// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//  CRTC (PD3301) ̃G~[V
// ---------------------------------------------------------------------------
//	$Id: CRTC.h,v 1.2 1999/01/11 15:32:07 cisc Exp $

#if !defined(AFX_CRTC_H__8E5D1438_291B_11D1_A283_A086A6A721AF__INCLUDED_)
#define AFX_CRTC_H__8E5D1438_291B_11D1_A283_A086A6A721AF__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "config.h"
#include "Device.h"

// ---------------------------------------------------------------------------

class PC88;

class CRTC : protected Device  
{
public:
	struct ScreenSetting
	{
		uint width;
		uint cursor_y;
		uint cursor_x;
		uint attrperline;
		uint linecharlimit;
		uint linesperchar;		
		uint height;
		bool widefont;
		bool color;
		bool inversed;
		bool skipline;
		bool controlcode;
		uint blinkrate;
		uint cursor_type;
//		uint hblank;
		uint vblank;
	};
	
	enum DrawStatus { off, on, erase };

private:
	uint8 Command(bool a0, uint8 data);

	ScreenSetting setting;

	PC88& pc;
	int cmdm, cmdc;
	uint cursormode;
	int tvramsize;
	bool shoulderase;
	bool paravalid;			// p[^͗LH
	uint8 status;
	bool line200;			// 15KHz [h


public:
	CRTC(PC88& _pc);
	~CRTC();

	uint8 In(uint p);
	void Out(uint p, uint d);
	void Reset(bool l200);

	bool IsOn() { return 0 != (status & 0x10); }
	DrawStatus GetSetting(ScreenSetting* s);
	void GetTVRAM(uint8* tvram);
};

#endif // !defined(AFX_CRTC_H__8E5D1438_291B_11D1_A283_A086A6A721AF__INCLUDED_)
