// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//  FDIF p PIO (8255) ̃G~[V
//	E8255 ̃[h 0 ̂݃G~[g
// ---------------------------------------------------------------------------
//	$Id: FDIF_PIO.cpp,v 1.2 1999/01/11 15:32:08 cisc Exp $

#include "FDIF_PIO.h"

// ---------------------------------------------------------------------------
//	|[gɏo
// ---------------------------------------------------------------------------

void FDIF_PIO::Out(uint adr, uint data)
{
	adr &= 3;
	if (adr != 3)
	{
		// Port A/B/C
		port[adr] = data;
	}
	else
	{
		// Control Word
		if (!(data & 0x80))
		{
			if (data & 0x01)
				port[2] |= 1 << ((data >> 1) & 7);
			else
				port[2] &= ~(1 << ((data >> 1) & 7));
		}
		else
		{
			readmask[0] = (data & 0x10 ? 0xff : 0x00);
			readmask[1] = (data & 0x02 ? 0xff : 0x00);
			readmask[2] = (data & 0x08 ? 0xf0 : 0x00)
			            | (data & 0x01 ? 0x0f : 0x00);
			port[0] = port[1] = port[2] = 0;
		}
	}
}

// ---------------------------------------------------------------------------
//	|[g
// ---------------------------------------------------------------------------

uint8 FDIF_PIO::In(uint adr)
{
	uint8 data;
	uint a = adr & 3;
	switch (a)
	{
	case 0:
		data = partner->Port(1);
		break;
	case 1:
		data = partner->Port(0);
		break;
	case 2:
		data = partner->Port(2);
		data = ((data << 4) & 0xf0) + ((data >> 4) & 0x0f);		// rotate 4 bits
		break;
	default:
	case 3:
		data = 0xff;
		break;
	}
	return (data & readmask[a]) | (port[a] & ~readmask[a]);
}
