// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//  FDU
// ---------------------------------------------------------------------------
//	$Id: FDU.h,v 1.2 1999/01/11 15:32:08 cisc Exp $

#ifndef FDU_H
#define FDU_H

#include "config.h"
#include "FDC.h"

class FileIO;

// ---------------------------------------------------------------------------
//	FDU
//	tbs[hCuG~[VNX
//
//	ReadSector(ID id, uint8* data);
//	ZN^ǂ
//
//	WriteSector(ID id, uint8* data);
//	 
class FDU
{
public:
	typedef FDC::ID ID;
	typedef FDC::Result Result;
	typedef FDC::WIDDESC WIDDESC;

public:
	enum Flags
	{
		MFM = 0x40, head = 0x01,
	};

	virtual ~FDU() {}

	virtual bool Mount(FileIO*) = 0;
	virtual bool Unmount() = 0;
	
	virtual Result ReadSector(uint8 flags, ID id, uint8* data) = 0;
	virtual Result WriteSector(uint8 flags, ID id, const uint8* data, bool deleted) = 0;
	virtual Result Seek(uint8 cyrinder) = 0;
	virtual uint8 SenceDeviceStatus() = 0;
	virtual Result ReadID(uint8 flags, ID* id) = 0;
	virtual Result WriteID(uint8 flags, WIDDESC wid) = 0;

	virtual Result ReadDiagnostic(uint8 flags, ID id, uint8* data, bool first);
};

#endif // FDU_H
