// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//  FDU ȈՃo[W
// ---------------------------------------------------------------------------
//	$Id: FDU0.cpp,v 1.2 1999/01/11 15:32:08 cisc Exp $

#define STRICT
#include <windows.h>

#include <stdio.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "WinCriticalSection.h"
#include "FDU0.h"

// ---------------------------------------------------------------------------
//	\zEj
// ---------------------------------------------------------------------------

FDU0::FDU0()
{
	file = 0;
	currentcyrinder = 0;
}

FDU0::~FDU0()
{
}

// ---------------------------------------------------------------------------
//	FDU0::Mount
//	C[WǂݍށihCuɃfBXNj
//
//	filename	fBXNC[W
// ---------------------------------------------------------------------------

bool FDU0::Mount(FileIO* fio)
{
	file = fio;
	file->Seek(0, FileIO::begin);

	char buf[16];
	if (16 != file->Read(buf, 16) || memcmp(buf, "M88 RawDiskImage", 16))
		return false;

	writeprotected = !!(file->GetFlags() & FileIO::readonly);
	return true;
}

bool FDU0::Unmount()
{
	file = 0;
	return true;
}

// ---------------------------------------------------------------------------
//	FDU0::Seek
//	w肳ꂽV_[ԍփV[N
//
//	cyrinder V[N
// ---------------------------------------------------------------------------

FDC::Result FDU0::Seek(uint8 cyrinder)
{
	if (cyrinder > 39)
		cyrinder = 39;
	
	currentcyrinder = cyrinder;
	return Result(0);
}

// ---------------------------------------------------------------------------
//	FDU0::ReadSector
//	ZN^ǂ
//
//	head	wbhԍ
//	id		ǂݍރZN^̃ZN^ ID
//	data	f[^̓]
// ---------------------------------------------------------------------------

FDC::Result FDU0::ReadSector(uint8 flags, ID id, uint8* data)
{
	head = flags & 1;	
	
	if (!file)
		return Result(FDC::ST0_AT | FDC::ST1_MA);
	
	if (id.c != currentcyrinder || id.h != head 
		|| (id.r-1) > 0xf || id.n != 1 || !(flags & 0x40))
		return Result(FDC::ST0_AT | FDC::ST1_ND);

	file->Seek((currentcyrinder * 2 + head) * 0x1000 + (id.r-1) * 0x100 + 16, FileIO::begin);
	if (0x100 == file->Read(data, 0x100))
		return Result(0);
	else
		return Result(FDC::ST0_AT | FDC::ST1_DE | FDC::ST2_DD);
}

// ---------------------------------------------------------------------------
//	FDU0::WriteSector
//	ZN^ɏ
//
//	head	wbhԍ
//	id		ރZN^̃ZN^ ID
//	data	f[^
// ---------------------------------------------------------------------------

FDC::Result FDU0::WriteSector(uint8 flags, ID id, const uint8* data, bool)
{
	head = flags & 1;
	
	if (!file)
		return Result(FDC::ST0_AT | FDC::ST1_MA);
	
	if (id.c != currentcyrinder || id.h != head 
		|| (id.r-1) > 0xf || id.n != 1 || !(flags & 0x40))
		return Result(FDC::ST0_AT | FDC::ST1_ND);

	file->Seek((currentcyrinder * 2 + head) * 0x1000 + (id.r-1) * 0x100 + 16, FileIO::begin);
	file->Write(data, 0x100);
	return Result(0);
}

// ---------------------------------------------------------------------------
//	FDU0::SenceDeviceStatus
//	foCXEX^[^X𓾂
// ---------------------------------------------------------------------------

uint8 FDU0::SenceDeviceStatus()
{
	return 0x20 | (file ? 8 : 0) | (writeprotected ? 0x40 : 0) | (currentcyrinder ? 0 : 0x10) | (head ? 4 : 0);
}

// ---------------------------------------------------------------------------
//	FDU0::ReadID
// ---------------------------------------------------------------------------

FDC::Result FDU0::ReadID(uint8 flags, ID* id)
{
	head = flags & 1;
	if (flags & 0x40)
	{
		id->c = currentcyrinder;
		id->h = head;
		id->r = ((idpos++) & 0x0f) + 1;
		id->n = 1;
		return Result(0);
	}
	else
	{
		return Result(FDC::ST0_AT | FDC::ST1_MA);
	}
}

// ---------------------------------------------------------------------------
//	FDU0::WriteID
// ---------------------------------------------------------------------------

FDC::Result FDU0::WriteID(uint8 flags, WIDDESC wid)
{
	return Result(FDC::ST0_AT | FDC::ST1_NW);
}
