// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//  P88SR tH[}bgɑΉ FDU
// ---------------------------------------------------------------------------
//	$Id: FDUB.h,v 1.2 1999/01/11 15:32:09 cisc Exp $

#ifndef FDUB_H
#define FDUB_H

#include "config.h"
#include "FDU.h"
#include "File.h"

// ---------------------------------------------------------------------------
//	FDUB
//	P88SR tH[}bgΉ FDU
//
class FDUB : public FDU
{
public:
	FDUB();
	~FDUB();

	bool Mount(FileIO* fio);
	bool Unmount();

	Result ReadSector(uint8 head, ID id, uint8* data);
	Result WriteSector(uint8 head, ID id, const uint8* data, bool deleted);
	Result Seek(uint8 cyrinder);
	Result ReadID(uint8 head, ID* id);
	Result WriteID(uint8 hd, WIDDESC wid);
	uint8 SenceDeviceStatus();

private:
	struct ImageHeader
	{
		char title[17];
		uint8 reserved[9];
		uint8 readonly;
		uint8 disktype;
		uint32 disksize;
		uint32 trackptr[164];
	};

	struct SectorHeader
	{
		ID id;
		uint16 sectors;
		uint8 density;
		uint8 deleted;
		uint8 status;
		uint8 reserved[5];
		uint16 length;
	};

private:
	bool SetHead(uint8 hd);
	bool Relocate(uint8** buf);
	int GetTrackSize();
	bool RemapTrack();
	
	FileIO* file;
	uint8 cyrinder;
	uint8 track;
	bool writeprotected;
	bool headermodified;
	int idleft;
	int sectorsize;
	SectorHeader sector;
	ImageHeader header;
};

#endif // FDU0_H
