// ---------------------------------------------------------------------------
//  M88 - PC88 emulator
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//	Config Dialog Box for M88
//	$Id: M88Config.h,v 1.3 1999/01/15 12:58:57 cisc Exp $

#ifndef M88Config_H
#define M88Config_H

#include "Config.h"
#include "InstanceThunk.h"
#include "PC88.h"

// ---------------------------------------------------------------------------

class Config
{
public:
	enum Flags
	{
		subcpucontrol	= 1 <<  0,	// Sub CPU ɋ쓮wȂx
		savedirectory	= 1 <<  1,	// NɑOĨfBNgɈړ
		fullspeed		= 1 <<  2,	// S
		enablepad		= 1 <<  3,	// pbhL
		enableopna		= 1 <<  4,	// OPNA [h (44h)
		watchregister	= 1 <<  5,	// WX^\
		askbeforereset	= 1 <<  6,	// IEZbgɊmF
		enablepcg		= 1 <<  7,	// PCG ñtHgL
		fv15k			= 1 <<  8,	// 15KHz j^[[h
		cpuburst        = 1 <<  9,	// m[EFCg
		suppressmenu	= 1 << 10,	// ALT  GRPH 
		cpuclockmode	= 1 << 11,	// NbNPʂŐ؂ւ
		usearrowfor10	= 1 << 12,	// L[eL[
//		ddonwin			= 1 << 13,	// (p~)
		swappadbuttons	= 1 << 14,	// pbh̃{^ւ
		disablesing		= 1 << 15,	// CMD SING 
		digitalpalette	= 1 << 16,	// fBW^pbg[h
		disablelfo		= 1 << 17,	// ()
		useqpc			= 1 << 18,	// QueryPerformanceCounter 
		force480		= 1 << 19,	// Sʂ 640x480 
		opnona8			= 1 << 20,	// OPN (a8h)
		opnaona8		= 1 << 21,	// OPNA (a8h)
		opna8intr		= 1 << 22,	// ()
		drawprioritylow	= 1 << 23,	// `̗Dx𗎂Ƃ
		disablef12reset = 1 << 24,  // F12  RESET ƂĎgpȂ(COPY L[ɂȂ)
	};

	int flags;
	int clock;
	int speed;
	int refreshtiming;
	int mainsubratio;
	int opnclock;
	int sound;
	int nerams;
	int keytype;
	int volfm, volssg, voladpcm, volrhythm;
	int volbd, volsd, voltop, volhh, voltom, volrim;
	int dipsw;
	uint soundbuffer;
	uint padsensibility;

	PC88::BASICMODE basicmode;

public:
	void LoadConfig(const char* ininame, bool applydefault);
	void SaveConfig(const char* ininame, bool writedefault);
	void LoadDefaultDirectory(const char* ininame);

private:
	bool LoadEntry(const char* inifile, const char* entry, int* value, int def, bool applydefault);
	bool SaveEntry(const char* inifile, const char* entry, int value, bool applydefault);
	bool SaveEntry(const char* inifile, const char* entry, const char* value, bool applydefault);
};

#endif
