// ---------------------------------------------------------------------------
//  M88 - PC88 emulator
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//	Config Dialog Box for M88
//	$Id: M88Config2.h,v 1.2 1999/01/11 15:32:11 cisc Exp $

#if !defined(AFX_M88CONFIG2_H__F4D3758B_4ABE_11D2_BDC3_00A0C90AC9DA__INCLUDED_)
#define AFX_M88CONFIG2_H__F4D3758B_4ABE_11D2_BDC3_00A0C90AC9DA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Config.h"
#include "InstanceThunk.h"
#include "M88Config.h"

// ---------------------------------------------------------------------------

class M88Config2
{
public:
	M88Config2();
	virtual ~M88Config2();
	
	bool Show(HINSTANCE, HWND, Config* config);

private:
	enum Index { cpu=0, screen, sound, soundvol, switches, function, term };

	void FillInPropPage(PROPSHEETPAGE* psp, int iddlg, void* dlgproc);
	
	int PropProc(HWND, UINT, LPARAM);
	static int _cdecl PropProcGate(M88Config2*, HWND, UINT, LPARAM);

	// CPUPage
	BOOL CPUPage(HWND, UINT, WPARAM, LPARAM);
	BOOL CPUPageCommand(HWND hdlg, HWND hwctl, UINT nc, UINT id);
	void CPUPageUpdate(HWND hdlg);
	void CPUPageUpdateSlider(HWND hdlg);
	static BOOL _cdecl CPUPageGate(M88Config2*, HWND, UINT, WPARAM, LPARAM);

	// ScreenPage
	BOOL ScreenPage(HWND, UINT, WPARAM, LPARAM);
	BOOL ScreenPageCommand(HWND hdlg, HWND hwctl, UINT nc, UINT id);
	void ScreenPageUpdate(HWND hdlg);
	static BOOL _cdecl ScreenPageGate(M88Config2*, HWND, UINT, WPARAM, LPARAM);

	// FunctionPage
	BOOL FunctionPage(HWND, UINT, WPARAM, LPARAM);
	BOOL FunctionPageCommand(HWND hdlg, HWND hwctl, UINT nc, UINT id);
	void FunctionPageUpdate(HWND hdlg);
	static BOOL _cdecl FunctionPageGate(M88Config2*, HWND, UINT, WPARAM, LPARAM);

	// SoundPage
	BOOL SoundPage(HWND, UINT, WPARAM, LPARAM);
	BOOL SoundPageCommand(HWND hdlg, HWND hwctl, UINT nc, UINT id);
	void SoundPageUpdate(HWND hdlg);
	static BOOL _cdecl SoundPageGate(M88Config2*, HWND, UINT, WPARAM, LPARAM);

	// SoundVolumePage
	BOOL SoundVolumePage(HWND, UINT, WPARAM, LPARAM);
	BOOL SoundVolumePageCommand(HWND hdlg, HWND hwctl, UINT nc, UINT id);
	void SoundVolumePageUpdateSlider(HWND hdlg);
	static BOOL _cdecl SoundVolumePageGate(M88Config2*, HWND, UINT, WPARAM, LPARAM);
	void InitVolumeSlider(HWND hdlg, UINT id, int val);
	void SoundSetVolumeText(HWND hdlg, int id, int val);

	// SwitchPage
	BOOL SwitchPage(HWND, UINT, WPARAM, LPARAM);
	BOOL SwitchPageCommand(HWND hdlg, HWND hwctl, UINT nc, UINT id);
	void SwitchPageUpdate(HWND hdlg);
	static BOOL _cdecl SwitchPageGate(M88Config2*, HWND, UINT, WPARAM, LPARAM);

	// thunks
	InstanceThunk propproc;
	InstanceThunk cpupage;
	InstanceThunk screenpage;
	InstanceThunk functionpage;
	InstanceThunk soundpage;
	InstanceThunk soundvolpage;
	InstanceThunk switchpage;

	//
	HWND hwndparent;
	HWND hwndps;
	HINSTANCE hinst;
	Config config;
	Config orgconfig;
	int page;
};

#endif // !defined(AFX_M88CONFIG2_H__F4D3758B_4ABE_11D2_BDC3_00A0C90AC9DA__INCLUDED_)
