// ---------------------------------------------------------------------------
//  M88 - PC88 emulator
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//	ROM ̓ǂ݂
//	$Id: PC88ROM.cpp,v 1.2 1999/01/11 15:32:12 cisc Exp $

#include "PC88.h"
#include "File.h"

// ---------------------------------------------------------------------------
//	Ej
// ---------------------------------------------------------------------------

PC88::ROM::ROM()
{
	rom = 0;
}

PC88::ROM::~ROM() 
{
	delete[] rom;
}

// ---------------------------------------------------------------------------
//	qnl̓ǂݏo
// ---------------------------------------------------------------------------

bool PC88::ROM::LoadROM()
{
	const int romsize = 0x8000 + 0x8000 + 0x8000 + 0x2000 + 0x40000 + 0x800;

	rom = new uint8[romsize];
	if (!rom)
		return false;
	
	memset(rom, 0xff, romsize);

	n88    = rom;
	n80    = rom + 0x8000;
	e0     = rom + 0x10000;
	e1     = rom + 0x12000;
	e2     = rom + 0x14000;
	e3     = rom + 0x16000;
	disk   = rom + 0x18000;
	kanji  = rom + 0x1a000;
	kanji2 = rom + 0x3a000;
	font   = rom + 0x5a000;

	if (!LoadPC88ROM())
	{
		LoadROMImage(n88, "n88.rom", 0x8000);
		LoadROMImage(n80, "n80.rom", 0x8000);
		LoadROMImage(e0,  "n88_0.rom", 0x2000);
		LoadROMImage(e1,  "n88_1.rom", 0x2000);
		LoadROMImage(e2,  "n88_2.rom", 0x2000);
		LoadROMImage(e3,  "n88_3.rom", 0x2000);
		LoadROMImage(disk, "disk.rom", 0x2000);	// 2D @ 2KB
	}
	LoadROMImage(kanji,  "kanji1.rom", 0x20000);
	LoadROMImage(kanji2, "kanji2.rom", 0x20000);
	if (!LoadROMImage(font, "font.rom", 0x800))
		memcpy(font, kanji+0x1000, 0x800);
	
	return true;
}

// ---------------------------------------------------------------------------
//	ROM t@C̓ǂݏo
// ---------------------------------------------------------------------------

int PC88::ROM::LoadROMImage(uint8* dest, char* filename, int32 size)
{
	FileIO file;
	if (!file.Open(filename, FileIO::readonly))
		return 0;

	file.Read(dest, size);
	file.Close();
	return 1;
}

// ---------------------------------------------------------------------------
//	PC88.ROM ǂݏo
// ---------------------------------------------------------------------------

bool PC88::ROM::LoadPC88ROM()
{
	FileIO file("PC88.ROM", FileIO::readonly);

	if (!(file.GetFlags() & FileIO::open))
		return false;

	file.Read(n88         , 0x8000);
	file.Read(n80 + 0x6000, 0x2000);
	file.Read(n88 + 0x6000, 0x2000);
	file.Read(e0          , 0x2000);
	file.Read(e1          , 0x2000);
	file.Read(e2          , 0x2000);
	file.Read(e3          , 0x2000);
	file.Read(disk        , 0x2000);
	file.Read(n80         , 0x6000);
	return true;
}
