// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1997, 1998
// ---------------------------------------------------------------------------
//  ʐƃOtBbNX̃G~[V
// ---------------------------------------------------------------------------
//	$Id: Screen.h,v 1.2 1999/01/11 15:32:13 cisc Exp $

#if !defined(AFX_SCREEN_H__0A64EF33_2C27_11D1_A292_83918CE43BA5__INCLUDED_)
#define AFX_SCREEN_H__0A64EF33_2C27_11D1_A292_83918CE43BA5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "config.h"
#include "Device.h"
#include "CRTC.h"

// ---------------------------------------------------------------------------
//	BITMAP BIT zu		-- TE TG TR TB GG GR GB
//	ATTR BIT zu		G  R  B  CG UL OL SE RE
// ---------------------------------------------------------------------------

#define TEXT_SET	(0x80)
#define TEXT_RES	(0x40)
#define TEXT_BIT	(0xc0)
#define COLOR_BIT	(0x38)
#define GVRAM0_SET	(0x01)
#define GVRAM1_SET	(0x02)
#define GVRAM2_SET	(0x04)
#define GVRAM_BIT	(0x07)

#define TEXT_SETP	PACK(TEXT_SET)
#define TEXT_RESP	PACK(TEXT_RES)
#define TEXT_BITP	PACK(TEXT_BIT)
#define COLOR_BITP	PACK(COLOR_BIT)

#define TEXT_MASKP	(~(TEXT_BITP | COLOR_BITP))
#define ATTR_TO_COLORP(a) ((PACK(a) >> 2) & COLOR_BITP)


// ---------------------------------------------------------------------------
//	88 ̉ʂɊւ铮zNX
// ---------------------------------------------------------------------------

class Screen : public Memory
{
	typedef uint8 (Screen::*Reader)(uint);
	typedef void  (Screen::*Writer)(uint, uint);
		
	union quadbyte
	{
		uint8 byte[4];
		uint32 pack;
	};

public:
	void SetRedrawFlag() { shouldredraw = true; }
	void UpdateScreen(uint8* image, int bpl, int* region);
	void Reset();
	void Snap() {}

	uint In5c();
	void Out30(uint data);
	void Out31(uint data);
	void Out32(uint data);
	void Out34(uint data);
	void Out35(uint data);
	void Out52(uint data);
	void Out53(uint data);
	void Out54(uint data);
	void Out55to5b(uint port, uint data);
	void Out5cto5f(uint port);
	
	bool IsGVRAMSelected() { return writer != &Screen::Writedummy; }

	Screen();
	virtual ~Screen();
	
	void Write(uint addr, uint data) { (this->*writer)(addr, data); }
	uint8 Read(uint addr) { return (this->*reader)(addr); }
	
private:

	// I/F n ----------------------------------------------------------------
	uint8 Readdummy(uint);
	void Writedummy(uint, uint);
	uint8 ReadPlane0(uint addr);
	uint8 ReadPlane1(uint addr);
	uint8 ReadPlane2(uint addr);
	void WritePlane0(uint addr, uint data);
	void WritePlane1(uint addr, uint data);
	void WritePlane2(uint addr, uint data);
	void SelectAccessFunc();
	
	// `n ----------------------------------------------------------------
	void CreateTable();
	void Redraw(uint8* redraw, int bpl);
	static packed ExpandTable[256];
	static packed ByteExpandTable[1 << sizeof(packed)];
	void SetDirtyFlag(uint addr);
	void UpdateScreen200(uint8* image, int bpl, int* region);
	void UpdateScreen400(uint8* image, int bpl, int* region);
	
	// ALU n ----------------------------------------------------------------
	void WriteALUSet(uint addr, uint data);
	void WriteALURGB(uint addr, uint data);
	void WriteALUR(uint addr, uint data);
	void WriteALUB(uint addr, uint data);
	uint8 ReadALU(uint addr);
	
	// pbgn ------------------------------------------------------------
	void InitPalette();
	virtual void SetPalette(int num, uint8 red, uint8 green, uint8 blue) = 0;
	
	// ϐ ------------------------------------------------------------------

	quadbyte gvram[16384];
	volatile bool dirtyline[1024];

	Reader reader;								// 00
	Writer writer;
#ifdef Z80_X86_NATIVE
	void* readerdirect;
	void* writerdirect;
#endif
	
//	quadbyte* gvram;
	quadbyte alureg;
	quadbyte maskr, maski, masks, aluread;

	uint8 red[8];
	uint8 blue[8];
	uint8 green[8];
	uint selectedplane;
	
	uint8 port30;
	uint8 port31;
	uint8 port32;
	uint8 port35;
	bool shouldredraw;
	
	uint8 bgblue, bgred, bggreen;				// 0
	uint8 displaygraphics;
	bool displaytext;
	bool color;
	bool line400;	
	uint8 displayplane;

protected:
	void Init();
	bool reinitpalette;

	friend class CRTC;

	// for debug
public:
	const char* GMode() { return gmode; }
private:
	const char* gmode;
};


#endif // !defined(AFX_SCREEN_H__0A64EF33_2C27_11D1_A292_83918CE43BA5__INCLUDED_)
