// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator
//	Copyright (C) cisc 1997, 1998.
// ---------------------------------------------------------------------------
//	OPN(PSG) Implementation for Win32
// ---------------------------------------------------------------------------
//	$Id: Sound.h,v 1.3 1999/01/11 15:32:13 cisc Exp $

#ifndef SOUND_H
#define SOUND_H

#include "Device.h"
#include "OPNA.h"
#include "PSGB.h"

// ---------------------------------------------------------------------------

#define SOUND_55K	55555	// Special

class PC88;

class OPN88 : public FM::OPNA
{
public:
	OPN88() { pc = 0, opna = true; }
	void Reset() { OPNA::Reset(); intrpending = false; }
	void SetPC(PC88* pc88) { pc = pc88; }
	void SetReg(uint a, uint d);
	void SetMode(bool _opna) { opna = _opna; }
	void EnableIntr(bool flag);
	bool IsOPNA() { return opna; }

private:
	void Intr(bool);
	PC88* pc;
	bool opna;
	bool intrenabled;
	bool intrpending;
};

// ---------------------------------------------------------------------------

class Sound88 : public Device
{
public:
	Sound88();
	~Sound88();
	
	bool Init(uint rate, uint32 clock, int bufsize, PC88* pc);
	void Cleanup();	
	
	bool SetRate(uint rate, uint32 clock, int bufsize);
	
	void Reset();
	void Out(uint port, uint data);
	uint8 In(uint port);
	void Out40(uint8 data, uint tick);
	void UpdateBeepState(uint);
	void Fill(void* dest, int bytes);

	void Count(int32 us, bool timer);
	int32 GetNextCount();

protected:
	void EnableSING(bool enable);
	void EnableOPN2(bool enable);
	int bwpos;
	int uscount;
	uint samplingrate;		// TvO[g
	uint srate50;			// samplingrate / 50

private:
	void SetClock(uint fmclk, uint psgclk);
	virtual uint8 PortIn(uint addr);
	void Store(int);
	void Mix(void* dest, int bytes);

	int32* mixingbuf;
	uint8* buffer;
	uint8* adpcmbuf;
	int buffersize;
	int32 mixingcount;
	int read;
	int write;
	
	uint32 clock;

	uint8 regadr1_0, regadr1_1;
	uint8 regadr2_0, regadr2_1;
	bool enabled;
	bool opn2enabled;


	// BEEP ֌W
	uint8 port40;
	uint8 beepmask;
	uint pswitches;
	uint bswitches;
	uint bvalue;
	uint32 pcount[8], pindex, plasttick, pstep;
	uint32 bcount[8], bindex, blasttick, bstep;
	
protected:
	PSGB psgb, psg2;
	OPN88 opn, opn2;
};

#endif //SOUND_H
