// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//  TuVXẽG~[V
// ---------------------------------------------------------------------------
//	$Id: Subsys.h,v 1.2 1999/01/11 15:32:14 cisc Exp $

#if !defined(AFX_SUBSYS_H__817C1901_DE87_11D1_99C7_0000E80C322E__INCLUDED_)
#define AFX_SUBSYS_H__817C1901_DE87_11D1_99C7_0000E80C322E__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "PC88.h"
#include "FDIF_PIO.h"
#include "misc.h"
//#include "FDC.h"
//#include "FDU0.h"

// ---------------------------------------------------------------------------

#ifndef Z80_TEST
	typedef Z80 Z80S;
#else
	typedef Z80R Z80S;
#endif

class FDC;

class SubSystem : public Z80S, public Device
{
public:
	SubSystem(uint8* _rom, FDC* _fdc);
	virtual ~SubSystem();

	// CVXẽC^[tF[X
	uint8 In(uint port);
	void Out(uint port, uint data);
	void Reset();

	// FDC ̊荞
	void Intr();
	void IntrReset();

	bool IsIdle(bool control);
	int IdleCount() { return 50-Min(50, idlecount); }
	uint GetPC() { return reg.pc; }

private:
	bool Initialize();

	// CPU ̃C^[tF[X
	uint8 Read(uint addr);
	void Write(uint addr, uint data);
	uint8 InPort(uint port);
	void OutPort(uint port, uint data);
	void AcceptInterrupt(uint intno);

private:
	void PatchROM();
	FDIF_PIO piomain;
	FDIF_PIO piosub;
	FDC* fdc;
	uint8* rom;
	uint8* ram;
	int idlecount;
};

// ---------------------------------------------------------------------------
//	荞ݏ
// ---------------------------------------------------------------------------

inline void SubSystem::Intr()
{
	RequestInterrupt(8);
}

inline void SubSystem::IntrReset()
{
	CancelInterrupt(8);
}

// ---------------------------------------------------------------------------
//	SubSystem::IsIdle
// ---------------------------------------------------------------------------

inline bool SubSystem::IsIdle(bool control)
{
	if (idlecount >= 50)
	{
		idlecount = 50;
		if (control)
		{
			reg.haltstate |= 2;
			return true;
		}
		reg.haltstate &= ~2;
	}
	return false;
}

#endif // !defined(AFX_SUBSYS_H__817C1901_DE87_11D1_99C7_0000E80C322E__INCLUDED_)
