// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//  eLXgʐ
// ---------------------------------------------------------------------------
//	$Id: Text.h,v 1.2 1999/01/11 15:32:14 cisc Exp $

#if !defined(TEXT_H)
#define TEXT_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "config.h"
#include "Device.h"
#include "CRTC.h"

// ---------------------------------------------------------------------------

class TextScreen : public Device
{
public:
	TextScreen(CRTC& _crtc, const uint8* textfont);
	~TextScreen();
	
	uint8 In(uint) { return 0; }
	void Out(uint, uint);
	void Reset();

	void Snap();
	void UpdateScreen(uint8* image, uint _bpl, uint nlines, ulong clock, int* region, bool refresh);
	
	void PutInfo(uint8* image, int bpl, char* infotxt);
	void EnablePCG(bool);

private:
	void ExpandImage(uint8* image, uint nlines, int* region);
	void ExpandAttributes(uint8* dest, const uint8* src, uint y);
	void ChangeAttr(uint8 code);
	void CreateFont();
	void ModifyFont(uint off, uint d);
	void CreateGFont();
	
	const uint8* GetFont (uint c, bool graphic);
	const uint8* GetFontW(uint c, bool graphic);
	
	void PutChar         (packed* dest, uint8 src, uint8 attr);
	void PutCharW        (packed* dest, uint8 src, uint8 attr);
	void PutNormal       (packed* dest, const packed* src);
	void PutNormalW      (packed* dest, const packed* src);
	void PutReversed     (packed* dest, const packed* src);
	void PutReversedW    (packed* dest, const packed* src);
	void PutLineNormal   (packed* dest, uint8 attr);
	void PutLineReversed (packed* dest, uint8 attr);
	void PutLineNormalW  (packed* dest, uint8 attr);
	void PutLineReversedW(packed* dest, uint8 attr);
	void ClearText       (packed* dest, uint nlines);
	void PutInfoChar     (packed* dest, uint ch, packed color);


	packed colorp;
	uint8* font;
	const uint8* orgfont;
	uint underlineptr;
	uint8* vram[2];
	uint8* attrcache;
	uint bank;
	uint bpl;
	CRTC::ScreenSetting setting;
	uint8 blinkstate;
	uint8 attr;				
	uint8 cursor_attr;
	uint8 blink;
	CRTC::DrawStatus state;

	uint8* pcgram;
	uint pcgadr;
	uint pcgdat;
	bool fontmodified;
	bool pcgenable;

	CRTC& crtc;

	const static uint8 order[8];
};

#endif
