// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1997, 1998.
// ---------------------------------------------------------------------------
//	PC88 Hardware Emulation for Win32
// ---------------------------------------------------------------------------
//	$Id: Win88.h,v 1.2 1999/01/11 15:32:15 cisc Exp $

#if !defined(AFX_WIN88_H__E9AF8F93_2E4F_11D1_A29B_C8FAF3CDE7A6__INCLUDED_)
#define AFX_WIN88_H__E9AF8F93_2E4F_11D1_A29B_C8FAF3CDE7A6__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "PC88.h"
#include "Calender.h"
#include "WinCriticalSection.h"
#include "M88Config.h"

class WinScreen;
class WinSound;
class WinFDC;
class WinKeyIF;

// ---------------------------------------------------------------------------

class Win88 : public PC88  
{
public:
	Win88(ROM* _rom, WinScreen* _screen, WinKeyIF* keyb, WinSound* s);
	~Win88();
	bool Initalize(int nerams); 

	void Reset();
	void Wait(bool);
	
	int GetICount();
	void StartMonitor();
	void StopMonitor();
	
	void UpdateScreen(uint8* image, int bpl, ulong clock, int* region, bool info, bool refresh);

	// fBXN̐
	int Mount(uint drive, const char* filename, bool readonly);
	bool Unmount(uint drive);
	bool IsMount(uint drive);
	char* GetDiskTitle(uint drive, uint id);
	bool SetDisk(uint drive, uint id);

	// configure
	void ApplyConfig(const Config* newconfig);

private:
	uint32 GetTime();
	int32 Execute(int32 cpuclock, int32 us);
	uint ThreadMain();
	static uint __stdcall ThreadEntry(LPVOID arg);
	void AcceptInterrupt(uint intno);
	void SetTimeMode(bool useqpc);
	
	CriticalSection cs_cpu;
	Calender calender;
	WinSound* sound;
	WinScreen* winscreen;
	WinKeyIF* winkeyb;
	WinFDC* winfdc;

	HANDLE hthread;
	uint idthread;
	
	LONG icount;
	int refreshcount;
	int vsynccount;
	int timercount;
	int refreshtiming;			// t[ɉʍXVH
	int vsynctime1;				// VRTC Ԃ̒
	int vsynctime2;				// !VRTC Ԃ̒
	uint32 precision;
	Config config;
	
	bool updatescreen;
	bool rtc;
	
	bool haltidlecpu;
	
	volatile bool shouldterminate;
	volatile bool halt;
};


#endif // !defined(AFX_WIN88_H__E9AF8F93_2E4F_11D1_A29B_C8FAF3CDE7A6__INCLUDED_)
