// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//	CriticalSection Class for Win32
// ---------------------------------------------------------------------------
//	$Id: WinCriticalSection.h,v 1.2 1999/01/11 15:32:15 cisc Exp $

#ifndef WinCriticalSection_h
#define WinCriticalSection_h

#ifndef _INC_WINDOWS
#define STRICT
#include <windows.h>
#endif

class CriticalSection
{
	CRITICAL_SECTION css;
public:
	class Lock
	{
		CRITICAL_SECTION* css;
	public:
		Lock(CriticalSection& cs) : css(&cs.css) { EnterCriticalSection(css); }
		~Lock() { LeaveCriticalSection(css); }
	};
	friend class Lock;

	CriticalSection() { InitializeCriticalSection(&css); }
	~CriticalSection() { DeleteCriticalSection(&css); }
};

#endif
