// ---------------------------------------------------------------------------
//  M88 - PC88 emulator
//  Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//	DirectDraw ɂSʕ`
// ---------------------------------------------------------------------------
//	$Id: WinDrawDDS.h,v 1.2 1999/01/11 15:32:15 cisc Exp $

#if !defined(AFX_WINDRAWDDS_H__6FFD5F30_49D3_11D2_BDBD_00A0C90AC9DA__INCLUDED_)
#define AFX_WINDRAWDDS_H__6FFD5F30_49D3_11D2_BDBD_00A0C90AC9DA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "WinDraw.h"

class WinDrawDDS : public WinDraw  
{
public:
	WinDrawDDS(bool force480 = false);
	~WinDrawDDS();

	bool Init(HWND hwnd);
	bool Cleanup();
	void SetPalette(PALETTEENTRY* pal);
	void QueryNewPalette();
	void UpdateScreen(int top, int bottom, bool refresh);
	bool Lock(uint8** pimage, int* pbpl);
	bool Unlock();
	void SetGUIMode(bool guimode);

private:
	bool guimode;
	void FillBlankArea();
	bool RestoreSurface();
	bool SetScreenMode();
	bool CreateDDPalette();
	bool CreateDD2();
	bool CreateDDS();

	static HRESULT WINAPI EDMCallBack(LPDDSURFACEDESC, LPVOID);

	HWND hwnd;

	LPDIRECTDRAW2 ddraw;
	LPDIRECTDRAWPALETTE ddpal;
	LPDIRECTDRAWSURFACE ddsscrn;
	LPDIRECTDRAWCLIPPER ddcscrn;
	LPDIRECTDRAWSURFACE ddswork;
	
	uint8* image;
	int bpl;
	int lines;		// 400 or 480
	bool palchanged;
	
	PALETTEENTRY palentry[256];
};


#endif // !defined(AFX_WINDRAWDDS_H__6FFD5F30_49D3_11D2_BDBD_00A0C90AC9DA__INCLUDED_)
