// ---------------------------------------------------------------------------
//  M88 - PC88 emulator
//  Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//	DirectDraw ɂEChEʕ`
//	قƂ 8bpp p݂Ȃł(T-T
// ---------------------------------------------------------------------------
//	$Id: WinDrawDDW.cpp,v 1.2 1999/01/11 15:32:15 cisc Exp $

#define STRICT
#define WIN32_LEAN_AND_MEAN
#define INITGUID
#include <windows.h>
#include <ddraw.h>
#include "misc.h"
#include "WinDrawDDW.h"

#define RELCOM(x)  if (x) x->Release(), x=0; else 0

uint32 WinDrawDDW::ConvertTable[256];

// ---------------------------------------------------------------------------
//	\z/
// ---------------------------------------------------------------------------

WinDrawDDW::WinDrawDDW()
{
	ddraw = 0;
	ddsscrn = 0;
	ddcscrn = 0;
	ddpal = 0;
	ddswork = 0;
	scrnhaspal = false;
	palchanged = false;
	image = 0;
	bpl = 0;
}

WinDrawDDW::~WinDrawDDW()
{
	Cleanup();
}

// ---------------------------------------------------------------------------
//	
// ---------------------------------------------------------------------------

bool WinDrawDDW::Init(HWND hwindow)
{
	hwnd = hwindow;

	image = new uint8[640*400];
	bpl = 640;
	if (!image)
		return false;
	memset(image, 0x40, 640*400);

	if (!CreateDD2())
		return false;

	if (DD_OK != ddraw->SetCooperativeLevel(hwnd, DDSCL_NORMAL))
		return false;

	if (!CreateDDS())
		return false;

	CreateDDPalette();
	return true;
}

// ---------------------------------------------------------------------------
//	Cleanup
// ---------------------------------------------------------------------------

bool WinDrawDDW::Cleanup()
{
	RELCOM(ddpal);
	RELCOM(ddcscrn);
	RELCOM(ddswork);
	RELCOM(ddsscrn);
	RELCOM(ddraw);
	delete[] image; image = 0;
	return true;
}

// ---------------------------------------------------------------------------
//	DirectDraw2 
// ---------------------------------------------------------------------------

bool WinDrawDDW::CreateDD2()
{
	LPDIRECTDRAW ddraw1;
	if (DD_OK != DirectDrawCreate(0, &ddraw1, 0))
		return false;
	if (S_OK != ddraw1->QueryInterface(IID_IDirectDraw2, (void**)&ddraw))
		return false;
	return true;
}

// ---------------------------------------------------------------------------
//	Surface 
// ---------------------------------------------------------------------------

bool WinDrawDDW::CreateDDS()
{
	// \T[tFX쐬
	DDSURFACEDESC ddsd;
	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_CAPS;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;

	if (DD_OK != ddraw->CreateSurface(&ddsd, &ddsscrn, 0))
		return false;

	// Nbp[
	if (DD_OK != ddraw->CreateClipper(0, &ddcscrn, 0))
		return false;

	ddcscrn->SetHWnd(0, hwnd);
	ddsscrn->SetClipper(ddcscrn);

	// \T[tFX̐FtH[}bg𓾂
	DDPIXELFORMAT ddpf;
	memset(&ddpf, 0, sizeof(ddpf));
	ddpf.dwSize = sizeof(DDPIXELFORMAT);
	if (DD_OK != ddsscrn->GetPixelFormat(&ddpf))
		return false;
	if (!(ddpf.dwFlags & DDPF_RGB))
		return false;
	scrnhaspal = !!(ddpf.dwFlags & DDPF_PALETTEINDEXED8);

	// ƗpT[tFX쐬
	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT | DDSD_CAPS;
	ddsd.dwWidth = 640;
	ddsd.dwHeight = 400;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
//	ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
//	ddsd.ddpfPixelFormat.dwFlags = DDPF_PALETTEINDEXED8 | DDPF_RGB;
//	ddsd.ddpfPixelFormat.dwRGBBitCount = ddpf.dwRGBBitCount;
//	ddsd.ddpfPixelFormat.dwRBitMask = ddpf.dwRBitMask;
//	ddsd.ddpfPixelFormat.dwGBitMask = ddpf.dwGBitMask;
//	ddsd.ddpfPixelFormat.dwBBitMask = ddpf.dwBBitMask;
	
	if (DD_OK != ddraw->CreateSurface(&ddsd, &ddswork, 0))
		return false;

	// Fϊ[`ݒ
	switch (ddpf.dwRGBBitCount)
	{
	case 8:
	default:
		convert = Convert8bpp;
		return true;

	case 16:	
		convert = Convert16bpp;
		break;

	case 24:
		convert = Convert24bpp;
		break;
		
	case 32:
		convert = Convert32bpp;
		break;
	}

	// Fϊ̂߂̐Fzu擾
	redmask = ddpf.dwRBitMask;
	bluemask = ddpf.dwBBitMask;
	greenmask = ddpf.dwGBitMask;

	for (redshift = 0; !((ddpf.dwRBitMask | 1) & (0x80000000 >> redshift)); redshift++);
	for (blueshift = 0; !((ddpf.dwBBitMask | 1) & (0x80000000 >> blueshift)); blueshift++);
	for (greenshift = 0; !((ddpf.dwGBitMask | 1) & (0x80000000 >> greenshift)); greenshift++);
	return true;
}

// ---------------------------------------------------------------------------
//	pbg
// ---------------------------------------------------------------------------

bool WinDrawDDW::CreateDDPalette()
{
	int i;
	const int nsyscol = 10;
	for (i=0; i<nsyscol; i++)
	{
		palentry[i].peRed = i;
		palentry[i].peGreen = 0;
		palentry[i].peBlue = 0;
		palentry[i].peFlags = PC_EXPLICIT;
		palentry[255-i].peRed = 255-i;
		palentry[255-i].peGreen = 0;
		palentry[255-i].peBlue = 0;
		palentry[255-i].peFlags = PC_EXPLICIT;
	}
	for (i=nsyscol; i<0x40; i++)
	{
		palentry[i].peRed = 0;
		palentry[i].peGreen = 0;
		palentry[i].peBlue = 0;
		palentry[i].peFlags = PC_NOCOLLAPSE;
//		palentry[255-i].peRed = 0;
//		palentry[255-i].peGreen = 0;
//		palentry[255-i].peBlue = 0;
//		palentry[255-i].peFlags = PC_NOCOLLAPSE;
	}
	for (i=0x40; i<0xc0; i++)
	{
		palentry[i].peFlags = PC_RESERVED | PC_NOCOLLAPSE;
	}
	if (scrnhaspal)
	{
		if (DD_OK == ddraw->CreatePalette(DDPCAPS_8BIT, palentry, &ddpal, 0))
		{
			ddsscrn->SetPalette(ddpal);
		}
	}
	return true;
}

// ---------------------------------------------------------------------------
//	`
// ---------------------------------------------------------------------------

void WinDrawDDW::UpdateScreen(int top, int bottom, bool refresh)
{
	RECT rect;
	rect.left = 0;
	rect.top = top;
	rect.right = 640;
	rect.bottom = bottom+1;

	if (palchanged)
	{
		palchanged = false;
		
		if (scrnhaspal)
		{
			ddpal->SetEntries(0, 64, 128, &palentry[64]);
		}
		else
		{
			rect.top = 0, rect.bottom = 400;
			MakeColorTable();
		}
	}

	// Ɨ̈XV
	if (rect.top <= rect.bottom)
	{
		if (DDERR_SURFACELOST == ddswork->IsLost())
		{
			if (!RestoreSurface())
				return;
			rect.top = 1, rect.bottom = 0;
		}
		else
		{
			DDSURFACEDESC ddsd;
			memset(&ddsd, 0, sizeof(ddsd));
			ddsd.dwSize = sizeof(ddsd);
			if (DD_OK != ddswork->Lock(&rect, &ddsd, 0, 0))
				return;
			
			(*convert)(ddsd.lpSurface, image, &rect, ddsd.lPitch);
			
			ddswork->Unlock(0);
		}
	}

	if (refresh)
	{
		refresh = false;
		rect.top = 0, rect.bottom = 400;
	}

	if (rect.top <= rect.bottom)
	{
		RECT rectdest;
		POINT srcpoint;
		srcpoint.x = 0, srcpoint.y = 0;
		ClientToScreen(hwnd, &srcpoint);
		rectdest.left = srcpoint.x + rect.left;
		rectdest.right = srcpoint.x + rect.right;
		rectdest.top = srcpoint.y + rect.top;
		rectdest.bottom = srcpoint.y + rect.bottom;
		
		if (DDERR_SURFACELOST == ddsscrn->Blt(&rectdest, ddswork, &rect, 0, 0))
		{
			RestoreSurface();
		}
	}
}

// ---------------------------------------------------------------------------
//	WM_QUERYNEWPALETTE
// ---------------------------------------------------------------------------

void WinDrawDDW::QueryNewPalette()
{
	if (scrnhaspal)
	{
		ddsscrn->SetPalette(ddpal);
	}
}

// ---------------------------------------------------------------------------
//	pbgݒ
// ---------------------------------------------------------------------------

void WinDrawDDW::SetPalette(PALETTEENTRY* pe)
{
	for (int i=0; i<0x80; i++)
	{
		palentry[i+0x40].peRed = pe[i].peRed;
		palentry[i+0x40].peBlue = pe[i].peBlue;
		palentry[i+0x40].peGreen = pe[i].peGreen;
	}
	palchanged = true;
}

// ---------------------------------------------------------------------------
//	8bpp -> ƃobt@
// ---------------------------------------------------------------------------

void WinDrawDDW::Convert8bpp(void* surface, const uint8* image, RECT* rect, int pitch)
{
	const uint8* src = image + rect->top * 640;
	uint8* dest = (uint8*) surface;

	for (int y=rect->top; y<=rect->bottom; y++)
	{
		memcpy(dest, src, rect->right-rect->left);
		src += 640;
		dest += pitch;
	}
}

// ---------------------------------------------------------------------------
//	8bpp -> ƃobt@(16bpp)
// ---------------------------------------------------------------------------

void WinDrawDDW::Convert16bpp(void* surface, const uint8* image, RECT* rect, int pitch)
{
	const uint8* src = image + rect->top * 640;
	uint8* dest = (uint8*) surface;
	int width = (rect->right-rect->left) / 8;

	for (int y=rect->top; y<=rect->bottom; y++)
	{
		const uint8* s = src;
		uint32* d = (uint32*) dest;
		for (int x=0; x<width; x++)
		{
			d[0] = ConvertTable[s[0]] + (ConvertTable[s[1]] << 16);
			d[1] = ConvertTable[s[2]] + (ConvertTable[s[3]] << 16);
			d[2] = ConvertTable[s[4]] + (ConvertTable[s[5]] << 16);
			d[3] = ConvertTable[s[6]] + (ConvertTable[s[7]] << 16);
			d+=4; s+=8;
		}
		src += 640;
		dest += pitch;
	}
}

// ---------------------------------------------------------------------------
//	8bpp -> ƃobt@(24bpp)
// ---------------------------------------------------------------------------

void WinDrawDDW::Convert24bpp(void* surface, const uint8* image, RECT* rect, int pitch)
{
	const uint8* src = image + rect->top * 640;
	uint8* dest = (uint8*) surface;
	int width = (rect->right-rect->left) / 8;

	for (int y=rect->top; y<=rect->bottom; y++)
	{
		const uint8* s = src;
		uint8* d = dest;
		for (int x=0; x<width; x++)
		{
			*(uint32*)(d +  0) = ConvertTable[s[0]];
			*(uint32*)(d +  3) = ConvertTable[s[1]];
			*(uint32*)(d +  6) = ConvertTable[s[2]];
			*(uint32*)(d +  9) = ConvertTable[s[3]];
			*(uint32*)(d + 12) = ConvertTable[s[4]];
			*(uint32*)(d + 15) = ConvertTable[s[5]];
			*(uint32*)(d + 18) = ConvertTable[s[6]];
			*(uint32*)(d + 21) = ConvertTable[s[7]];
			d+=24; s+=8;
		}
		src += 640;
		dest += pitch;
	}
}


// ---------------------------------------------------------------------------
//	8bpp -> ƃobt@(32bpp)
// ---------------------------------------------------------------------------

void WinDrawDDW::Convert32bpp(void* surface, const uint8* image, RECT* rect, int pitch)
{
	const uint8* src = image + rect->top * 640;
	uint8* dest = (uint8*) surface;
	int width = (rect->right-rect->left) / 8;

	for (int y=rect->top; y<=rect->bottom; y++)
	{
		const uint8* s = src;
		uint32* d = (uint32*) dest;
		for (int x=0; x<width; x++)
		{
			d[0] = ConvertTable[s[0]];
			d[1] = ConvertTable[s[1]];
			d[2] = ConvertTable[s[2]];
			d[3] = ConvertTable[s[3]];
			d[4] = ConvertTable[s[4]];
			d[5] = ConvertTable[s[5]];
			d[6] = ConvertTable[s[6]];
			d[7] = ConvertTable[s[7]];
			d+=8; s+=8;
		}
		src += 640;
		dest += pitch;
	}
}


// ---------------------------------------------------------------------------
//	Fϊe[u̍쐬
// ---------------------------------------------------------------------------

void WinDrawDDW::MakeColorTable()
{
	for (int i=0x40; i<0xc0; i++)
	{
		ConvertTable[i] = (((palentry[i].peRed << 24) >> redshift) & redmask)
						+ (((palentry[i].peBlue << 24) >> blueshift) & bluemask)
						+ (((palentry[i].peGreen << 24) >> greenshift) & greenmask);
	}
}

// ---------------------------------------------------------------------------
//	ʃC[W̎gpv
// ---------------------------------------------------------------------------

bool WinDrawDDW::Lock(uint8** pimage, int* pbpl)
{
	*pimage = image;
	*pbpl = bpl;
	return true;
}

// ---------------------------------------------------------------------------
//	ʃC[W̎gpI
// ---------------------------------------------------------------------------

bool WinDrawDDW::Unlock()
{
	return true;
}

// ---------------------------------------------------------------------------
//	XgT[tFX߂
// ---------------------------------------------------------------------------

bool WinDrawDDW::RestoreSurface()
{
	if (DD_OK != ddsscrn->Restore() || DD_OK != ddswork->Restore())
		return false;

	// ƃT[tFX̒g
	DDSURFACEDESC ddsd;
	memset(&ddsd, 0, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	if (DD_OK != ddswork->Lock(0, &ddsd, 0, 0))
		return false;

	RECT rect;
	rect.left = 0;		rect.top = 0;
	rect.right = 640;	rect.bottom = 400;

	(*convert)(ddsd.lpSurface, image, &rect, ddsd.lPitch);
	
	ddswork->Unlock(0);

	// Primary Surface ̒g
	RECT rectdest;
	POINT srcpoint;
	srcpoint.x = 0, srcpoint.y = 0;
	ClientToScreen(hwnd, &srcpoint);
	rectdest.left = srcpoint.x + rect.left;
	rectdest.right = srcpoint.x + rect.right;
	rectdest.top = srcpoint.y + rect.top;
	rectdest.bottom = srcpoint.y + rect.bottom;
	
	if (DD_OK != ddsscrn->Blt(&rectdest, ddswork, &rect, 0, 0))
		return false;
	return true;
}
