// ---------------------------------------------------------------------------
//  M88 - PC88 emulator
//  Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//	DirectDraw ɂEChEʕ`
// ---------------------------------------------------------------------------
//	$Id: WinDrawDDW.h,v 1.2 1999/01/11 15:32:16 cisc Exp $

#if !defined(AFX_WINDRAWDDW_H__2E1F13FC_4941_11D2_BDBA_00A0C90AC9DA__INCLUDED_)
#define AFX_WINDRAWDDW_H__2E1F13FC_4941_11D2_BDBA_00A0C90AC9DA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "WinDraw.h"

class WinDrawDDW : public WinDraw  
{
public:
	WinDrawDDW();
	~WinDrawDDW();

	bool Init(HWND hwnd);
	bool Cleanup();
	void SetPalette(PALETTEENTRY* pal);
	void QueryNewPalette();
	void UpdateScreen(int top, int bottom, bool refresh);
	bool Lock(uint8** pimage, int* pbpl);
	bool Unlock();

private:
	bool CreateDDPalette();
	bool CreateDD2();
	bool CreateDDS();
	void MakeColorTable();
	bool RestoreSurface();
	HWND hwnd;
	static uint32 ConvertTable[256];

	void (*convert)(void* dest, const uint8* src, RECT* rect, int pitch);
	static void Convert8bpp(void* dest, const uint8* src, RECT* rect, int pitch);
	static void Convert16bpp(void* dest, const uint8* src, RECT* rect, int pitch);
	static void Convert24bpp(void* dest, const uint8* src, RECT* rect, int pitch);
	static void Convert32bpp(void* dest, const uint8* src, RECT* rect, int pitch);
	
	LPDIRECTDRAW2 ddraw;
	LPDIRECTDRAWPALETTE ddpal;
	
	LPDIRECTDRAWSURFACE ddsscrn;
	LPDIRECTDRAWCLIPPER ddcscrn;
	
	LPDIRECTDRAWSURFACE ddswork;
	
	uint8* image;
	int bpl;
	uint32 redmask;
	uint32 greenmask;
	uint32 bluemask;
	uint8 redshift;
	uint8 greenshift;
	uint8 blueshift;
	bool scrnhaspal;
	bool palchanged;
	
	PALETTEENTRY palentry[256];
};

#endif // !defined(AFX_WINDRAWDDW_H__2E1F13FC_4941_11D2_BDBA_00A0C90AC9DA__INCLUDED_)
