// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//	FDC obNOEhpJvZ
// ---------------------------------------------------------------------------
//	$Id: WinFDC.h,v 1.2 1999/01/11 15:32:16 cisc Exp $

#if !defined(AFX_WINFDC_H__8E755A9D_EC72_11D1_BC6B_00A0C90AC9DA__INCLUDED_)
#define AFX_WINFDC_H__8E755A9D_EC72_11D1_BC6B_00A0C90AC9DA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "WinCriticalSection.h"
#include "FDC.h"

class WinFDU;

// ---------------------------------------------------------------------------

class WinFDC : public FDC  
{
public:
	WinFDC();
	virtual ~WinFDC();

	bool Init();
	void Cleanup();
	void Reset();

	int Mount(uint drive, const char* filename, bool readonly);
	bool Unmount(uint drive);
	bool IsMount(uint drive);
	char* GetDiskTitle(uint drive, uint id);
	bool SetDisk(uint drive, uint id);



protected:
	void Seek(uint dr, uint cy);
	void ReadData(bool deleted);
	void WriteData(bool last, bool deleted);
	void ReadID();
	void WriteID();
	void TC();
	void ReadDiag(bool first);
	bool ShiftPhase(Phase, uint8, bool);

private:
	uint ThreadMain();
	static uint _stdcall ThreadEntry(LPVOID arg);

	WinFDU* winfdu[NUM_FLOPPY_DRIVES];
	CriticalSection cs;
	CriticalSection csphase;
	HANDLE hthread;
	UINT idthread;
	bool threaded;

};

#endif // !defined(AFX_WINFDC_H__8E755A9D_EC72_11D1_BC6B_00A0C90AC9DA__INCLUDED_)
