// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//  FDU with Auto Selector
// ---------------------------------------------------------------------------
//	$Id: WinFDU.h,v 1.2 1999/01/11 15:32:17 cisc Exp $

#if !defined(AFX_WINFDU_H__8E755A9F_EC72_11D1_BC6B_00A0C90AC9DA__INCLUDED_)
#define AFX_WINFDU_H__8E755A9F_EC72_11D1_BC6B_00A0C90AC9DA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "FDU.h"
#include "WinCriticalSection.h"
#include "File.h"

#define WINFDU_MAXDISKINFILE	64

class WinFDU : public FDU  
{
public:
	WinFDU();
	~WinFDU();

	bool IsMount();
	int Mount(const char* filename, bool readonly);
	bool Unmount();
	char* GetDiskTitle(uint id);
	bool SetDisk(uint diskid);
	
	bool Mount(FileIO* fio) { return false; }
	
	Result ReadSector(uint8 flags, ID id, uint8* data);
	Result WriteSector(uint8 flags, ID id, const uint8* data, bool deleted);
	Result Seek(uint8 cyrinder);
	uint8 SenceDeviceStatus();
	Result ReadID(uint8 flags, ID* id);
	Result WriteID(uint8 flags, WIDDESC wid);

private:
	struct DiskDesc
	{
		char title[20];
		uint32 pos;
	};

private:
	bool CheckMultiDiskImage(const char* filename);
	bool DoMount(FDU* fdu);
	
	FileIO file;
	FDU* fdu;
	uint8 cy;
	CriticalSection cs;
	uint ndisks;
	
	DiskDesc diskdesc[WINFDU_MAXDISKINFILE];
};

#endif // !defined(AFX_WINFDU_H__8E755A9F_EC72_11D1_BC6B_00A0C90AC9DA__INCLUDED_)
