// ---------------------------------------------------------------------------
//	M88 - PC88 emulator
//	Copyright (c) cisc 1998.
// ---------------------------------------------------------------------------
//	PC88 Keyboard Interface Emulation for Win32/106 key (Rev. 3)
// ---------------------------------------------------------------------------
//	$Id: WinKeyIF.h,v 1.2 1999/01/11 15:32:17 cisc Exp $

#ifndef WINKEYIF_H
#define WINKEYIF_H

#include "Device.h"
#include "WinCriticalSection.h"

class Config;

// ---------------------------------------------------------------------------

class WinKeyIF : public Device
{
public:
	WinKeyIF();
	~WinKeyIF();
	bool Init(HWND);
	void ApplyConfig(const Config* config);

	uint8 In(uint port);
	void Out(uint, uint) {}
	void Activate(bool);
	void Disable(bool);
	void VSync();
	void KeyDown(uint, uint32);
	void KeyUp(uint, uint32);

private:
	enum KeyState
	{
		locked = 1,
		down   = 2,
		downex = 4,
	};
	enum KeyFlags
	{
		none = 0, lock, nex, ext, arrowten, keyb, noarrowten, noarrowtenex,
	};
	struct Key
	{
		uint8 k, f;
	};

	uint GetKey(const Key* key);

	static const Key KeyTable98[16 * 8][8];
	static const Key KeyTable106[16 * 8][8];

	const Key* keytable;
	int keyboardtype;
	bool active;
	bool disable;
	bool usearrow;
	HWND hwnd;
	HANDLE hevent;
	int keyport[16];
	uint8 keyboard[256];
	uint8 keystate[512];
};

#endif // WINKEYIF_H
