// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator.
//	Copyright (C) cisc 1998.
// ---------------------------------------------------------------------------
//	$Id: WinScreen.h,v 1.2 1999/01/11 15:32:18 cisc Exp $

#if !defined(AFX_WINSCREEN_H__0A64EF34_2C27_11D1_A292_83918CE43BA5__INCLUDED_)
#define AFX_WINSCREEN_H__0A64EF34_2C27_11D1_A292_83918CE43BA5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Screen.h"

class Win88;
class WinDraw;
class M88UI;
class Config;

class WinScreen : public Screen
{
public:
	enum DisplayType { None, GDI, DDWin, DDFull };

public:
	WinScreen();
	~WinScreen();
	bool Init0(HWND hwindow);
	bool Init(Win88* _pc);
	void Cleanup();
	
	int GetFCount();
	void RequestPaint(bool redraw = false);
	void QueryNewPalette(bool background);
	void SetGUIFlag(bool flag);
	void ApplyConfig(const Config* config);
	bool ChangeDisplayDriver(DisplayType type);
	bool Capture(uint8* dest);

private:
	void SaveScreen(uint8* dest);
	void LoadScreen(const uint8* src);
	void PaintWindow();
	uint ThreadMain();
	static uint __stdcall ThreadEntry(LPVOID arg);
	void SetPalette(int num, uint8 red, uint8 green, uint8 blue);
	
	uint idthread;
	HANDLE hthread;
	volatile bool shouldterminate;
	volatile bool updated;
	bool putinfo;
	bool palchanged;
	bool updatepalette;
	bool updateall;
	bool redraw;
	bool force480;
	DisplayType drawtype;
	DisplayType drawtypenew;
	HANDLE hevredraw;

	WinDraw* draw;
	Win88* pc;
	M88UI* ui;
	long fcount;
	int guicount;
	int guicountdiff;
	int palettemode;
	CriticalSection csdraw;
	CriticalSection csdtn;
	HWND hwnd;
	
	PALETTEENTRY palentry[0x80];
};

#endif // !defined(AFX_WINSCREEN_H__0A64EF34_2C27_11D1_A292_83918CE43BA5__INCLUDED_)
