// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator
//	Copyright (C) cisc 1997, 1998.
// ---------------------------------------------------------------------------
//	Sound Implemention for Win32
// ---------------------------------------------------------------------------
//	$Id: WinSound.h,v 1.2 1999/01/11 15:32:18 cisc Exp $

#if !defined(AFX_WINSOUND_H__63DD1F2A_8F45_11D1_AAA8_00A0C90AC9DA__INCLUDED_)
#define AFX_WINSOUND_H__63DD1F2A_8F45_11D1_AAA8_00A0C90AC9DA__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#if 0
#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <mmsystem.h>
#include <dsound.h>
#endif
#include "WinCriticalSection.h"
#include "Device.h"
#include "Sound.h"
#include "WinJoy.h"

// ---------------------------------------------------------------------------

class Config;

class WinSound : public Sound88
{
private:
	class Driver
	{
		static const uint num_blocks;
		static const uint timer_resolution;

	public:
		Driver();
		~Driver();

		bool Init(WinSound* ws, HWND hwnd, uint rate, uint ch, uint buflen);
		bool Cleanup();
		void Send();

	private:
		static void CALLBACK TimeProc(UINT, UINT, DWORD, DWORD, DWORD);

		LPDIRECTSOUND lpds;
		LPDIRECTSOUNDBUFFER lpdsb_primary;
		LPDIRECTSOUNDBUFFER lpdsb;
		UINT timerid;
		LONG sending;
		
		WinSound* winsound;
		uint nextwrite;
		uint buffersize;
		uint buffer_length;
		bool playing;
	};
	friend class Driver;

public:
	WinSound();
	~WinSound();

	bool Init(HWND hwnd, uint rate, uint32 clock, PC88* pc, uint buflen);
	bool ChangeRate(uint rate, uint32 clock, uint buflen);
	
	void ApplyConfig(const Config* config);
	void SetVolume(const Config* config);
	void Count(int32 us, bool timer);
	void VSync();

	void Reset();
	const uint8* FillBlock(uint);

private:
	bool InitSoundBuffer(LPDIRECTSOUND lpds, uint rate);
	void Cleanup();
	uint8 PortIn(uint port);
	
	void SetOPNVolume(const Config* config, OPN88& opn);
	int ConvertVolume(int volume);
	
	Driver driver;
	
	HWND hwnd;
	HANDLE hthread;
	UINT idthread;
	uint dsbsize;
	uint sbsize;
	uint currentrate;
	uint currentbuflen;
	
	int timerid;
	uint nextwriteoffset;
	LPDIRECTSOUND lpds;
	LPDIRECTSOUNDBUFFER lpdsb_primary;
	LPDIRECTSOUNDBUFFER lpdsb;
	CriticalSection csmix;
	WinJoyPad joy;
	uint32 cfgflg;

	bool enablesound;
	bool enablepad;
};


#endif // !defined(AFX_WINSOUND_H__63DD1F2A_8F45_11D1_AAA8_00A0C90AC9DA__INCLUDED_)
