// ---------------------------------------------------------------------------
//	Z80 emulator.
//	Copyright (C) cisc 1997, 1998.
// ---------------------------------------------------------------------------
//	Z80 ̃WX^`
// ---------------------------------------------------------------------------
//	$Id: Z80.h,v 1.2 1999/01/11 15:32:18 cisc Exp $

#ifndef Z80_H
#define Z80_H

#include "config.h"

//#ifndef DEBUG_F
#define WORDREG_IN_INT
//#endif

// ---------------------------------------------------------------------------
//	Z80 ̃WX^Zbg
// ---------------------------------------------------------------------------

struct Z80Reg
{
#ifdef WORDREG_IN_INT
	#define PAD(p)	uint8 p[sizeof(uint) - sizeof(uint16)]
	typedef uint wordreg;
#else
	#define PAD(p)
	typedef uint16 wordreg;
#endif

	union primary
	{
		struct
		{
			wordreg af;
			wordreg hl, de, bc, ix, iy, sp;
		} w;
		struct
		{
#ifdef ENDIAN_IS_BIG
			PAD(p1);
			uint8 a, flags;
			PAD(p2);
			uint8 h, l;
			PAD(p3);
			uint8 d, e;
			PAD(p4);
			uint8 b, c;
			PAD(p5);
			uint8 xh, xl;
			PAD(p6);
			uint8 yh, yl;
			PAD(p7);
			uint8 sph, spl;
#else
			uint8 flags, a;
			PAD(p1);
			uint8 l, h;
			PAD(p2);
			uint8 e, d;
			PAD(p3);
			uint8 c, b;
			PAD(p4);
			uint8 xl, xh;
			PAD(p5);
			uint8 yl, yh;
			PAD(p6);
			uint8 spl, sph;
			PAD(p7);
#endif
		} b;
	} r;

	wordreg r_af, r_hl, r_de, r_bc;			/* WX^ */
	wordreg pc;
	uint8 ireg;
	uint8 rreg, rreg7;						/* R(0-6 bit), R(7th bit) */
	uint8 intmode;							/* 荞݃[h */
	uint8 haltstate;
	bool iff1, iff2;
};

#undef PAD

#endif /* Z80_H */
