// ---------------------------------------------------------------------------
//	Z80 emulator in C++
//	Copyright (C) cisc 1997, 1998.
// ----------------------------------------------------------------------------
//	$Id: Z80R.h,v 1.2 1999/01/11 15:32:19 cisc Exp $

#ifndef Z80R_h
#define Z80R_h

#include <stdio.h>
#include "Device.h"
#include "Z80.h"

//#define STAT_COUNT
#define READ16_AT_ONCE  // gGfBAŋEzANZX\Ȃ

// ---------------------------------------------------------------------------
//	Z80  C++ Cve[V
// ---------------------------------------------------------------------------

class Z80R
{
	// OC^[tF[X
public:
	Z80R();
	virtual ~Z80R();
	void StartMonitor();
	void StopMonitor();

	void Reset(int rstat);
	void NMI();
	void Step(uint clocks);
	void StepDual(uint clocks, Z80R* sub);
	void StepDual2(uint clocks, Z80R* sub);
	void StepDualP(uint clocks, Z80R* sub, int x, int y);
	void RequestInterrupt(uint intno);
	void CancelInterrupt(uint intno);
	uint32 GetClockCount();

	// foCXƂ̃C^[tF[X
protected:
	virtual uint8 Read(uint a) = 0;
	virtual void Write(uint a, uint d) = 0;
	virtual uint8 InPort(uint p) = 0;
	virtual void OutPort(uint p, uint d) = 0;
	virtual void AcceptInterrupt(uint intno) = 0;
	
	void SetIMask(uint32 im) { intr_mask = im; }

	volatile bool wait;

	Z80Reg reg;
	
	// 88 ŗL
	bool gvramselected;						/* C000 ȍ~𒼐ڃANZXĂ悢 */

	// CPU G~[VpuWX^v(?)
private:
	int clockcount;
	uint32 intr_req;
	uint32 intr_mask;
	
	enum index { USEHL, USEIX, USEIY };
	index index_mode;						/* HL/IX/IY ǂQƂ邩 */
	uint8 uf;								/* vZtO */
	uint8 nfa;								/* Ō̉Z̎ */
	uint8 xf;								/* `tO(3,5rbg) */
	uint32 fx32, fy32;						/* tOvZp̃f[^ */
	uint fx, fy;
	
	uint8* ref_h[3];						/* H / XH / YH ̃e[u */
	uint8* ref_l[3];						/* L / YH / YL ̃e[u */
	Z80Reg::wordreg* ref_hl[3];				/* HL/ IX / IY ̃e[u */
	uint8* ref_byte[8];						/* BCDEHL A ̃e[u */

protected:
	uint8* readaccess[256];					/* 256B y[WPʂ̓ǂݍ݃̃|C^ */				
	uint8* writeaccess[256];				/* 256B y[WPʂ̏݃̃|C^ */				

	uint memwait[256];
	uint memwait2[256];
	uint gvramwait;
	uint gvramwait2;

private:

#ifdef STAT_COUNT
	int etable[0x100], eitable[0x100], eetable[0x100], ectable[0x100];
#endif

#ifdef DEBUG_MONITOR
	int monitor;
	FILE* fpmon;
	void Monitor();
	void Disassemble(char* buf);
#endif

	// C^[tF[X
private:
	void Write8(uint addr, uint8 data);
	uint8 Read8(uint addr);
	void TestIntr();

	void SingleStep();
	void Init();
	
	void Call();
	uint8 GetCF(), GetZF(), GetSF();
	uint8 GetHF(), GetPF();
	void SetM(uint8 n);
	uint8 GetM();
	uint Read16(uint a);
	void Write16(uint a, uint d);
	void Push(uint n);
	uint Pop();
	void ADDA(uint8), ADCA(uint8), SUBA(uint8);
	void SBCA(uint8), ANDA(uint8), ORA(uint8);
	void XORA(uint8), CPA(uint8);
	uint8 Inc8(uint8), Dec8(uint8);
	uint ADD16(uint x, uint y);
	void ADCHL(uint y), SBCHL(uint y);
	uint GetAF();
	void SetAF(uint n);
	void SetZS(uint8 a), SetZSP(uint8 a);
	void SetIFF(bool flag);
	void CPI(), CPD();
	void CodeCB();

	uint8 RLC(uint8), RRC(uint8), RL (uint8);
	uint8 RR (uint8), SLA(uint8), SRA(uint8);
	uint8 SLL(uint8), SRL(uint8);

//	virtual const char* GetDesc() { return "??"; }
	friend class Z80Test;
};

#endif // Z80R.h
