// ---------------------------------------------------------------------------
//	Z80 emulator for x86/VC5
//	Copyright (C) cisc 1997, 1998.
// ---------------------------------------------------------------------------
//	$Id: Z80_x86.cpp,v 1.2 1999/01/11 15:32:19 cisc Exp $

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "Z80_x86.h"

// ---------------------------------------------------------------------------
//	WX^ANZX
// ---------------------------------------------------------------------------

extern Z80_x86* z80_ptr;		// dummy. ۂɂ݂͑Ȃ

#define A		al
#define B		[esi]z80_ptr.reg.r.b.b
#define C		[esi]z80_ptr.reg.r.b.c
#define D		[esi]z80_ptr.reg.r.b.d
#define E		[esi]z80_ptr.reg.r.b.e
#define H		[esi]z80_ptr.reg.r.b.h
#define L		[esi]z80_ptr.reg.r.b.l
#define XH		[esi]z80_ptr.reg.r.b.xh
#define XL		[esi]z80_ptr.reg.r.b.xl
#define YH		[esi]z80_ptr.reg.r.b.yh
#define YL		[esi]z80_ptr.reg.r.b.yl
#define SPH		[esi]z80_ptr.reg.r.b.sph
#define SPL		[esi]z80_ptr.reg.r.b.spl
#define BC		[esi]z80_ptr.reg.r.w.bc
#define DE		[esi]z80_ptr.reg.r.w.de
#define HL		[esi]z80_ptr.reg.r.w.hl
#define IX		[esi]z80_ptr.reg.r.w.ix
#define IY		[esi]z80_ptr.reg.r.w.iy
#define SP		[esi]z80_ptr.reg.r.w.sp
#define I		[esi]z80_ptr.reg.ireg
#define R		[esi]z80_ptr.reg.rreg		// R  Urbg܂
#define R7		[esi]z80_ptr.reg.rreg7		// R  Vrbg
#define IFF1	[esi]z80_ptr.reg.iff1
#define IFF2	[esi]z80_ptr.reg.iff2
#define REVAF	[esi]z80_ptr.reg.r_af		// 
#define REVBC	[esi]z80_ptr.reg.r_bc
#define REVDE	[esi]z80_ptr.reg.r_de
#define REVHL	[esi]z80_ptr.reg.r_hl
#define FLAGX	[esi]z80_ptr.flagn			// ugpvtO

#define INTMODE [esi]z80_ptr.reg.intmode
#define INTREQ  [esi]z80_ptr.intr_req
#define INTMASK	[esi]z80_ptr.intr_mask
#define HLTSTAT	[esi]z80_ptr.reg.haltstate
#define CLKCNT	[esi]z80_ptr.clockcounter

#define BNKLIM  [esi]z80_ptr.banklimit
#define BNKWAIT [esi]z80_ptr.bankwait
			
#define S		dh
#define T		dl
#define U		ch
#define V		cl
#ifdef WORDREG_IN_INT
	#define	PQ		ebp
	#define ST		edx
	#define UV		ecx
	#define PC		edi
#else
	#define	PQ		bp
	#define ST		dx
	#define UV		cx
	#define PC		di
#endif

#define ePC		edi
#define ePQ		ebp
#define eST		edx
#define eUV		ecx

#define CF		1		// 00000001b
#define NF		2		// 00000010b
#define PF		4		// 00000100b
#define HF		16		// 00010000b
#define ZF		64		// 01000000b
#define SF		128		// 10000000b

// ---------------------------------------------------------------------------
//	{
// ---------------------------------------------------------------------------

#define SETF(flgs)			__asm { or ah,(flgs) }
#define CLRF(flgs)			__asm { and ah,not (flgs) }

#define LOADF				__asm { sahf }
#define LOADCY				__asm { ror ah,1 }
#define SAVEF				__asm { lahf }
#define SAVEFX(reg)			__asm { mov FLAGX,reg } \
							SAVEF 

#define MOV(dest, src)		__asm { mov V, src } \
							__asm { mov dest, V }
#define MOVD(dest, src)		__asm { mov dest, src }
#define MOVN(dest, n)		__asm { mov dest, n }
#define MOV16(dest, src)	__asm { mov dest, src }
#define MOV16N(dest, n)		__asm { mov dest, n }
#define INC16(reg)			__asm { inc reg }
#define DEC16(reg)			__asm { dec reg }
#define ADD16(d, s)			__asm { add d, s }
#define ADD16N(reg, n)		__asm { add reg, n } 
#define XCHG16(r1, r2)		__asm { xchg r1, r2 }

#define MOVSX(dest, src)	__asm { movsx dest,src }
#ifdef WORDREG_IN_INT
  #define MOVZX(dest, src)	__asm { mov dest,src }
#else
  #define MOVZX(dest, src)	__asm { movzx dest,src }
#endif

#define SETIM(n)			__asm { mov INTMODE, n }

#define INTERRUPT			__asm { call O_INTR }

#define CLK(n, m)			__asm { sub ebx, n * 2 }

void O_INTR();

// ---------------------------------------------------------------------------
//	OC^[tF[X
// ---------------------------------------------------------------------------

#include "Z80_x86i.h"

// ---------------------------------------------------------------------------
//  X^bN
// ---------------------------------------------------------------------------

#define MPUSH(reg)			MOVZX(ePQ, SP); ADD16N(ePQ, -2); MOV16(SP, PQ); WRITE16(reg); 
//#define MPOP(reg)			MOVZX(ePQ, SP); READ16(reg); ADD16N(SP, 2);

// ---------------------------------------------------------------------------
//	IX+d / IY+d	AhXZo -> PQ
// ---------------------------------------------------------------------------

#define LEAHL				MOVZX(ePQ, HL);
#define MLEAIX				FETCHSX(UV); MOVZX(ePQ, IX); ADD16(ePQ, eUV)
#define MLEAIY				FETCHSX(UV); MOVZX(ePQ, IY); ADD16(ePQ, eUV)

// ---------------------------------------------------------------------------
//	WX^()
//	UV <-> AF, A <- R
// ---------------------------------------------------------------------------

#ifdef DEBUG_F
#define LOADUVAF			__asm { and ah,0d7h } \
							__asm { mov U,A } \
							__asm { mov V,ah }
#else
#define LOADUVAF			__asm { mov V,FLAGX } \
							__asm { and ah,0d7h } \
							__asm { and V,28h } \
							__asm { mov U,A } \
							__asm { or  V,ah } 
#endif
							
#define STOREAFUV			__asm { mov ah,V } \
							__asm { mov FLAGX,V } \
							__asm { mov A,U }

// A = R - rfoward * 4 - T 						
#define LOADAR				__asm { mov ecx,eax } \
							__asm { shr ecx,24 } \
							__asm { mov A,R7 } \
							__asm { and cl,7fh } \
							__asm { and A,80h } \
							__asm { or A,cl }

// R = A + T + rfoward * 4 
#define STORERA				__asm { mov ecx,eax } \
							__asm { and eax,00ffffffh } \
							__asm { shl ecx,24 } \
							__asm { mov R7, A } \
							__asm { or eax,ecx }


// ---------------------------------------------------------------------------
//	tO
// ---------------------------------------------------------------------------

#define USEVFP				__asm { seto T } \
							CLRF(PF+NF) \
							__asm { shl T,2 } \
							__asm { or ah,T }

#define USEVFM				__asm { seto T } \
							CLRF(PF) \
							__asm { shl T,2 } \
							SETF(NF) \
							__asm { or ah,T }

// A ̓e IFF  tOZbg

#define TESTIFF				LOADF \
							__asm { inc A } \
							__asm { dec A } \
							SAVEFX(A) \
							__asm { test IFF1,-1 } \
							__asm { setnz V } \
							CLRF(HF+PF+NF) \
							__asm { shl V,2 } \
							__asm { or ah,V }

// ---------------------------------------------------------------------------
//	߃t[
// ---------------------------------------------------------------------------

#define MJUMP(dest)			MOVZX(ePC,dest)
#define MJUMPR(r)			__asm { lea PC, [PC+r+1] }
#define MCALLUV				MPUSH(PC); MOV16(PC, UV);
#define MRET				MPOP(PC)

// ---------------------------------------------------------------------------
// 	WrbgZpZ
// ---------------------------------------------------------------------------

#define MADD_A(reg)			__asm { add A,reg } \
							SAVEFX(A) \
							USEVFP

#define MADC_A(reg)			LOADCY \
							__asm { adc A,reg } \
							SAVEFX(A) \
							USEVFP
							
#define MSUB(reg)			__asm { sub A,reg } \
							SAVEFX(A) \
							USEVFM 

#define MSBC_A(reg)			LOADCY \
							__asm { sbb A,reg } \
							SAVEFX(A) \
							USEVFM
							
#define MAND(reg)			__asm { and A,reg } \
							SAVEFX(A) \
							CLRF(NF) \
							SETF(HF)
							
#define MOR(reg)			__asm { or A,reg } \
							SAVEFX(A) \
							CLRF(NF+HF)

#define MXOR(reg)			__asm { xor A,reg } \
							SAVEFX(A) \
							CLRF(NF+HF)
							
#define MCP(reg)			__asm { cmp A,reg } \
							SAVEFX(A) \
							USEVFM
							
#define MINCV				LOADF \
							__asm { inc V } \
							SAVEFX(V) \
							USEVFP

#define MDECV				LOADF \
							__asm { dec V } \
							SAVEFX(V) \
							USEVFM 

// ---------------------------------------------------------------------------
//	PUrbgZpZ
// ---------------------------------------------------------------------------

#define MADD16(ph,pl,qh,ql)	__asm { mov T,ah } \
							__asm { add pl,ql } \
							__asm { adc ph,qh } \
							__asm { lahf } \
							__asm { and T,not (HF+NF+CF) } \
							__asm { and ah,HF+CF } \
							__asm { or ah,T }

#define MADCHL(rh,rl)		MOV16(UV, HL) \
							LOADCY \
							__asm { adc V,rl } \
							__asm { adc U,rh } \
							SAVEFX(U) \
							USEVFP \
							CLRF(ZF) \
							__asm { test UV,0ffffh } \
							MOV16(HL, UV); \
							__asm { setz V } \
							__asm { shl V,6 } \
							__asm { or ah,V }

#define MSBCHL(rh,rl)		MOV16(UV, HL); \
							LOADCY \
							__asm { sbb V,rl } \
							__asm { sbb U,rh } \
							SAVEFX(U) \
							USEVFM \
							CLRF(ZF) \
							__asm { test UV,0ffffh } \
							MOV16(HL, UV); \
							__asm { setz V } \
							__asm { shl V,6 } \
							__asm { or ah,V }

// ---------------------------------------------------------------------------
//	[e[gEVtg
// ---------------------------------------------------------------------------

#define MRLCU				__asm { rol U,1 } \
							__asm { dec U } \
							__asm { inc U } \
							SAVEFX(U) \
							CLRF(NF+HF)
							
#define MRRCU				__asm { ror U,1 } \
							__asm { dec U } \
							__asm { inc U } \
							SAVEFX(U) \
							CLRF(NF+HF)
							
#define MRLU				LOADCY \
							__asm { adc U,U } \
							SAVEFX(U) \
							CLRF(NF+HF) 

#define MRRU				LOADF \
							__asm { rcr U,1 } \
							__asm { dec U } \
							__asm { inc U } \
							SAVEFX(U) \
							CLRF(NF+HF)

#define MSLAU				__asm { sal U,1 } \
							__asm { dec U } \
							__asm { inc U } \
							SAVEFX(U) \
							CLRF(NF+HF) 
							
#define MSRAU				__asm { sar U,1 } \
							__asm { dec U } \
							__asm { inc U } \
							SAVEFX(U) \
							CLRF(NF+HF)
							
#define MSLLU				__asm { stc } \
							__asm { adc U,U } \
							SAVEFX(U) \
							CLRF(NF+HF)
							
#define MSRLU				__asm { shr U,1 } \
							__asm { dec U } \
							__asm { inc U } \
							SAVEFX(U) \
							CLRF(NF+HF)

#define MRLD				MOVZX(ePQ, HL) \
							READ8(V) \
							__asm { mov T,A } \
							__asm { mov U,V } \
							__asm { and A,0f0h } \
							__asm { shr U,4 } \
							__asm { shl V,4 } \
							__asm { and T,0fh } \
							__asm { or A,U } \
							__asm { or V,T } \
							WRITE8(V); \
							LOADF \
							__asm { inc A } \
							__asm { dec A } \
							SAVEFX(A) \
							CLRF(NF+HF)
							
#define MRRD				MOVZX(ePQ, HL); \
							READ8(V); \
							__asm { mov T,A } \
							__asm { mov U,V } \
							__asm { shr V,4 } \
							__asm { and U,0fh } \
							__asm { shl T,4 } \
							__asm { and A,0f0h } \
							__asm { or V,T } \
							__asm { or A,U } \
							WRITE8(V); \
							LOADF \
							__asm { inc A } \
							__asm { dec A } \
							SAVEFX(A) \
							CLRF(NF+HF)
		
// ---------------------------------------------------------------------------
//	
// ---------------------------------------------------------------------------

#define MIFNZ(dest)			__asm { test ah,ZF } __asm { jz dest }
#define MIFZ(dest)			__asm { test ah,ZF } __asm { jnz dest }
#define MIFNC(dest)			__asm { test ah,CF } __asm { jz dest }
#define MIFC(dest)			__asm { test ah,CF } __asm { jnz dest }
#define MIFPO(dest)			__asm { test ah,PF } __asm { jz dest }
#define MIFPE(dest)			__asm { test ah,PF } __asm { jnz dest }
#define MIFP(dest)			__asm { test ah,SF } __asm { jz dest }
#define MIFM(dest)			__asm { test ah,SF } __asm { jnz dest }
#define MIFSUB(dest)		__asm { test ah,NF } __asm { jnz dest }

// ---------------------------------------------------------------------------
//	I/O 
// ---------------------------------------------------------------------------
//  use C or BC  ? 

#define MINPC(reg)			INP(U, BC) \
							LOADF \
							__asm { mov reg,U } \
							__asm { inc U } \
							__asm { dec U } \
							SAVEFX(U) \
							CLRF(HF|NF)
							
// ---------------------------------------------------------------------------
//	P̖߃G~[V}N
// ---------------------------------------------------------------------------

// ---------------------------------------------------------------------------
//  ݂[E[e[gVtg ----------------------------------------

#define MRLCA				LOADF \
							__asm { rol A,1 } \
							SAVEFX(A) \
							CLRF(NF+HF)

#define MRRCA				LOADF \
							__asm { ror A,1 } \
							SAVEFX(A) \
							CLRF(NF+HF) 

#define MRLA				LOADF \
							__asm { rcl A,1 } \
							SAVEFX(A) \
							CLRF(NF+HF)

#define MRRA				LOADF \
							__asm { rcr A,1 } \
							SAVEFX(A) \
							CLRF(NF+HF) 

// ---------------------------------------------------------------------------
//	݂[ 얽 -------------------------------------------------

#define MDAA				__asm { mov cl,ah } \
							__asm { and cl,NF } \
							__asm { jnz M_DAA_1 } \
							LOADF \
							__asm { daa } \
							__asm { jmp M_DAA_2 } \
							M_DAA_1: \
							LOADF \
							__asm { das } \
							M_DAA_2: \
							SAVEFX(A) \
							__asm { and ah,not NF } \
							__asm { or ah,cl }

#define MCPL				__asm { not A } \
							SETF(HF+NF) 
							
#define MSCF				SETF(CF) CLRF(NF+HF)

#define MCCF				CLRF(NF) \
							__asm { xor ah,CF }

// ---------------------------------------------------------------------------
//	ubNo͑ -------------------------------------------------------

#ifdef DEBUG_F
#define MINX				INP(V, BC); \
							MOVZX(ePQ, HL); \
							WRITE8(V); \
							__asm { mov U,ah }  \
							LOADF \
							__asm { dec B } \
							SAVEF \
							__asm { and ah,ZF+NF+CF } \
							__asm { and U,not(ZF+CF) } \
							__asm { or ah,U } 

#define MOUTX				MOVZX(ePQ,HL); \
							READ8(V); \
							OUTP(BC, V); \
							__asm { mov U,ah } \
							LOADF \
							__asm { dec B } \
							SAVEF \
							__asm { and ah,ZF+NF+CF } \
							__asm { and U,not(ZF+CF) } \
							__asm { or ah,U }
#else

#define MINX				INP(V, BC); \
							MOVZX(ePQ, HL); \
							WRITE8(V); \
							LOADF \
							__asm { dec B } \
							SAVEF \
							SETF(NF)

#define MOUTX				MOVZX(ePQ,HL); \
							READ8(V); \
							OUTP(BC, V); \
							LOADF \
							__asm { dec B } \
							SAVEF \
							SETF(NF) \
							INTERRUPT
#endif

// ---------------------------------------------------------------------------
//	ubN] ---------------------------------------------------------

#define MLDI				__asm { mov PQ, HL } \
							__asm { lea UV, [PQ+1] } \
							__asm { call Reader } \
							__asm { mov HL, UV } \
							__asm { mov PQ, DE } \
							__asm { lea UV, [PQ+1] } \
							__asm { call Writer } \
							__asm { mov DE, UV } \
							__asm { mov PQ, BC } \
							__asm { dec PQ } \
							__asm { test PQ,0ffffh } \
							__asm { mov BC,PQ } \
							__asm { setnz V } \
							CLRF(HF+PF+NF) \
							__asm { shl V,2 } \
							__asm { or ah,V } 

#define MLDD				__asm { mov PQ, HL } \
							__asm { lea UV, [PQ-1] } \
							__asm { call Reader } \
							__asm { mov HL, UV } \
							__asm { mov PQ, DE } \
							__asm { lea UV, [PQ-1] } \
							__asm { call Writer } \
							__asm { mov DE, UV } \
							__asm { mov PQ, BC } \
							__asm { dec PQ } \
							__asm { test PQ,0ffffh } \
							__asm { mov BC,PQ } \
							__asm { setnz V } \
							CLRF(HF+PF+NF) \
							__asm { shl V,2 } \
							__asm { or ah,V } 

// ---------------------------------------------------------------------------
//	ubNT[` -------------------------------------------------------

#define MCPI				__asm { mov PQ, HL } \
							__asm { lea UV, [PQ+1] } \
							__asm { mov HL, UV } \
							READ8(V); \
							__asm { mov U, ah } \
							LOADF \
							__asm { cmp A, V } \
							SAVEF \
							__asm { and U, 1 } \
							CLRF(PF+CF) \
							__asm { or U,NF } \
							__asm { mov ST,BC } \
							__asm { dec ST } \
							__asm { test ST,0ffffh } \
							__asm { mov BC,ST } \
							__asm { setnz V } \
							__asm { or ah, U } \
							__asm { shl V, 2 } \
							__asm { or ah, V }

#define MCPD				__asm { mov PQ, HL } \
							__asm { lea UV, [PQ-1] } \
							__asm { mov HL, UV } \
							READ8(V); \
							__asm { mov U, ah } \
							LOADF \
							__asm { cmp A, V } \
							SAVEF \
							__asm { and U, 1 } \
							CLRF(PF+CF) \
							__asm { or U,NF } \
							__asm { mov ST,BC } \
							__asm { dec ST } \
							__asm { test ST,0ffffh } \
							__asm { mov BC,ST } \
							__asm { setnz V } \
							__asm { or ah, U } \
							__asm { shl V, 2 } \
							__asm { or ah, V }


// ---------------------------------------------------------------------------
//  R[h
// ---------------------------------------------------------------------------

#define OPFUNC(label)	void __declspec(naked) O_##label ()
#define OPEND			__asm { ret }
typedef void (*OpFuncPtr)();

// ---------------------------------------------------------------------------
//  t inline
// ---------------------------------------------------------------------------

#define LEAIX		MLEAIX
#define LEAIY		MLEAIY
#define FETCHV		FETCH(V)
#define MPUSHUV		MPUSH(UV)
#define MPOPUV		MPOP(UV)

// ---------------------------------------------------------------------------
//	oNLbV ---------------------------------------------------------

#if 0

// PC <- UV
#define LOADUVPC			__asm { call O_UVPC }
#define STOREPCUV			__asm { call O_PCUV }

//
static OPFUNC(PCUV)
{
	__asm
	{
		test [esi]z80_ptr.gvramselected,-1
		jnz indirect
	direct:
		mov edi,ecx
		mov edx,ecx
		shr ecx,6
		and edx,0ff00h
		and ecx,0ffh*4
		and edi,0ffh
		mov [esi]z80_ptr.pc,edx
		mov edx,[esi]z80_ptr.memwait[ecx]
		mov ecx,[esi]z80_ptr.readaccess[ecx]
		mov BNKWAIT,edx
		add edi,ecx
		add ecx,100h
		mov BNKLIM,ecx
		ret
	indirect:
		cmp ecx,0c000h
		jb direct
		xor edx,edx
		mov esi,ecx
		mov BNKLIM,edx
		ret
	}
}

static OPFUNC(UVPC)
{
	__asm
	{
		mov edx,BNKLIM
		or edx,edx
		jz indirect
		neg edx
		mov ecx,[esi]z80_ptr.pc
		lea ecx,[ecx+edx+100h]
		ret
	indirect:
		mov ecx,edi
		ret
	}
}

#endif


// ---------------------------------------------------------------------------
//	AL[^얽ߖ -----------------------------------------------

static OPFUNC(DAA) { MDAA; CLK(4, 1); OPEND; }
static OPFUNC(CPL) { MCPL; CLK(4, 1); OPEND; }
static OPFUNC(CCF) { MCCF; CLK(4, 1); OPEND; }
static OPFUNC(SCF) { MSCF; CLK(4, 1); OPEND; }

static OPFUNC(RLCA) { MRLCA; CLK(4, 1); OPEND; }
static OPFUNC(RRCA) { MRRCA; CLK(4, 1); OPEND; }
static OPFUNC(RLA)  { MRLA; CLK(4, 1); OPEND; }
static OPFUNC(RRA)  { MRRA; CLK(4, 1); OPEND; }

static OPFUNC(RLD)  { MRLD; CLK(18, 4); OPEND; }
static OPFUNC(RRD)  { MRRD; CLK(18, 4); OPEND; }

static OPFUNC(NEG) { MOVD(V, A); MOVN(A, 0); CLK(8, 2); MSUB(V); OPEND; }

// ---------------------------------------------------------------------------
//	IM -----------------------------------------------------------------------

static OPFUNC(IM0) { SETIM(0); CLK(8, 2); OPEND; }
static OPFUNC(IM1) { SETIM(1); CLK(8, 2); OPEND; }
static OPFUNC(IM2) { SETIM(2); CLK(8, 2); OPEND; }

// ---------------------------------------------------------------------------
//	o͖ ---------------------------------------------------------------

static OPFUNC(IN_A_N)  { FETCHV; MOVD(U, A); INP(U, UV); MOVD(A, U); CLK(11, 2); OPEND; }
static OPFUNC(OUT_N_A) { FETCHV; MOVD(U, A); OUTP(UV, A); INTERRUPT; CLK(11, 2); OPEND; }

static OPFUNC(IN_B_C) { MINPC(B); CLK(12, 2); OPEND; }
static OPFUNC(IN_C_C) { MINPC(C); CLK(12, 2); OPEND; }
static OPFUNC(IN_D_C) { MINPC(D); CLK(12, 2); OPEND; }
static OPFUNC(IN_E_C) { MINPC(E); CLK(12, 2); OPEND; }
static OPFUNC(IN_H_C) { MINPC(H); CLK(12, 2); OPEND; }
static OPFUNC(IN_L_C) { MINPC(L); CLK(12, 2); OPEND; }
static OPFUNC(IN_F_C) { MINPC(V); CLK(12, 2); OPEND; }
static OPFUNC(IN_A_C) { MINPC(A); CLK(12, 2); OPEND; }

static OPFUNC(OUT_C_B) { OUTP(BC, B); CLK(12, 2); INTERRUPT; OPEND; }
static OPFUNC(OUT_C_C) { OUTP(BC, C); CLK(12, 2); INTERRUPT; OPEND; }
static OPFUNC(OUT_C_D) { OUTP(BC, D); CLK(12, 2); INTERRUPT; OPEND; }
static OPFUNC(OUT_C_E) { OUTP(BC, E); CLK(12, 2); INTERRUPT; OPEND; }
static OPFUNC(OUT_C_H) { OUTP(BC, H); CLK(12, 2); INTERRUPT; OPEND; }
static OPFUNC(OUT_C_L) { OUTP(BC, L); CLK(12, 2); INTERRUPT; OPEND; }
static OPFUNC(OUT_C_Z) { MOVN(V, 0); OUTP(BC, V); CLK(12, 2); INTERRUPT; OPEND; }
static OPFUNC(OUT_C_A) { OUTP(BC, A); CLK(12, 2); INTERRUPT; OPEND; }
	
// ---------------------------------------------------------------------------
//	򖽗 -----------------------------------------------------------------

static OPFUNC(JP) 	 { MOV16(PQ, PC); READ16(PC); CLK(10, 3); OPEND; }
static OPFUNC(JR)    { READPCSX(UV); CLK(12, 2); MJUMPR(UV); OPEND; }

static OPFUNC(JP_NZ) { CLK(10, 3); MIFZ (END); MOV16(PQ, PC); READ16(PC); OPEND; END: ADD16(ePC, 2); OPEND; }
static OPFUNC(JP_Z)  { CLK(10, 3); MIFNZ(END); MOV16(PQ, PC); READ16(PC); OPEND; END: ADD16(ePC, 2); OPEND; }
static OPFUNC(JP_NC) { CLK(10, 3); MIFC (END); MOV16(PQ, PC); READ16(PC); OPEND; END: ADD16(ePC, 2); OPEND; }
static OPFUNC(JP_C)  { CLK(10, 3); MIFNC(END); MOV16(PQ, PC); READ16(PC); OPEND; END: ADD16(ePC, 2); OPEND; }
static OPFUNC(JP_PO) { CLK(10, 3); MIFPE(END); MOV16(PQ, PC); READ16(PC); OPEND; END: ADD16(ePC, 2); OPEND; }
static OPFUNC(JP_PE) { CLK(10, 3); MIFPO(END); MOV16(PQ, PC); READ16(PC); OPEND; END: ADD16(ePC, 2); OPEND; }
static OPFUNC(JP_P)  { CLK(10, 3); MIFM (END); MOV16(PQ, PC); READ16(PC); OPEND; END: ADD16(ePC, 2); OPEND; }
static OPFUNC(JP_M)  { CLK(10, 3); MIFP (END); MOV16(PQ, PC); READ16(PC); OPEND; END: ADD16(ePC, 2); OPEND; }

static OPFUNC(JR_NZ) { MIFZ (END); READPCSX(UV); CLK(12, 2); MJUMPR(UV); OPEND; END: CLK(7, 2); INC16(ePC); OPEND; }
static OPFUNC(JR_Z)  { MIFNZ(END); READPCSX(UV); CLK(12, 2); MJUMPR(UV); OPEND; END: CLK(7, 2); INC16(ePC); OPEND; }
static OPFUNC(JR_NC) { MIFC (END); READPCSX(UV); CLK(12, 2); MJUMPR(UV); OPEND; END: CLK(7, 2); INC16(ePC); OPEND; }
static OPFUNC(JR_C)  { MIFNC(END); READPCSX(UV); CLK(12, 2); MJUMPR(UV); OPEND; END: CLK(7, 2); INC16(ePC); OPEND; }

static OPFUNC(JP_HL) { MJUMP(HL); CLK(4, 1); OPEND; }
static OPFUNC(JP_IX) { MJUMP(IX); CLK(4, 1); OPEND; }
static OPFUNC(JP_IY) { MJUMP(IY); CLK(4, 1); OPEND; }

static OPFUNC(CALL)    { FETCH16(UV); CLK(17, 5); MCALLUV; OPEND; }
static OPFUNC(CALL_NZ) { MIFZ (END); FETCH16(UV); CLK(17, 5); MCALLUV; OPEND; END: CLK(10, 3); ADD16(ePC, 2); OPEND; }
static OPFUNC(CALL_Z)  { MIFNZ(END); FETCH16(UV); CLK(17, 5); MCALLUV; OPEND; END: CLK(10, 3); ADD16(ePC, 2); OPEND; }
static OPFUNC(CALL_NC) { MIFC (END); FETCH16(UV); CLK(17, 5); MCALLUV; OPEND; END: CLK(10, 3); ADD16(ePC, 2); OPEND; }
static OPFUNC(CALL_C)  { MIFNC(END); FETCH16(UV); CLK(17, 5); MCALLUV; OPEND; END: CLK(10, 3); ADD16(ePC, 2); OPEND; }
static OPFUNC(CALL_PO) { MIFPE(END); FETCH16(UV); CLK(17, 5); MCALLUV; OPEND; END: CLK(10, 3); ADD16(ePC, 2); OPEND; }
static OPFUNC(CALL_PE) { MIFPO(END); FETCH16(UV); CLK(17, 5); MCALLUV; OPEND; END: CLK(10, 3); ADD16(ePC, 2); OPEND; }
static OPFUNC(CALL_P)  { MIFM (END); FETCH16(UV); CLK(17, 5); MCALLUV; OPEND; END: CLK(10, 3); ADD16(ePC, 2); OPEND; }
static OPFUNC(CALL_M)  { MIFP (END); FETCH16(UV); CLK(17, 5); MCALLUV; OPEND; END: CLK(10, 3); ADD16(ePC, 2); OPEND; }

static OPFUNC(RET)    { CLK(10, 3); MRET; OPEND; }
static OPFUNC(RET_NZ) { MIFZ (END); MRET; CLK(11, 3); OPEND; END: CLK(5, 1); OPEND; }
static OPFUNC(RET_Z)  { MIFNZ(END); MRET; CLK(11, 3); OPEND; END: CLK(5, 1); OPEND; }
static OPFUNC(RET_NC) { MIFC (END); MRET; CLK(11, 3); OPEND; END: CLK(5, 1); OPEND; }
static OPFUNC(RET_C)  { MIFNC(END); MRET; CLK(11, 3); OPEND; END: CLK(5, 1); OPEND; }
static OPFUNC(RET_PO) { MIFPE(END); MRET; CLK(11, 3); OPEND; END: CLK(5, 1); OPEND; }
static OPFUNC(RET_PE) { MIFPO(END); MRET; CLK(11, 3); OPEND; END: CLK(5, 1); OPEND; }
static OPFUNC(RET_P)  { MIFM (END); MRET; CLK(11, 3); OPEND; END: CLK(5, 1); OPEND; }
static OPFUNC(RET_M)  { MIFP (END); MRET; CLK(11, 3); OPEND; END: CLK(5, 1); OPEND; }

static OPFUNC(RETN) { /*MOVD(V, IFF2);*/ MRET; CLK(14, 4); OPEND; }
static OPFUNC(RETI) { MRET; CLK(14, 4); OPEND; }

static OPFUNC(DJNZ)
{
	__asm { mov U,B }
	__asm { dec U }
	__asm { jz no_jump }
	__asm { mov B,U }
	READPCSX(UV);
	CLK(13, 2);
	MJUMPR(UV);
	OPEND;
no_jump:
	CLK(8, 2); 
	__asm { inc ePC }
	__asm { mov B,U }
	OPEND;
}

static OPFUNC(RST00) { CLK(11, 3); MPUSH(PC); MOV16N(ePC, 0x00); OPEND; }
static OPFUNC(RST08) { CLK(11, 3); MPUSH(PC); MOV16N(ePC, 0x08); OPEND; }
static OPFUNC(RST10) { CLK(11, 3); MPUSH(PC); MOV16N(ePC, 0x10); OPEND; }
static OPFUNC(RST18) { CLK(11, 3); MPUSH(PC); MOV16N(ePC, 0x18); OPEND; }
static OPFUNC(RST20) { CLK(11, 3); MPUSH(PC); MOV16N(ePC, 0x20); OPEND; }
static OPFUNC(RST28) { CLK(11, 3); MPUSH(PC); MOV16N(ePC, 0x28); OPEND; }
static OPFUNC(RST30) { CLK(11, 3); MPUSH(PC); MOV16N(ePC, 0x30); OPEND; }
static OPFUNC(RST38) { CLK(11, 3); MPUSH(PC); MOV16N(ePC, 0x38); OPEND; }

// ---------------------------------------------------------------------------
//	PUrbgZp -------------------------------------------------------

static OPFUNC(ADDHL_BC) { MOV16(UV,HL); MADD16(U,V, B,C); MOVD(L, V); CLK(11, 1); MOVD(H, U); OPEND; }
static OPFUNC(ADDHL_DE) { MOV16(UV,HL); MADD16(U,V, D,E); MOVD(L, V); CLK(11, 1); MOVD(H, U); OPEND; }
static OPFUNC(ADDHL_HL) { MOV16(UV,HL); MADD16(U,V, U,V); MOVD(L, V); CLK(11, 1); MOVD(H, U); OPEND; }
static OPFUNC(ADDHL_SP) { MOV16(UV,HL); MADD16(U,V, SPH,SPL); MOVD(L, V); CLK(11, 1); MOVD(H, U); OPEND; }

//static OPFUNC(ADDHL_BC) { MOV16(UV,HL); MADD16(U,V, B,C); CLK(11, 1); MOV16(HL,UV); OPEND; }
//static OPFUNC(ADDHL_DE) { MOV16(UV,HL); MADD16(U,V, D,E); CLK(11, 1); MOV16(HL,UV); OPEND; }
//static OPFUNC(ADDHL_HL) { MOV16(UV,HL); MADD16(U,V, U,V); CLK(11, 1); MOV16(HL,UV); OPEND; }
//static OPFUNC(ADDHL_SP) { MOV16(UV,HL); MADD16(U,V, SPH,SPL); CLK(11, 1); MOV16(HL,UV); OPEND; }

static OPFUNC(ADDIX_BC) { MOV16(UV,IX); MADD16(U,V, B,C); CLK(11, 1); MOV16(IX,UV); OPEND; }
static OPFUNC(ADDIX_DE) { MOV16(UV,IX); MADD16(U,V, D,E); CLK(11, 1); MOV16(IX,UV); OPEND; }
static OPFUNC(ADDIX_IX) { MOV16(UV,IX); MADD16(U,V, U,V); CLK(11, 1); MOV16(IX,UV); OPEND; }
static OPFUNC(ADDIX_SP) { MOV16(UV,IX); MADD16(U,V, SPH,SPL); CLK(11, 1); MOV16(IX,UV); OPEND; }

static OPFUNC(ADDIY_BC) { MOV16(UV,IY); MADD16(U,V, B,C); CLK(11, 1); MOV16(IY,UV); OPEND; }
static OPFUNC(ADDIY_DE) { MOV16(UV,IY); MADD16(U,V, D,E); CLK(11, 1); MOV16(IY,UV); OPEND; }
static OPFUNC(ADDIY_IY) { MOV16(UV,IY); MADD16(U,V, U,V); CLK(11, 1); MOV16(IY,UV); OPEND; }
static OPFUNC(ADDIY_SP) { MOV16(UV,IY); MADD16(U,V, SPH,SPL); CLK(11, 1); MOV16(IY,UV); OPEND; }

// ADC/SBC HL,HL :  UV <- HL ł邱Ƃ𗘗p
static OPFUNC(ADCHL_BC) { CLK(15, 2); MADCHL(B,C); OPEND; }
static OPFUNC(ADCHL_DE) { CLK(15, 2); MADCHL(D,E); OPEND; }
static OPFUNC(ADCHL_HL) { CLK(15, 2); MADCHL(U,V); OPEND; }
static OPFUNC(ADCHL_SP) { CLK(15, 2); MADCHL(SPH,SPL); OPEND; }

static OPFUNC(SBCHL_BC) { CLK(15, 2); MSBCHL(B,C); OPEND; }
static OPFUNC(SBCHL_DE) { CLK(15, 2); MSBCHL(D,E); OPEND; }
static OPFUNC(SBCHL_HL) { CLK(15, 2); MSBCHL(U,V); OPEND; }
static OPFUNC(SBCHL_SP) { CLK(15, 2); MSBCHL(SPH,SPL); OPEND; }

#define INC16X(reg)  MOV16(UV, reg); INC16(UV); CLK(6, 1); MOV16(reg, UV)

static OPFUNC(INC_BC) { INC16X(BC); OPEND; }			// INC ss ̓tOωȂ
static OPFUNC(INC_DE) { INC16X(DE); OPEND; }
static OPFUNC(INC_HL) { INC16X(HL); OPEND; }
static OPFUNC(INC_SP) { INC16X(SP); OPEND; }
static OPFUNC(INC_IX) { INC16X(IX); OPEND; }
static OPFUNC(INC_IY) { INC16X(IY); OPEND; }

#define DEC16X(reg)  MOV16(UV, reg); DEC16(UV); CLK(6, 1); MOV16(reg, UV)

static OPFUNC(DEC_BC) { DEC16X(BC); OPEND; }			// DEC ss ̓tOωȂ
static OPFUNC(DEC_DE) { DEC16X(DE); OPEND; }
static OPFUNC(DEC_HL) { DEC16X(HL); OPEND; }
static OPFUNC(DEC_SP) { DEC16X(SP); OPEND; }
static OPFUNC(DEC_IX) { DEC16X(IX); OPEND; }
static OPFUNC(DEC_IY) { DEC16X(IY); OPEND; }

// ---------------------------------------------------------------------------
//	 -----------------------------------------------------------------

static OPFUNC(EX_AF_AF) { LOADUVAF; MOV16(PQ, REVAF); MOV16(REVAF, UV); MOV16(UV, PQ); STOREAFUV; CLK(4, 1); OPEND; }

static OPFUNC(EX_SP_HL) { MPOPUV; MOV16(PQ, UV); MOV16(UV, HL); CLK(19, 5); MOV16(HL, PQ); MPUSHUV; OPEND; }
static OPFUNC(EX_SP_IX) { MPOPUV; MOV16(PQ, UV); MOV16(UV, IX); CLK(19, 5); MOV16(IX, PQ); MPUSHUV; OPEND; }
static OPFUNC(EX_SP_IY) { MPOPUV; MOV16(PQ, UV); MOV16(UV, IY); CLK(19, 5); MOV16(IY, PQ); MPUSHUV; OPEND; }

static OPFUNC(EX_DE_HL) { MOV16(UV, DE); MOV16(PQ, HL); CLK(4, 1); MOV16(HL, UV); MOV16(DE, PQ); OPEND; }

static OPFUNC(EXX) 
{ 
	MOV16(UV, REVBC); XCHG16(UV, BC); MOV16(REVBC, UV);
	MOV16(UV, REVDE); XCHG16(UV, DE); MOV16(REVDE, UV);
	MOV16(UV, REVHL); XCHG16(UV, HL); MOV16(REVHL, UV);
	CLK(4, 1); 
	OPEND;
}

// ---------------------------------------------------------------------------
//	CPU 䖽 -------------------------------------------------------------

static OPFUNC(NOP) { CLK(4, 1); OPEND; }

static OPFUNC(HALT)
{
	__asm { dec ePC }
	__asm { test HLTSTAT, 1 }
	__asm { jnz halt_1 } 
	__asm { mov HLTSTAT, 1 }
	__asm { call O_INTR } 
	__asm { jnc halt_1 }
	__asm { mov HLTSTAT, 3 }
	CLK(100, 1);
	__asm { ret }
halt_1:
	CLK(64, 1);
	__asm { ret }
}

// ---------------------------------------------------------------------------
//	8 bit Z -----------------------------------------------------------

#define	OPALU(func)			static OPFUNC(func##_B)  { M##func(B); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_C)  { M##func(C); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_D)  { M##func(D); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_E)  { M##func(E); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_H)  { M##func(H); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_L)  { M##func(L); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_A)  { M##func(A); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_XH) { M##func(XH); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_XL) { M##func(XL); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_YH) { M##func(YH); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_YL) { M##func(YL); CLK(4, 1); OPEND; } \
							static OPFUNC(func##_M)  { LEAHL; READ8(V); M##func(V); CLK(7, 2); OPEND; } \
							static OPFUNC(func##_MX) { LEAIX; READ8(V); M##func(V); CLK(15, 3); OPEND; } \
							static OPFUNC(func##_MY) { LEAIY; READ8(V); M##func(V); CLK(15, 3); OPEND; } \
							static OPFUNC(func##_N)  { FETCHV; M##func(V); CLK(7, 2); OPEND; }

OPALU(ADD_A)	OPALU(ADC_A)	OPALU(SUB)	OPALU(SBC_A)
OPALU(AND)		OPALU(XOR)		OPALU(OR)	OPALU(CP)

static OPFUNC(INC_B)  { MOVD(V, B); MINCV; MOVD(B, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_C)  { MOVD(V, C); MINCV; MOVD(C, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_D)  { MOVD(V, D); MINCV; MOVD(D, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_E)  { MOVD(V, E); MINCV; MOVD(E, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_H)  { MOVD(V, H); MINCV; MOVD(H, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_L)  { MOVD(V, L); MINCV; MOVD(L, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_A)  { MOVD(V, A); MINCV; MOVD(A, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_XH) { MOVD(V, XH); MINCV; MOVD(XH, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_XL) { MOVD(V, XL); MINCV; MOVD(XL, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_YH) { MOVD(V, YH); MINCV; MOVD(YH, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_YL) { MOVD(V, YL); MINCV; MOVD(YL, V); CLK(4, 1); OPEND; }
static OPFUNC(INC_M)  { LEAHL; READ8(V); MINCV; WRITE8(V); CLK(11, 3); OPEND; }
static OPFUNC(INC_MX) { LEAIX; READ8(V); MINCV; WRITE8(V); CLK(19, 4); OPEND; }
static OPFUNC(INC_MY) { LEAIY; READ8(V); MINCV; WRITE8(V); CLK(19, 4); OPEND; }

static OPFUNC(DEC_B)  { MOVD(V, B); MDECV; MOVD(B, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_C)  { MOVD(V, C); MDECV; MOVD(C, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_D)  { MOVD(V, D); MDECV; MOVD(D, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_E)  { MOVD(V, E); MDECV; MOVD(E, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_H)  { MOVD(V, H); MDECV; MOVD(H, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_L)  { MOVD(V, L); MDECV; MOVD(L, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_A)  { MOVD(V, A); MDECV; MOVD(A, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_XH) { MOVD(V, XH); MDECV; MOVD(XH, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_XL) { MOVD(V, XL); MDECV; MOVD(XL, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_YH) { MOVD(V, YH); MDECV; MOVD(YH, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_YL) { MOVD(V, YL); MDECV; MOVD(YL, V); CLK(4, 1); OPEND; }
static OPFUNC(DEC_M)  { LEAHL; READ8(V); MDECV; WRITE8(V); CLK(11, 3); OPEND; }
static OPFUNC(DEC_MX) { LEAIX; READ8(V); MDECV; WRITE8(V); CLK(19, 4); OPEND; }
static OPFUNC(DEC_MY) { LEAIY; READ8(V); MDECV; WRITE8(V); CLK(19, 4); OPEND; }

// ---------------------------------------------------------------------------
//	X^bN -------------------------------------------------------------

static OPFUNC(PUSH_BC) { MPUSH(BC); CLK(11, 3); OPEND; }
static OPFUNC(PUSH_DE) { MPUSH(DE); CLK(11, 3); OPEND; }
static OPFUNC(PUSH_HL) { MPUSH(HL); CLK(11, 3); OPEND; }
static OPFUNC(PUSH_IX) { MPUSH(IX); CLK(11, 3); OPEND; }
static OPFUNC(PUSH_IY) { MPUSH(IY); CLK(11, 3); OPEND; }
static OPFUNC(PUSH_AF) { LOADUVAF; CLK(11, 3); MPUSHUV; OPEND; }

static OPFUNC(POP_BC) { MPOP(BC); CLK(10, 3); OPEND; }
static OPFUNC(POP_DE) { MPOP(DE); CLK(10, 3); OPEND; }
static OPFUNC(POP_HL) { MPOP(HL); CLK(10, 3); OPEND; }
static OPFUNC(POP_IX) { MPOP(IX); CLK(10, 3); OPEND; }
static OPFUNC(POP_IY) { MPOP(IY); CLK(10, 3); OPEND; }
static OPFUNC(POP_AF) { MPOPUV; CLK(10, 3); STOREAFUV; OPEND; }

// ---------------------------------------------------------------------------
//	16 rbg[h ------------------------------------------------------

static OPFUNC(LD_BC_NN) { FETCH16(BC); CLK(10, 3); OPEND; }
static OPFUNC(LD_DE_NN) { FETCH16(DE); CLK(10, 3); OPEND; }
static OPFUNC(LD_HL_NN) { FETCH16(HL); CLK(10, 3); OPEND; }
static OPFUNC(LD_IX_NN) { FETCH16(IX); CLK(10, 3); OPEND; }
static OPFUNC(LD_IY_NN) { FETCH16(IY); CLK(10, 3); OPEND; }
static OPFUNC(LD_SP_NN) { FETCH16(SP); CLK(10, 3); OPEND; }

static OPFUNC(LD_MM_HL) { FETCH16(UV); MOVZX(ePQ, UV); CLK(16, 5); WRITE16(HL); OPEND; }
static OPFUNC(LD_MM_BC) { FETCH16(UV); MOVZX(ePQ, UV); CLK(20, 6); WRITE16(BC); OPEND; }
static OPFUNC(LD_MM_DE) { FETCH16(UV); MOVZX(ePQ, UV); CLK(20, 6); WRITE16(DE); OPEND; }
static OPFUNC(LD_MM_SP) { FETCH16(UV); MOVZX(ePQ, UV); CLK(20, 6); WRITE16(SP); OPEND; }
static OPFUNC(LD_MM_IX) { FETCH16(UV); MOVZX(ePQ, UV); CLK(16, 5); WRITE16(IX); OPEND; }
static OPFUNC(LD_MM_IY) { FETCH16(UV); MOVZX(ePQ, UV); CLK(16, 5); WRITE16(IY); OPEND; }
static OPFUNC(LD_HL_MM) { FETCH16(UV); MOVZX(ePQ, UV); CLK(16, 5); READ16(HL); OPEND; }
static OPFUNC(LD_BC_MM) { FETCH16(UV); MOVZX(ePQ, UV); CLK(20, 6); READ16(BC); OPEND; }
static OPFUNC(LD_DE_MM) { FETCH16(UV); MOVZX(ePQ, UV); CLK(20, 6); READ16(DE); OPEND; }
static OPFUNC(LD_SP_MM) { FETCH16(UV); MOVZX(ePQ, UV); CLK(20, 6); READ16(SP); OPEND; }
static OPFUNC(LD_IX_MM) { FETCH16(UV); MOVZX(ePQ, UV); CLK(16, 5); READ16(IX); OPEND; }
static OPFUNC(LD_IY_MM) { FETCH16(UV); MOVZX(ePQ, UV); CLK(16, 5); READ16(IY); OPEND; }

static OPFUNC(LD_SP_HL) { MOV16(UV, HL); CLK(6, 1); MOV16(SP, UV); OPEND; }
static OPFUNC(LD_SP_IX) { MOV16(UV, IX); CLK(6, 1); MOV16(SP, UV); OPEND; }
static OPFUNC(LD_SP_IY) { MOV16(UV, IY); CLK(6, 1); MOV16(SP, UV); OPEND; }

// ---------------------------------------------------------------------------
//	8 rbg[h -------------------------------------------------------

static OPFUNC(LD_B_C)  { MOV(B, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_D)  { MOV(B, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_E)  { MOV(B, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_H)  { MOV(B, H); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_L)  { MOV(B, L); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_A)  { MOVD(B, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_XH) { MOV(B, XH); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_YH) { MOV(B, YH); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_XL) { MOV(B, XL); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_YL) { MOV(B, YL); CLK(4, 1); OPEND; }
static OPFUNC(LD_B_M)  { LEAHL; READ8(B); CLK(7, 2); OPEND; }
static OPFUNC(LD_B_MX) { LEAIX; READ8(B); CLK(15, 3); OPEND; }
static OPFUNC(LD_B_MY) { LEAIY; READ8(B); CLK(15, 3); OPEND; }
static OPFUNC(LD_B_N)  { FETCH(B); CLK(7, 2); OPEND; }

static OPFUNC(LD_C_B)  { MOV(C, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_D)  { MOV(C, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_E)  { MOV(C, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_H)  { MOV(C, H); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_L)  { MOV(C, L); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_A)  { MOVD(C, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_XH) { MOV(C, XH); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_YH) { MOV(C, YH); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_XL) { MOV(C, XL); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_YL) { MOV(C, YL); CLK(4, 1); OPEND; }
static OPFUNC(LD_C_M)  { LEAHL; READ8(C); CLK(7, 2); OPEND; }
static OPFUNC(LD_C_MX) { LEAIX; READ8(C); CLK(15, 3); OPEND; }
static OPFUNC(LD_C_MY) { LEAIY; READ8(C); CLK(15, 3); OPEND; }
static OPFUNC(LD_C_N)  { FETCH(C); CLK(7, 2); OPEND; }

static OPFUNC(LD_D_B)  { MOV(D, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_C)  { MOV(D, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_E)  { MOV(D, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_H)  { MOV(D, H); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_L)  { MOV(D, L); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_A)  { MOVD(D, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_XH) { MOV(D, XH); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_YH) { MOV(D, YH); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_XL) { MOV(D, XL); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_YL) { MOV(D, YL); CLK(4, 1); OPEND; }
static OPFUNC(LD_D_M)  { LEAHL; READ8(D); CLK(7, 2); OPEND; }
static OPFUNC(LD_D_MX) { LEAIX; READ8(D); CLK(15, 3); OPEND; }
static OPFUNC(LD_D_MY) { LEAIY; READ8(D); CLK(15, 3); OPEND; }
static OPFUNC(LD_D_N)  { FETCH(D); CLK(7, 2); OPEND; }

static OPFUNC(LD_E_B)  { MOV(E, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_C)  { MOV(E, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_D)  { MOV(E, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_H)  { MOV(E, H); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_L)  { MOV(E, L); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_A)  { MOVD(E, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_XH) { MOV(E, XH); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_YH) { MOV(E, YH); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_XL) { MOV(E, XL); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_YL) { MOV(E, YL); CLK(4, 1); OPEND; }
static OPFUNC(LD_E_M)  { LEAHL; READ8(E); CLK(7, 2); OPEND; }
static OPFUNC(LD_E_MX) { LEAIX; READ8(E); CLK(15, 3); OPEND; }
static OPFUNC(LD_E_MY) { LEAIY; READ8(E); CLK(15, 3); OPEND; }
static OPFUNC(LD_E_N)  { FETCH(E); CLK(7, 2); OPEND; }

static OPFUNC(LD_H_B)  { MOV(H, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_H_C)  { MOV(H, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_H_D)  { MOV(H, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_H_E)  { MOV(H, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_H_L)  { MOV(H, L); CLK(4, 1); OPEND; }
static OPFUNC(LD_H_A)  { MOVD(H, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_H_M)  { LEAHL; READ8(H); CLK(7, 2); OPEND; }
static OPFUNC(LD_H_MX) { LEAIX; READ8(H); CLK(15, 3); OPEND; }
static OPFUNC(LD_H_MY) { LEAIY; READ8(H); CLK(15, 3); OPEND; }
static OPFUNC(LD_H_N)  { FETCH(H); CLK(7, 2); OPEND; }

static OPFUNC(LD_L_B)  { MOV(L, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_L_C)  { MOV(L, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_L_D)  { MOV(L, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_L_E)  { MOV(L, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_L_H)  { MOV(L, H); CLK(4, 1); OPEND; }
static OPFUNC(LD_L_A)  { MOVD(L, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_L_M)  { LEAHL; READ8(L); CLK(7, 2); OPEND; }
static OPFUNC(LD_L_MX) { LEAIX; READ8(L); CLK(15, 3); OPEND; }
static OPFUNC(LD_L_MY) { LEAIY; READ8(L); CLK(15, 3); OPEND; }
static OPFUNC(LD_L_N)  { FETCH(L); CLK(7, 2); OPEND; }

static OPFUNC(LD_A_B)  { MOVD(A, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_C)  { MOVD(A, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_D)  { MOVD(A, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_E)  { MOVD(A, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_H)  { MOVD(A, H); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_L)  { MOVD(A, L); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_XH) { MOVD(A, XH); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_YH) { MOVD(A, YH); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_XL) { MOVD(A, XL); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_YL) { MOVD(A, YL); CLK(4, 1); OPEND; }
static OPFUNC(LD_A_M)  { LEAHL; READ8(V); MOVD(A,V); CLK(7, 2); OPEND; }
static OPFUNC(LD_A_MX) { LEAIX; READ8(V); MOVD(A,V); CLK(15, 3); OPEND; }
static OPFUNC(LD_A_MY) { LEAIY; READ8(V); MOVD(A,V); CLK(15, 3); OPEND; }
static OPFUNC(LD_A_N)  { FETCHV; MOVD(A,V); CLK(7, 2); OPEND; }

static OPFUNC(LD_XH_B)  { MOV(XH, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_XH_C)  { MOV(XH, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_XH_D)  { MOV(XH, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_XH_E)  { MOV(XH, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_XH_A)  { MOVD(XH, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_XH_XL) { MOV(XH, XL); CLK(4, 1); OPEND; }
static OPFUNC(LD_XH_N)  { FETCH(XH); CLK(7, 2); OPEND; }

static OPFUNC(LD_YH_B)  { MOV(YH, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_YH_C)  { MOV(YH, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_YH_D)  { MOV(YH, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_YH_E)  { MOV(YH, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_YH_A)  { MOVD(YH, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_YH_YL) { MOV(YH, YL); CLK(4, 1); OPEND; }
static OPFUNC(LD_YH_N)  { FETCH(YH);  CLK(4, 1); OPEND; }

static OPFUNC(LD_XL_B)  { MOV(XL, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_XL_C)  { MOV(XL, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_XL_D)  { MOV(XL, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_XL_E)  { MOV(XL, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_XL_A)  { MOVD(XL, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_XL_XH) { MOV(XL, XH); CLK(4, 1); OPEND; }
static OPFUNC(LD_XL_N)  { FETCH(XL); CLK(7, 2); OPEND; }

static OPFUNC(LD_YL_B)  { MOV(YL, B); CLK(4, 1); OPEND; }
static OPFUNC(LD_YL_C)  { MOV(YL, C); CLK(4, 1); OPEND; }
static OPFUNC(LD_YL_D)  { MOV(YL, D); CLK(4, 1); OPEND; }
static OPFUNC(LD_YL_E)  { MOV(YL, E); CLK(4, 1); OPEND; }
static OPFUNC(LD_YL_A)  { MOVD(YL, A); CLK(4, 1); OPEND; }
static OPFUNC(LD_YL_YH) { MOV(YL, YH); CLK(4, 1); OPEND; }
static OPFUNC(LD_YL_N)  { FETCH(YL);  CLK(4, 1); OPEND; }

static OPFUNC(LD_M_B)	{ LEAHL; WRITE8(B); CLK(7, 2); OPEND; }
static OPFUNC(LD_M_C)	{ LEAHL; WRITE8(C); CLK(7, 2); OPEND; }
static OPFUNC(LD_M_D)	{ LEAHL; WRITE8(D); CLK(7, 2); OPEND; }
static OPFUNC(LD_M_E)	{ LEAHL; WRITE8(E); CLK(7, 2); OPEND; }
static OPFUNC(LD_M_H)	{ LEAHL; WRITE8(H); CLK(7, 2); OPEND; }
static OPFUNC(LD_M_L)	{ LEAHL; WRITE8(L); CLK(7, 2); OPEND; }
static OPFUNC(LD_M_A)	{ LEAHL; WRITE8(A); CLK(7, 2); OPEND; }
static OPFUNC(LD_M_N)	{ FETCHV; LEAHL; CLK(10, 3); WRITE8(V); OPEND; }

static OPFUNC(LD_MX_B) { LEAIX; WRITE8(B); CLK(19, 3); OPEND; }
static OPFUNC(LD_MX_C) { LEAIX; WRITE8(C); CLK(19, 3); OPEND; }
static OPFUNC(LD_MX_D) { LEAIX; WRITE8(D); CLK(19, 3); OPEND; }
static OPFUNC(LD_MX_E) { LEAIX; WRITE8(E); CLK(19, 3); OPEND; }
static OPFUNC(LD_MX_H) { LEAIX; WRITE8(H); CLK(19, 3); OPEND; }
static OPFUNC(LD_MX_L) { LEAIX; WRITE8(L); CLK(19, 3); OPEND; }
static OPFUNC(LD_MX_A) { LEAIX; WRITE8(A); CLK(19, 3); OPEND; }
static OPFUNC(LD_MX_N) { FETCH16(UV); MOVZX(ePQ, IX); MOVSX(eST, V); CLK(19, 3); ADD16(ePQ, eST); WRITE8(U); OPEND; }

static OPFUNC(LD_MY_B) { LEAIY; WRITE8(B); CLK(19, 3); OPEND; }
static OPFUNC(LD_MY_C) { LEAIY; WRITE8(C); CLK(19, 3); OPEND; }
static OPFUNC(LD_MY_D) { LEAIY; WRITE8(D); CLK(19, 3); OPEND; }
static OPFUNC(LD_MY_E) { LEAIY; WRITE8(E); CLK(19, 3); OPEND; }
static OPFUNC(LD_MY_H) { LEAIY; WRITE8(H); CLK(19, 3); OPEND; }
static OPFUNC(LD_MY_L) { LEAIY; WRITE8(L); CLK(19, 3); OPEND; }
static OPFUNC(LD_MY_A) { LEAIY; WRITE8(A); CLK(19, 3); OPEND; }
static OPFUNC(LD_MY_N) { FETCH16(UV); MOVZX(ePQ, IY); MOVSX(eST, V); CLK(19, 3); ADD16(ePQ, eST); WRITE8(U); OPEND; }

static OPFUNC(LD_BC_A) { MOVZX(ePQ, BC); CLK(7, 2); WRITE8(A); OPEND; }
static OPFUNC(LD_DE_A) { MOVZX(ePQ, DE); CLK(7, 2); WRITE8(A); OPEND; }
static OPFUNC(LD_MM_A) { FETCH16(UV); MOVZX(ePQ, UV); CLK(13,  3); WRITE8(A); OPEND; }
static OPFUNC(LD_A_BC) { MOVZX(ePQ, BC); READ8(A); CLK(7, 2); OPEND; }
static OPFUNC(LD_A_DE) { MOVZX(ePQ, DE); READ8(A); CLK(7, 2); OPEND; }
static OPFUNC(LD_A_MM) { FETCH16(UV); MOVZX(ePQ, UV); READ8(A); CLK(13, 3); OPEND; }

static OPFUNC(LD_A_I) { MOVD(A, I); TESTIFF; CLK(9, 2); OPEND; }
static OPFUNC(LD_A_R) { LOADAR; TESTIFF; CLK(9, 2); OPEND; }
static OPFUNC(LD_I_A) { MOVD(I, A); CLK(9, 2); OPEND; }
static OPFUNC(LD_R_A) { STORERA; CLK(9, 2); OPEND; }

// ---------------------------------------------------------------------------
//	ubNo͖ -------------------------------------------------------

static OPFUNC(INI) { MINX; INC16(HL); CLK(16, 3); OPEND; }
static OPFUNC(IND) { MINX; DEC16(HL); CLK(16, 3); OPEND; }
static OPFUNC(OUTI) { MOUTX; INC16(HL); CLK(16, 3); OPEND; }
static OPFUNC(OUTD) { MOUTX; DEC16(HL); CLK(16, 3); OPEND; }

static OPFUNC(INIR) { MINX;  INC16(HL); MIFZ(END); CLK(20, 3); ADD16N(ePC, -2); OPEND; END: CLK(16, 3); OPEND; }
static OPFUNC(INDR) { MINX;  DEC16(HL); MIFZ(END); CLK(20, 3); ADD16N(ePC, -2); OPEND; END: CLK(16, 3); OPEND; }
static OPFUNC(OTIR) { MOUTX; INC16(HL); MIFZ(END); CLK(20, 3); ADD16N(ePC, -2); OPEND; END: CLK(16, 3); OPEND; }
static OPFUNC(OTDR) { MOUTX; DEC16(HL); MIFZ(END); CLK(20, 3); ADD16N(ePC, -2); OPEND; END: CLK(16, 3); OPEND; }

// ---------------------------------------------------------------------------
//	ubN] ---------------------------------------------------------

static OPFUNC(LDI) { MLDI; CLK(16, 4); OPEND; }
static OPFUNC(LDD) { MLDD; CLK(16, 4); OPEND; }

static OPFUNC(LDIR) { MLDI; MIFPO(END); CLK(20, 4); ADD16N(ePC, -2); OPEND; END: CLK(16, 4); OPEND; }
static OPFUNC(LDDR) { MLDD; MIFPO(END); CLK(20, 4); ADD16N(ePC, -2); OPEND; END: CLK(16, 4); OPEND; }

// ---------------------------------------------------------------------------
//	ubNT[` -------------------------------------------------------

static OPFUNC(CPI) { MCPI; CLK(16, 4); OPEND; }
static OPFUNC(CPD) { MCPD; CLK(16, 4); OPEND; }

static OPFUNC(CPIR) { MCPI; MIFZ(END); MIFPO(END); CLK(20, 4); ADD16N(ePC, -2); OPEND; END: CLK(16, 4); OPEND; }
static OPFUNC(CPDR) { MCPD; MIFZ(END); MIFPO(END); CLK(20, 4); ADD16N(ePC, -2); OPEND; END: CLK(16, 4); OPEND; }

// ---------------------------------------------------------------------------
//	CB ֌W ------------------------------------------------------------------

#define MBITU(n)		\
 /* ݏȗ */		__asm { pop edx } \
						__asm { test U,n } \
						__asm { setz cl } \
						CLRF(SF+NF+ZF) \
						__asm { mov FLAGX,ch } \
						__asm { shl cl,6 } \
						SETF(HF) \
						__asm { and ch,80h } \
						__asm { or ah,cl } \
						__asm { or ah,ch }

#define MRESU(n)		__asm { and U,not n }

#define MSETU(n)		__asm { or U,n }

static OPFUNC(RLCU)	{ MRLCU; OPEND; }	static OPFUNC(RLU)	{ MRLU;  OPEND; }
static OPFUNC(RRCU)	{ MRRCU; OPEND; }	static OPFUNC(RRU)	{ MRRU;  OPEND; }
static OPFUNC(SLAU)	{ MSLAU; OPEND; }	static OPFUNC(SRAU)	{ MSRAU; OPEND; }
static OPFUNC(SLLU)	{ MSLLU; OPEND; }	static OPFUNC(SRLU)	{ MSRLU; OPEND; }

static OPFUNC(BITU_0)	{ MBITU(0x01); OPEND; }	static OPFUNC(BITU_1)	{ MBITU(0x02); OPEND; }
static OPFUNC(BITU_2)	{ MBITU(0x04); OPEND; }	static OPFUNC(BITU_3)	{ MBITU(0x08); OPEND; }
static OPFUNC(BITU_4)	{ MBITU(0x10); OPEND; }	static OPFUNC(BITU_5)	{ MBITU(0x20); OPEND; }
static OPFUNC(BITU_6)	{ MBITU(0x40); OPEND; }	static OPFUNC(BITU_7)	{ MBITU(0x80); OPEND; }

static OPFUNC(RESU_0)	{ MRESU(0x01); OPEND; }	static OPFUNC(RESU_1)	{ MRESU(0x02); OPEND; }
static OPFUNC(RESU_2)	{ MRESU(0x04); OPEND; }	static OPFUNC(RESU_3)	{ MRESU(0x08); OPEND; }
static OPFUNC(RESU_4)	{ MRESU(0x10); OPEND; }	static OPFUNC(RESU_5)	{ MRESU(0x20); OPEND; }
static OPFUNC(RESU_6)	{ MRESU(0x40); OPEND; }	static OPFUNC(RESU_7)	{ MRESU(0x80); OPEND; }

static OPFUNC(SETU_0)	{ MSETU(0x01); OPEND; }	static OPFUNC(SETU_1)	{ MSETU(0x02); OPEND; }
static OPFUNC(SETU_2)	{ MSETU(0x04); OPEND; }	static OPFUNC(SETU_3)	{ MSETU(0x08); OPEND; }
static OPFUNC(SETU_4)	{ MSETU(0x10); OPEND; }	static OPFUNC(SETU_5)	{ MSETU(0x20); OPEND; }
static OPFUNC(SETU_6)	{ MSETU(0x40); OPEND; }	static OPFUNC(SETU_7)	{ MSETU(0x80); OPEND; }

static const OpFuncPtr OpTableCB2[0x20] =
{
O_RLCU,		O_RRCU,		O_RLU,		O_RRU,		O_SLAU,		O_SRAU,		O_SLLU,		O_SRLU,
O_BITU_0,	O_BITU_1,	O_BITU_2,	O_BITU_3,	O_BITU_4,	O_BITU_5,	O_BITU_6,	O_BITU_7,	
O_RESU_0,	O_RESU_1,	O_RESU_2,	O_RESU_3,	O_RESU_4,	O_RESU_5,	O_RESU_6,	O_RESU_7,	
O_SETU_0,	O_SETU_1,	O_SETU_2,	O_SETU_3,	O_SETU_4,	O_SETU_5,	O_SETU_6,	O_SETU_7,	
};

static OPFUNC(CB_B)	{ CLK(8, 2); MOVD(U,B); __asm { call OpTableCB2[eST*4] } MOVD(B, U); OPEND; }
static OPFUNC(CB_C)	{ CLK(8, 2); MOVD(U,C); __asm { call OpTableCB2[eST*4] } MOVD(C, U); OPEND; }
static OPFUNC(CB_D)	{ CLK(8, 2); MOVD(U,D); __asm { call OpTableCB2[eST*4] } MOVD(D, U); OPEND; }
static OPFUNC(CB_E)	{ CLK(8, 2); MOVD(U,E); __asm { call OpTableCB2[eST*4] } MOVD(E, U); OPEND; }
static OPFUNC(CB_H)	{ CLK(8, 2); MOVD(U,H); __asm { call OpTableCB2[eST*4] } MOVD(H, U); OPEND; }
static OPFUNC(CB_L)	{ CLK(8, 2); MOVD(U,L); __asm { call OpTableCB2[eST*4] } MOVD(L, U); OPEND; }
static OPFUNC(CB_A)	{ CLK(8, 2); MOVD(U,A); __asm { call OpTableCB2[eST*4] } MOVD(A, U); OPEND; }
static OPFUNC(CB_M)
{
	CLK(12, 3); 
	__asm { push eST }
	READ8(U); 
	__asm { pop eST }
	__asm { call OpTableCB2[eST*4] }
	CLK(3, 1);
	WRITE8(U);
	OPEND;
}

// ---------------------------------------------------------------------------
//	A DD/FD prefix ̎̂߂̏ubN -------------------------------

static OPFUNC(DEC_PC)
{
	__asm { sub eax,1000000h };
	DEC16(ePC);
	CLK(4, 1); 
	OPEND;
}

// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------

void O_CODE_ED();
void O_CODE_DD();
void O_CODE_FD();
void O_CODE_CB();
void O_CODE_DDCB();
void O_CODE_FDCB();

void O_DI();
void O_EI();

static const OpFuncPtr OpTable[0x100] =
{
O_NOP,		O_LD_BC_NN,	O_LD_BC_A,	O_INC_BC,	O_INC_B,	O_DEC_B,	O_LD_B_N,	O_RLCA,		
O_EX_AF_AF,	O_ADDHL_BC,	O_LD_A_BC,	O_DEC_BC,	O_INC_C,	O_DEC_C,	O_LD_C_N,	O_RRCA,		
O_DJNZ,		O_LD_DE_NN,	O_LD_DE_A,	O_INC_DE,	O_INC_D,	O_DEC_D,	O_LD_D_N,	O_RLA,		
O_JR,		O_ADDHL_DE,	O_LD_A_DE,	O_DEC_DE,	O_INC_E,	O_DEC_E,	O_LD_E_N,	O_RRA,		
O_JR_NZ,	O_LD_HL_NN,	O_LD_MM_HL,	O_INC_HL,	O_INC_H,	O_DEC_H,	O_LD_H_N,	O_DAA,		
O_JR_Z,		O_ADDHL_HL,	O_LD_HL_MM,	O_DEC_HL,	O_INC_L,	O_DEC_L,	O_LD_L_N,	O_CPL,		
O_JR_NC,	O_LD_SP_NN,	O_LD_MM_A,	O_INC_SP,	O_INC_M,	O_DEC_M,	O_LD_M_N,	O_SCF,		
O_JR_C,		O_ADDHL_SP,	O_LD_A_MM,	O_DEC_SP,	O_INC_A,	O_DEC_A,	O_LD_A_N,	O_CCF,		

O_NOP,		O_LD_B_C,	O_LD_B_D,	O_LD_B_E,	O_LD_B_H,	O_LD_B_L,	O_LD_B_M,	O_LD_B_A,	
O_LD_C_B,	O_NOP,		O_LD_C_D,	O_LD_C_E,	O_LD_C_H,	O_LD_C_L,	O_LD_C_M,	O_LD_C_A,	
O_LD_D_B,	O_LD_D_C,	O_NOP,		O_LD_D_E,	O_LD_D_H,	O_LD_D_L,	O_LD_D_M,	O_LD_D_A,	
O_LD_E_B,	O_LD_E_C,	O_LD_E_D,	O_NOP,		O_LD_E_H,	O_LD_E_L,	O_LD_E_M,	O_LD_E_A,	
O_LD_H_B,	O_LD_H_C,	O_LD_H_D,	O_LD_H_E,	O_NOP,		O_LD_H_L,	O_LD_H_M,	O_LD_H_A,	
O_LD_L_B,	O_LD_L_C,	O_LD_L_D,	O_LD_L_E,	O_LD_L_H,	O_NOP,		O_LD_L_M,	O_LD_L_A,	
O_LD_M_B,	O_LD_M_C,	O_LD_M_D,	O_LD_M_E,	O_LD_M_H,	O_LD_M_L,	O_HALT,		O_LD_M_A,	
O_LD_A_B,	O_LD_A_C,	O_LD_A_D,	O_LD_A_E,	O_LD_A_H,	O_LD_A_L,	O_LD_A_M,	O_NOP,		

O_ADD_A_B,	O_ADD_A_C,	O_ADD_A_D,	O_ADD_A_E,	O_ADD_A_H,	O_ADD_A_L,	O_ADD_A_M,	O_ADD_A_A,	
O_ADC_A_B,	O_ADC_A_C,	O_ADC_A_D,	O_ADC_A_E,	O_ADC_A_H,	O_ADC_A_L,	O_ADC_A_M,	O_ADC_A_A,	
O_SUB_B,	O_SUB_C,	O_SUB_D,	O_SUB_E,	O_SUB_H,	O_SUB_L,	O_SUB_M,	O_SUB_A,	
O_SBC_A_B,	O_SBC_A_C,	O_SBC_A_D,	O_SBC_A_E,	O_SBC_A_H,	O_SBC_A_L,	O_SBC_A_M,	O_SBC_A_A,	
O_AND_B,	O_AND_C,	O_AND_D,	O_AND_E,	O_AND_H,	O_AND_L,	O_AND_M,	O_AND_A,	
O_XOR_B,	O_XOR_C,	O_XOR_D,	O_XOR_E,	O_XOR_H,	O_XOR_L,	O_XOR_M,	O_XOR_A,	
O_OR_B,		O_OR_C,		O_OR_D,		O_OR_E,		O_OR_H,		O_OR_L,		O_OR_M,		O_OR_A,		
O_CP_B,		O_CP_C,		O_CP_D,		O_CP_E,		O_CP_H,		O_CP_L,		O_CP_M,		O_CP_A,		

O_RET_NZ,	O_POP_BC,	O_JP_NZ,	O_JP,		O_CALL_NZ,	O_PUSH_BC,	O_ADD_A_N,	O_RST00,	
O_RET_Z,	O_RET,		O_JP_Z,		O_CODE_CB,	O_CALL_Z,	O_CALL,		O_ADC_A_N,	O_RST08,	
O_RET_NC,	O_POP_DE,	O_JP_NC,	O_OUT_N_A,	O_CALL_NC,	O_PUSH_DE,	O_SUB_N,	O_RST10,	
O_RET_C,	O_EXX,		O_JP_C,		O_IN_A_N,	O_CALL_C,	O_CODE_DD,	O_SBC_A_N,	O_RST18,	
O_RET_PO,	O_POP_HL,	O_JP_PO,	O_EX_SP_HL,	O_CALL_PO,	O_PUSH_HL,	O_AND_N,	O_RST20,	
O_RET_PE,	O_JP_HL,	O_JP_PE,	O_EX_DE_HL,	O_CALL_PE,	O_CODE_ED,	O_XOR_N,	O_RST28,	
O_RET_P,	O_POP_AF,	O_JP_P,		O_DI,		O_CALL_P,	O_PUSH_AF,	O_OR_N,		O_RST30,	
O_RET_M,	O_LD_SP_HL,	O_JP_M,		O_EI,		O_CALL_M,	O_CODE_FD,	O_CP_N,		O_RST38,	
};

static const OpFuncPtr OpTableDD[0x100] =
{
O_NOP,		O_LD_BC_NN,	O_LD_BC_A,	O_INC_BC,	O_INC_B,	O_DEC_B,	O_LD_B_N,	O_RLCA,		
O_EX_AF_AF,	O_ADDIX_BC,	O_LD_A_BC,	O_DEC_BC,	O_INC_C,	O_DEC_C,	O_LD_C_N,	O_RRCA,		
O_DJNZ,		O_LD_DE_NN,	O_LD_DE_A,	O_INC_DE,	O_INC_D,	O_DEC_D,	O_LD_D_N,	O_RLA,		
O_JR,		O_ADDIX_DE,	O_LD_A_DE,	O_DEC_DE,	O_INC_E,	O_DEC_E,	O_LD_E_N,	O_RRA,		
O_JR_NZ,	O_LD_IX_NN,	O_LD_MM_IX,	O_INC_IX,	O_INC_XH,	O_DEC_XH,	O_LD_XH_N,	O_DAA,		
O_JR_Z,		O_ADDIX_IX,	O_LD_IX_MM,	O_DEC_IX,	O_INC_XL,	O_DEC_XL,	O_LD_XL_N,	O_CPL,		
O_JR_NC,	O_LD_SP_NN,	O_LD_MM_A,	O_INC_SP,	O_INC_MX,	O_DEC_MX,	O_LD_MX_N,	O_SCF,		
O_JR_C,		O_ADDIX_SP,	O_LD_A_MM,	O_DEC_SP,	O_INC_A,	O_DEC_A,	O_LD_A_N,	O_CCF,		

O_NOP,		O_LD_B_C,	O_LD_B_D,	O_LD_B_E,	O_LD_B_XH,	O_LD_B_XL,	O_LD_B_MX,	O_LD_B_A,	
O_LD_C_B,	O_NOP,		O_LD_C_D,	O_LD_C_E,	O_LD_C_XH,	O_LD_C_XL,	O_LD_C_MX,	O_LD_C_A,	
O_LD_D_B,	O_LD_D_C,	O_NOP,		O_LD_D_E,	O_LD_D_XH,	O_LD_D_XL,	O_LD_D_MX,	O_LD_D_A,	
O_LD_E_B,	O_LD_E_C,	O_LD_E_D,	O_NOP,		O_LD_E_XH,	O_LD_E_XL,	O_LD_E_MX,	O_LD_E_A,	
O_LD_XH_B,	O_LD_XH_C,	O_LD_XH_D,	O_LD_XH_E,	O_NOP,		O_LD_XH_XL,	O_LD_H_MX,	O_LD_XH_A,	
O_LD_XL_B,	O_LD_XL_C,	O_LD_XL_D,	O_LD_XL_E,	O_LD_XL_XH,	O_NOP,		O_LD_L_MX,	O_LD_XL_A,	
O_LD_MX_B,	O_LD_MX_C,	O_LD_MX_D,	O_LD_MX_E,	O_LD_MX_H,	O_LD_MX_L,	O_HALT,		O_LD_MX_A,	
O_LD_A_B,	O_LD_A_C,	O_LD_A_D,	O_LD_A_E,	O_LD_A_XH,	O_LD_A_XL,	O_LD_A_MX,	O_NOP,		

O_ADD_A_B,	O_ADD_A_C,	O_ADD_A_D,	O_ADD_A_E,	O_ADD_A_XH,	O_ADD_A_XL,	O_ADD_A_MX,	O_ADD_A_A,	
O_ADC_A_B,	O_ADC_A_C,	O_ADC_A_D,	O_ADC_A_E,	O_ADC_A_XH,	O_ADC_A_XL,	O_ADC_A_MX,	O_ADC_A_A,	
O_SUB_B,	O_SUB_C,	O_SUB_D,	O_SUB_E,	O_SUB_XH,	O_SUB_XL,	O_SUB_MX,	O_SUB_A,	
O_SBC_A_B,	O_SBC_A_C,	O_SBC_A_D,	O_SBC_A_E,	O_SBC_A_XH,	O_SBC_A_XL,	O_SBC_A_MX,	O_SBC_A_A,	
O_AND_B,	O_AND_C,	O_AND_D,	O_AND_E,	O_AND_XH,	O_AND_XL,	O_AND_MX,	O_AND_A,	
O_XOR_B,	O_XOR_C,	O_XOR_D,	O_XOR_E,	O_XOR_XH,	O_XOR_XL,	O_XOR_MX,	O_XOR_A,	
O_OR_B,		O_OR_C,		O_OR_D,		O_OR_E,		O_OR_XH,	O_OR_XL,	O_OR_MX,	O_OR_A,		
O_CP_B,		O_CP_C,		O_CP_D,		O_CP_E,		O_CP_XH,	O_CP_XL,	O_CP_MX,	O_CP_A,		

O_RET_NZ,	O_POP_BC,	O_JP_NZ,	O_JP,		O_CALL_NZ,	O_PUSH_BC,	O_ADD_A_N,	O_RST00,	
O_RET_Z,	O_RET,		O_JP_Z,		O_CODE_DDCB,O_CALL_Z,	O_CALL,		O_ADC_A_N,	O_RST08,	
O_RET_NC,	O_POP_DE,	O_JP_NC,	O_OUT_N_A,	O_CALL_NC,	O_PUSH_DE,	O_SUB_N,	O_RST10,	
O_RET_C,	O_EXX,		O_JP_C,		O_IN_A_N,	O_CALL_C,	O_CODE_DD,	O_SBC_A_N,	O_RST18,	
O_RET_PO,	O_POP_IX,	O_JP_PO,	O_EX_SP_IX,	O_CALL_PO,	O_PUSH_IX,	O_AND_N,	O_RST20,	
O_RET_PE,	O_JP_IX,	O_JP_PE,	O_EX_DE_HL,	O_CALL_PE,	O_DEC_PC,	O_XOR_N,	O_RST28,	
O_RET_P,	O_POP_AF,	O_JP_P,		O_DI,		O_CALL_P,	O_PUSH_AF,	O_OR_N,		O_RST30,	
O_RET_M,	O_LD_SP_IX,	O_JP_M,		O_EI,		O_CALL_M,	O_DEC_PC,	O_CP_N,		O_RST38,	
};

static const OpFuncPtr OpTableFD[0x100] =
{
O_NOP,		O_LD_BC_NN,	O_LD_BC_A,	O_INC_BC,	O_INC_B,	O_DEC_B,	O_LD_B_N,	O_RLCA,		
O_EX_AF_AF,	O_ADDIY_BC,	O_LD_A_BC,	O_DEC_BC,	O_INC_C,	O_DEC_C,	O_LD_C_N,	O_RRCA,		
O_DJNZ,		O_LD_DE_NN,	O_LD_DE_A,	O_INC_DE,	O_INC_D,	O_DEC_D,	O_LD_D_N,	O_RLA,		
O_JR,		O_ADDIY_DE,	O_LD_A_DE,	O_DEC_DE,	O_INC_E,	O_DEC_E,	O_LD_E_N,	O_RRA,		
O_JR_NZ,	O_LD_IY_NN,	O_LD_MM_IY,	O_INC_IY,	O_INC_YH,	O_DEC_YH,	O_LD_YH_N,	O_DAA,		
O_JR_Z,		O_ADDIY_IY,	O_LD_IY_MM,	O_DEC_IY,	O_INC_YL,	O_DEC_YL,	O_LD_YL_N,	O_CPL,		
O_JR_NC,	O_LD_SP_NN,	O_LD_MM_A,	O_INC_SP,	O_INC_MY,	O_DEC_MY,	O_LD_MY_N,	O_SCF,		
O_JR_C,		O_ADDIY_SP,	O_LD_A_MM,	O_DEC_SP,	O_INC_A,	O_DEC_A,	O_LD_A_N,	O_CCF,		

O_NOP,		O_LD_B_C,	O_LD_B_D,	O_LD_B_E,	O_LD_B_YH,	O_LD_B_YL,	O_LD_B_MY,	O_LD_B_A,	
O_LD_C_B,	O_NOP,		O_LD_C_D,	O_LD_C_E,	O_LD_C_YH,	O_LD_C_YL,	O_LD_C_MY,	O_LD_C_A,	
O_LD_D_B,	O_LD_D_C,	O_NOP,		O_LD_D_E,	O_LD_D_YH,	O_LD_D_YL,	O_LD_D_MY,	O_LD_D_A,	
O_LD_E_B,	O_LD_E_C,	O_LD_E_D,	O_NOP,		O_LD_E_YH,	O_LD_E_YL,	O_LD_E_MY,	O_LD_E_A,	
O_LD_YH_B,	O_LD_YH_C,	O_LD_YH_D,	O_LD_YH_E,	O_NOP,		O_LD_YH_YL,	O_LD_H_MY,	O_LD_YH_A,	
O_LD_YL_B,	O_LD_YL_C,	O_LD_YL_D,	O_LD_YL_E,	O_LD_YL_YH,	O_NOP,		O_LD_L_MY,	O_LD_YL_A,	
O_LD_MY_B,	O_LD_MY_C,	O_LD_MY_D,	O_LD_MY_E,	O_LD_MY_H,	O_LD_MY_L,	O_HALT,		O_LD_MY_A,	
O_LD_A_B,	O_LD_A_C,	O_LD_A_D,	O_LD_A_E,	O_LD_A_YH,	O_LD_A_YL,	O_LD_A_MY,	O_NOP,		

O_ADD_A_B,	O_ADD_A_C,	O_ADD_A_D,	O_ADD_A_E,	O_ADD_A_YH,	O_ADD_A_YL,	O_ADD_A_MY,	O_ADD_A_A,	
O_ADC_A_B,	O_ADC_A_C,	O_ADC_A_D,	O_ADC_A_E,	O_ADC_A_YH,	O_ADC_A_YL,	O_ADC_A_MY,	O_ADC_A_A,	
O_SUB_B,	O_SUB_C,	O_SUB_D,	O_SUB_E,	O_SUB_YH,	O_SUB_YL,	O_SUB_MY,	O_SUB_A,	
O_SBC_A_B,	O_SBC_A_C,	O_SBC_A_D,	O_SBC_A_E,	O_SBC_A_YH,	O_SBC_A_YL,	O_SBC_A_MY,	O_SBC_A_A,	
O_AND_B,	O_AND_C,	O_AND_D,	O_AND_E,	O_AND_YH,	O_AND_YL,	O_AND_MY,	O_AND_A,	
O_XOR_B,	O_XOR_C,	O_XOR_D,	O_XOR_E,	O_XOR_YH,	O_XOR_YL,	O_XOR_MY,	O_XOR_A,	
O_OR_B,		O_OR_C,		O_OR_D,		O_OR_E,		O_OR_YH,	O_OR_YL,	O_OR_MY,	O_OR_A,		
O_CP_B,		O_CP_C,		O_CP_D,		O_CP_E,		O_CP_YH,	O_CP_YL,	O_CP_MY,	O_CP_A,		

O_RET_NZ,	O_POP_BC,	O_JP_NZ,	O_JP,		O_CALL_NZ,	O_PUSH_BC,	O_ADD_A_N,	O_RST00,	
O_RET_Z,	O_RET,		O_JP_Z,		O_CODE_FDCB,O_CALL_Z,	O_CALL,		O_ADC_A_N,	O_RST08,	
O_RET_NC,	O_POP_DE,	O_JP_NC,	O_OUT_N_A,	O_CALL_NC,	O_PUSH_DE,	O_SUB_N,	O_RST10,	
O_RET_C,	O_EXX,		O_JP_C,		O_IN_A_N,	O_CALL_C,	O_CODE_DD,	O_SBC_A_N,	O_RST18,	
O_RET_PO,	O_POP_IY,	O_JP_PO,	O_EX_SP_IY,	O_CALL_PO,	O_PUSH_IY,	O_AND_N,	O_RST20,	
O_RET_PE,	O_JP_IY,	O_JP_PE,	O_EX_DE_HL,	O_CALL_PE,	O_DEC_PC,	O_XOR_N,	O_RST28,	
O_RET_P,	O_POP_AF,	O_JP_P,		O_DI,		O_CALL_P,	O_PUSH_AF,	O_OR_N,		O_RST30,	
O_RET_M,	O_LD_SP_IY,	O_JP_M,		O_EI,		O_CALL_M,	O_DEC_PC,	O_CP_N,		O_RST38,	
};

static const OpFuncPtr OpTableED[0x80] =
{
O_IN_B_C,	O_OUT_C_B,	O_SBCHL_BC,	O_LD_MM_BC,	O_NEG,		O_RETN,		O_IM0,		O_LD_I_A,	
O_IN_C_C,	O_OUT_C_C,	O_ADCHL_BC,	O_LD_BC_MM,	O_NEG,		O_RETI,		O_IM0,		O_LD_R_A,	
O_IN_D_C,	O_OUT_C_D,	O_SBCHL_DE,	O_LD_MM_DE,	O_NEG,		O_RETN,		O_IM1,		O_LD_A_I,	
O_IN_E_C,	O_OUT_C_E,	O_ADCHL_DE,	O_LD_DE_MM,	O_NEG,		O_RETN,		O_IM2,		O_LD_A_R,	
O_IN_H_C,	O_OUT_C_H,	O_SBCHL_HL,	O_LD_MM_HL,	O_NEG,		O_RETN,		O_IM0,		O_RRD,		
O_IN_L_C,	O_OUT_C_L,	O_ADCHL_HL,	O_LD_HL_MM,	O_NEG,		O_RETN,		O_IM0,		O_RLD,		
O_IN_F_C,	O_OUT_C_Z,	O_SBCHL_SP,	O_LD_MM_SP,	O_NEG,		O_RETN,		O_IM1,		O_NOP,		
O_IN_A_C,	O_OUT_C_A,	O_ADCHL_SP,	O_LD_SP_MM,	O_NEG,		O_RETN,		O_IM2,		O_NOP,		

O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		
O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		
O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		
O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		
O_LDI,		O_CPI,		O_INI,		O_OUTI,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		
O_LDD,		O_CPD,		O_IND,		O_OUTD,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		
O_LDIR,		O_CPIR,		O_INIR,		O_OTIR,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		
O_LDDR,		O_CPDR,		O_INDR,		O_OTDR,		O_NOP,		O_NOP,		O_NOP,		O_NOP,		
};

static const OpFuncPtr OpTableCB1[8] =
{
O_CB_B,		O_CB_C,		O_CB_D,		O_CB_E,		O_CB_H,		O_CB_L,		O_CB_M,		O_CB_A,		
};

// ---------------------------------------------------------------------------
//  prefix tߏ
// ---------------------------------------------------------------------------

static OPFUNC(CODE_DD)
{
	__asm { call ReaderFetch } 
	CLK(4, 1);
	__asm { jmp OpTableDD[ecx*4] }
}

static OPFUNC(CODE_FD)
{
	__asm { call ReaderFetch } 
	CLK(4, 1);
	__asm { jmp OpTableFD[ecx*4] }
}

static OPFUNC(CODE_ED)
{
	__asm { call ReaderFetch }
	__asm { sub ecx,40h } 
	__asm { cmp ecx,80h }
	__asm { jnb none }
	__asm { jmp OpTableED[ecx*4] }
none:
	CLK(8, 2);
	OPEND;
}

static OPFUNC(CODE_CB)
{
	__asm { call ReaderFetch } 
	__asm { mov edx,ecx }
	__asm { mov PQ,HL }
	__asm { shr edx,3 }
	__asm { and ecx,7 } 
	__asm { and edx,31 } 
	__asm { jmp OpTableCB1[ecx*4] }
}

static OPFUNC(CODE_DDCB)
{
	LEAIX;					// PQ <- IX+d 
	
	__asm { push ebp }
	__asm { mov ebp,edi } 
	__asm { call Reader } 
	__asm { inc edi }
	__asm { mov ecx,edx }
	__asm { pop ebp }
	
	__asm { shr edx,3 }
	__asm { and ecx,7 }
	__asm { and edx,31 }
	CLK(4, 2);
	__asm { jmp OpTableCB1[ecx*4] }
}

static OPFUNC(CODE_FDCB)
{
	LEAIY;					// PQ <- IY+d
	
	__asm { push ebp }
	__asm { mov ebp,edi }
	__asm { call Reader }
	__asm { inc edi }
	__asm { mov ecx,edx }
	__asm { pop ebp }
	
	__asm { shr edx,3 }
	__asm { and ecx,7 }
	__asm { and edx,31 }
	CLK(4, 2);
	__asm { jmp OpTableCB1[ecx*4] }
}

// ---------------------------------------------------------------------------
//   荞
// ---------------------------------------------------------------------------

static void _stdcall AcceptIntr(Z80_x86* z80, uint intno)
{
	z80->AcceptInterrupt(intno);
}


static OPFUNC(INTR)
{
	__asm { mov edx,INTREQ }				// 荞݂s邩ǂ𒲂ׂ
	__asm { mov cl,IFF1 }					// 荞ݏƊݗv
	__asm { and edx,INTMASK }
	__asm { add cl,255 }					// ecx = ecx ? -1 : 0
	__asm { sbb ebp,ebp }					// p.r.s
	__asm { and ebp,edx }
	__asm { jnz process_intr }
	__asm { ret }					// NC
process_intr:
	__asm { xor ebp,ebp }
	__asm { mov ecx,1 }
loop1:
	__asm { test ecx,edx }
	__asm { jnz found }
	__asm { inc ebp }
	__asm { add ecx,ecx }
	__asm { jnz loop1 }
	__asm { or edx,edx }
	__asm { ret }					// NC

found:
	// ebp = dest
	__asm { push eax }						// C++ Ƃ interface ͑...
	__asm { push edx }
	__asm { push ebp }						// 2nd arg: intno
	__asm { push esi }						// 1st arg: this
	__asm { call AcceptIntr }
	__asm { pop edx }
	__asm { pop eax }

	__asm { test HLTSTAT, 1 }
	__asm { jz nothalt }
	__asm { inc ePC }
nothalt:
	__asm { mov HLTSTAT, 0 }

	//
	__asm { xor edx,edx }
	__asm { add eax,1000000h }				// R++

	__asm { mov IFF1,dl }					// 荞݋tOZbg
	
	__asm { movzx ecx,INTMODE }
	__asm { test ecx,ecx }
	__asm { jz int0 }
	__asm { dec ecx }
	__asm { jz int1 }

// int2:
	__asm { movzx edx,I }
	__asm { shl edx,8 }
	__asm { add ebp,edx }
	READ16(UV);							// UV <- 荞ݐ
	MCALLUV;
	CLK(12, 4);							// xN^ǂݍ + push ? 
	__asm { stc }
	__asm { ret }

int1:
	MPUSH(PC);
	__asm { mov ePC, 38h }
	CLK(7, 2);								// push pc ?
	__asm { stc }
	__asm { ret }

int0:
	// ߏȂ
	CLK(4, 1);								// nop ?
	__asm { stc }
	__asm { ret }
}

// ---------------------------------------------------------------------------
// ߏp}N

#if !defined(DEBUG_F)	// optimized fetch process

#ifndef DEBUG_MONITOR
#define FETCHCODE(n)	__asm { mov ebp,edi } \
						__asm { and edi,0ffffh } \
						__asm { test [esi]z80_ptr.gvramselected,-1 } \
						__asm { jnz indirect_##n } \
						direct_##n: \
						__asm { mov edx,edi } \
						__asm { shr edi,8 } \
						__asm { mov ecx,[esi]z80_ptr.memwait[edi*4] } \
						__asm { and edx,0ffh } \
						__asm { sub ebx,ecx } \
						__asm { mov edi,[esi]z80_ptr.readaccess[edi*4] } \
						__asm { inc ebp } \
						__asm { movzx ecx,byte ptr [edi+edx] } \
						__asm { add eax,1000000h } \
						__asm { mov edi,ebp } \
						__asm { call OpTable[ecx*4] } \
						fetchend_##n:
#else

static void _stdcall DoMonitor(Z80_x86* x)
{
	x->Monitor();
}

#define FETCHCODE(n)	__asm { mov [esi]z80_ptr.reg.pc,edi } \
						__asm { mov [esi]z80_ptr.reg.r.w.af,eax } \
						__asm { push eax } \
						__asm { shr eax,24 } \
						__asm { mov [esi]z80_ptr.reg.rreg, al } \
						__asm { push ecx } \
						__asm { push edx } \
						__asm { push esi } \
						__asm { call DoMonitor } \
						__asm { pop edx } \
						__asm { pop ecx } \
						__asm { pop eax } \
						__asm { mov ebp,edi } \
						__asm { and edi,0ffffh } \
						__asm { test [esi]z80_ptr.gvramselected,-1 } \
						__asm { jnz indirect_##n } \
						direct_##n: \
						__asm { mov edx,edi } \
						__asm { shr edi,8 } \
						__asm { and edx,0ffh } \
						__asm { sub ebx,[esi]z80_ptr.memwait[edi*4] } \
						__asm { mov edi,[esi]z80_ptr.readaccess[edi*4] } \
						__asm { inc ebp } \
						__asm { movzx ecx,byte ptr [edi+edx] /**/} \
						__asm { add eax,1000000h } \
						__asm { mov edi,ebp } \
						__asm { call OpTable[ecx*4] } \
						fetchend_##n:
#endif

#define FETCHCODE_S		__asm { mov edx,[esi]z80_ptr.readaccess[0] } \
						__asm { and edi,0ffffh } \
						__asm { movzx ecx,byte ptr [edi+edx] } \
						__asm { add eax,1000000h } \
						__asm { inc edi } \
						__asm { call OpTable[ecx*4] }

/*
#define FETCHCODE_S		__asm { mov ebp,edi } \
						__asm { and edi,0ffffh } \
						__asm { mov edx,edi } \
						__asm { shr edi,8 } \
						__asm { and edx,0ffh } \
						__asm { mov edi,[esi]z80_ptr.readaccess[edi*4] } \
						__asm { inc ebp } \
						__asm { movzx ecx,byte ptr [edi+edx] } \
						__asm { add eax,1000000h } \
						__asm { mov edi,ebp } \
						__asm { call OpTable[ecx*4] }
*/

#define FETCHSUB(n)		indirect_##n: \
						__asm { cmp edi,0c000h } \
						__asm { jb direct_##n } \
						__asm { add eax,1000000h } \
						__asm { mov ecx,[esi]z80_ptr.gvramwait } \
						__asm { sub ebx,ecx } \
						__asm { push eax } \
						__asm { mov eax,[esi] } \
						__asm { mov ecx,esi } /* ecx as this */ \
						__asm { push edi } \
						__asm { inc ebp } \
						__asm { call [eax] } \
						__asm { movzx ecx,al } \
						__asm { pop eax } \
						__asm { mov edi,ebp } \
						__asm { call OpTable[ecx*4] } \
						__asm { jmp fetchend_##n }
#else

#define FETCHCODE(n)	__asm { call ReaderFetch } \
						__asm { call OpTable[ecx*4] }


#define FETCHSUB(n)
#endif

// ---------------------------------------------------------------------------
//	ߏ
//	O: thiscall
//
void __declspec(naked) Z80_x86::Step(uint clocks)
{
	__asm { push ebp }
	__asm { mov ebp,esp }
	__asm { push esi }
	__asm { push ecx }
	__asm { mov esi,ecx }			// esi = this 
	__asm { mov ecx,CLKCNT }
	__asm { push ebx }
	__asm { mov ebx,clocks }
	__asm { lea ecx,[ecx+ebx*2] }
	__asm { add ebx,ebx }
	__asm { push edi }

#ifndef WORDREG_IN_INT
	__asm { xor eax,eax }
	__asm { mov al,R }
	__asm { shl eax,24 }
#endif

#ifdef WORDREG_IN_INT
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }
	__asm { mov edi,[esi]z80_ptr.reg.pc }
#else
	__asm { mov ax,[esi]z80_ptr.reg.r.w.af }
	__asm { mov di,[esi]z80_ptr.reg.pc }
#endif
	__asm { mov CLKCNT,ecx }

#ifdef DEBUG_F
	__asm { xchg ah,al }
	__asm { mov FLAGX,ah }
#endif
	FETCHCODE(0)
	__asm { call O_INTR }			// 荞ݕ]

OP_EXEC_2:
	FETCHCODE(1)
#ifndef DEBUG_F
	FETCHCODE(2)
	FETCHCODE(3)
	FETCHCODE(4)
#endif
	__asm { test ebx,ebx }
	__asm { jg OP_EXEC_2 }

#ifdef DEBUG_F
	__asm { mov cl,FLAGX }
	__asm { and ah,11010111b }
	__asm { and cl,00101000b }
	__asm { or  ah,cl }
	__asm { xchg ah,al }
#endif
#ifdef WORDREG_IN_INT
	__asm { mov [esi]z80_ptr.reg.pc,edi }
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax	} // AF
#else
	__asm { mov [esi]z80_ptr.reg.pc,di }
	__asm { mov [esi]z80_ptr.reg.r.w.af,ax } // AF
	__asm { shr eax,24 }
	__asm { mov R,al }
#endif
	
	__asm { pop edi }
	__asm { pop ebx }
	__asm { pop ecx }
	__asm { pop esi }
	__asm { pop ebp }
	__asm { ret 4*1 }

	FETCHSUB(0);
	FETCHSUB(1);
#ifndef DEBUG_F
	FETCHSUB(2);
	FETCHSUB(3);
	FETCHSUB(4);
#endif
}

// ---------------------------------------------------------------------------
//	ߏ
//	O: thiscall
//
#if !defined(DEBUG_F) && defined(WORDREG_IN_INT)	// optimized fetch process

// 7 pushes

#define	STEPDUAL_PROLOG \
	__asm { push ebp } \
	__asm { mov ebp,esp } \
	__asm { push esi } \
	__asm { mov esi,ecx } \
	__asm { push ecx } \
	__asm { mov edx,secondary } \
	__asm { push ebx } \
	__asm { mov ebx,clocks } \
	__asm { mov ecx,CLKCNT } \
	__asm { add ebx,ebx } \
	__asm { push edi } \
	__asm { mov eax,[edx]z80_ptr.reg.r.w.af } \
	__asm { add ecx,ebx } \
	__asm { push esi } \
	__asm { mov edi,[edx]z80_ptr.reg.pc } \
	__asm { push edx } \
	__asm { mov esi,edx } \
	__asm { mov CLKCNT,ecx } \
	__asm { call O_INTR } \
	__asm { mov [esi]z80_ptr.reg.r.w.af, eax } \
	__asm { mov [esi]z80_ptr.reg.pc, edi } \
	__asm { mov esi,[esp][4] } \
	__asm { mov edi,[esi]z80_ptr.reg.pc } \
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }

#define STEPDUAL_EPILOG \
	__asm { pop edi } \
	__asm { pop ebx } \
	__asm { pop ecx } \
	__asm { pop esi } \
	__asm { pop ebp }



// ---------------------------------------------------------------------------
//	2 CPU 쓮
//	NbNP ؂ւ
// ---------------------------------------------------------------------------

#if 0
void __declspec(naked) Z80_x86::StepDualP(uint clocks, Z80_x86* secondary, int main, int sub)
{
	STEPDUAL_PROLOG
	FETCHCODE(0)
	__asm { xor edx,edx }
	__asm { push edx }
	__asm { push ebx }
	__asm { call O_INTR }
	__asm { mov ebx,[esp][4*12] }		// main
//	__asm { jmp OP_EXEC_2 }

OP_EXEC_2:
	FETCHCODE(1)
	__asm { test ebx,ebx }
	__asm { jg OP_EXEC_2 }
	
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { mov [esi]z80_ptr.reg.pc,edi }
	
	__asm { mov edx,[esp][4*1] }
	__asm { mov [esp][4*1],ebx }
	
	__asm { mov ebx,[esp][4*13] }		// sub
	__asm { add ebx,edx }

	__asm { mov esi,[esp][4*2] }
	__asm { mov edi,[esi]z80_ptr.reg.pc }
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }

OP_EXEC_3:
	FETCHCODE_S
	__asm { test ebx,ebx }
	__asm { jg OP_EXEC_3 }

	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { mov [esi]z80_ptr.reg.pc,edi }

	__asm { mov edx,[esp][4*1] }
	__asm { mov [esp][4*1],ebx }
	
	__asm { mov ebx,[esp][4*12] }
	__asm { mov ecx,[esp][4*0] }
	__asm { sub ecx,ebx }
	__asm { mov [esp][4*0],ecx }
	__asm { jng OP_EXEC_5 }
	
	__asm { add ebx,edx }
	
	__asm { mov al,HLTSTAT }
	__asm { test al,2 }
	__asm { mov esi,[esp][4*3] }
	
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }
	__asm { mov edi,[esi]z80_ptr.reg.pc }
	
	__asm { jz OP_EXEC_2 }
	
	__asm { pop ebx }

OP_EXEC_4:
	FETCHCODE(2)
	FETCHCODE(3)
	FETCHCODE(4)
	FETCHCODE(5)
	__asm { test ebx,ebx }
	__asm { mov ecx,[esp][4*1] }
	__asm { jng OP_EXEC_6 }
	__asm { test [ecx]z80_ptr.reg.haltstate, 2 }
	__asm { jnz OP_EXEC_4 }

	__asm { mov [esi]z80_ptr.reg.pc,edi }
	__asm { mov edi,[ecx]z80_ptr.reg.pc }
	__asm { push ebx }
	__asm { mov ebx,[esp][4*13] }		// sub
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { mov esi,ecx }
	__asm { mov eax,[ecx]z80_ptr.reg.r.w.af }
	
	__asm { jmp OP_EXEC_3 }

OP_EXEC_5:
	__asm { add esp,4*4 }
	__asm { jmp OP_EXEC_7 }
OP_EXEC_6:
	__asm { mov [esi]z80_ptr.reg.pc,edi }
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { add esp,4*3 }
OP_EXEC_7:
	STEPDUAL_EPILOG
	__asm { ret 4*4 }

	FETCHSUB(0)
	FETCHSUB(1)
	FETCHSUB(2)
	FETCHSUB(3)
	FETCHSUB(4)
	FETCHSUB(5)
}
#else
void __declspec(naked) Z80_x86::StepDualP(uint clocks, Z80_x86* secondary, int main, int sub)
{
	STEPDUAL_PROLOG
	FETCHCODE(0)
	__asm { push ebx }
	__asm { call O_INTR }
	__asm { mov ebx,[esp][4*11] }		// main
	__asm { jmp OP_EXEC_2 }

OP_EXEC_1:
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }
	__asm { mov edi,[esi]z80_ptr.reg.pc }

OP_EXEC_2:
	FETCHCODE(1)
	__asm { test ebx,ebx }
	__asm { jg OP_EXEC_2 }
	
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { mov ecx,[esp][4*12] }		// sub
	__asm { neg ebx }
	__asm { mov [esi]z80_ptr.reg.pc,edi }
	__asm { mov esi,[esp][4] }
	__asm { add ebx,ecx }
	__asm { mov edi,[esi]z80_ptr.reg.pc }
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }

OP_EXEC_3:
	FETCHCODE_S
	__asm { test ebx,ebx }
	__asm { jg OP_EXEC_3 }

	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { neg ebx }
	__asm { mov ecx,[esp][4*11] }
	__asm { mov [esi]z80_ptr.reg.pc,edi }
	__asm { mov edx,[esp] }
	__asm { add ebx,ecx }
	__asm { mov al,HLTSTAT }
	__asm { sub edx,ebx }
	__asm { mov [esp],edx }
	__asm { jng OP_EXEC_5 }
	
	__asm { test al,2 }
	__asm { mov esi,[esp][8] }
	__asm { jz OP_EXEC_1 }
	
	__asm { pop ebx }

	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }
	__asm { mov edi,[esi]z80_ptr.reg.pc }

OP_EXEC_4:
	FETCHCODE(2)
	FETCHCODE(3)
	FETCHCODE(4)
	FETCHCODE(5)
	__asm { test ebx,ebx }
	__asm { mov ecx,[esp] }
	__asm { jng OP_EXEC_6 }
	__asm { test [ecx]z80_ptr.reg.haltstate, 2 }
	__asm { jnz OP_EXEC_4 }

	__asm { mov [esi]z80_ptr.reg.pc,edi }
	__asm { mov edi,[ecx]z80_ptr.reg.pc }
	__asm { push ebx }
	__asm { mov ebx,[esp][4*12] }		// sub
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { mov esi,ecx }
	__asm { mov eax,[ecx]z80_ptr.reg.r.w.af }
	
	__asm { jmp OP_EXEC_3 }

OP_EXEC_5:
	__asm { add esp,12 }
	__asm { jmp OP_EXEC_7 }
OP_EXEC_6:
	__asm { mov [esi]z80_ptr.reg.pc,edi }
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { add esp,8 }
OP_EXEC_7:
	STEPDUAL_EPILOG
	__asm { ret 4*4 }

	FETCHSUB(0);
	FETCHSUB(1);
	FETCHSUB(2);
	FETCHSUB(3);
	FETCHSUB(4);
	FETCHSUB(5);
}
#endif



// ---------------------------------------------------------------------------
//	2 CPU 쓮
//	8  : 4  ؂ւ
// ---------------------------------------------------------------------------

void __declspec(naked) Z80_x86::StepDual2(uint clocks, Z80_x86* secondary)
{
	STEPDUAL_PROLOG
	FETCHCODE(0)
	__asm { call O_INTR }
	__asm { jmp OP_EXEC_2 }

OP_EXEC_1:
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }
	__asm { mov edi,[esi]z80_ptr.reg.pc }
OP_EXEC_2:
	FETCHCODE(1) 
	FETCHCODE(2) 
	FETCHCODE(3) 
	FETCHCODE(4) 
	FETCHCODE(5) 
	FETCHCODE(6) 
	FETCHCODE(7) 
	FETCHCODE(8) 
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { mov [esi]z80_ptr.reg.pc,edi	}
	
	__asm { mov esi,[esp] }
	__asm { push ebx }
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }
	__asm { mov edi,[esi]z80_ptr.reg.pc }
	FETCHCODE_S 
	FETCHCODE_S 
	FETCHCODE_S 
	FETCHCODE_S 
	__asm { pop ebx }
	__asm { test ebx,ebx }
	__asm { mov [esi]z80_ptr.reg.pc,edi	}
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { mov esi,[esp][4] }

	__asm { jg OP_EXEC_1 }

	__asm { add esp,8 }
	STEPDUAL_EPILOG
	__asm { ret 4*2 }

	FETCHSUB(0)
	FETCHSUB(1)
	FETCHSUB(2)
	FETCHSUB(3)
	FETCHSUB(4)
	FETCHSUB(5)
	FETCHSUB(6)
	FETCHSUB(7)
	FETCHSUB(8)
}

// ---------------------------------------------------------------------------
//	2 CPU 쓮
//	4  : 4  ؂ւ
// ---------------------------------------------------------------------------

void __declspec(naked) Z80_x86::StepDual(uint clocks, Z80_x86* secondary)
{
	STEPDUAL_PROLOG
	FETCHCODE(0);
	__asm { call O_INTR }
	__asm { jmp OP_EXEC_2 }

OP_EXEC_1:
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }
	__asm { mov edi,[esi]z80_ptr.reg.pc }
OP_EXEC_2:
	FETCHCODE(1) 
	FETCHCODE(2) 
	FETCHCODE(3) 
	FETCHCODE(4) 
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { mov [esi]z80_ptr.reg.pc,edi }
	
	__asm { mov esi,[esp] }
	__asm { push ebx }
	__asm { mov eax,[esi]z80_ptr.reg.r.w.af }
	__asm { mov edi,[esi]z80_ptr.reg.pc }
	FETCHCODE_S 
	FETCHCODE_S 
	FETCHCODE_S 
	FETCHCODE_S 
	__asm { pop ebx }
	__asm { test ebx,ebx }
	__asm { mov [esi]z80_ptr.reg.pc,edi }
	__asm { mov [esi]z80_ptr.reg.r.w.af,eax }
	__asm { mov esi,[esp][4] }

	__asm { jg OP_EXEC_1 }

	__asm { add esp,8 }
	STEPDUAL_EPILOG
	__asm { ret 4*2 }

	FETCHSUB(0)
	FETCHSUB(1)
	FETCHSUB(2)
	FETCHSUB(3)
	FETCHSUB(4)
}


#endif

// ---------------------------------------------------------------------------
//	荞ݐ䖽 ---------------------------------------------------------

static OPFUNC(DI)
{
	CLK(4, 1);
	__asm { xor cl,cl }
	__asm { mov IFF1,cl }
	__asm { ret }
}

static OPFUNC(EI)
{
	CLK(4, 1)
#ifdef DEBUG_F
	__asm { MOVN(IFF1, 1) }				// 荞݋
	__asm { ret }
#else
	__asm { mov edx,0f7h }			// ReaderFetch  edx j
	__asm { call ReaderFetch }				// ̂P߂͎s
	__asm { and edx,ecx }					// A DI ܂ EI ߂ł
	__asm { cmp edx,0f3h }					// Ȃ
	__asm { jz dont_exec }
	__asm { call OpTable[ecx*4] }

	__asm { mov IFF1,1 }
	__asm { call O_INTR }					// 荞݃`FbN荞ݎs
	__asm { ret }

dont_exec:
	__asm { dec ePC }						// ǂ݂߂
	__asm { sub eax,1000000h }
	__asm { ret }
#endif
}

// ---------------------------------------------------------------------------
//	Zbg
//	bank - 荞ݔԍ
// ---------------------------------------------------------------------------

void Z80_x86::Reset(int rstat)
{
	memset(&reg, 0, sizeof(reg));

	intr_req = 0;
	wait = !!rstat;
	intr_mask = 0;
}

// ---------------------------------------------------------------------------
//	荞݂̗v
// ---------------------------------------------------------------------------

void Z80_x86::RequestInterrupt(uint intno)
{
	__asm { mov esi,this }
	__asm { mov ecx,intno }
	__asm { mov eax,1 }
	__asm { rol eax,cl }
	__asm { or [esi]z80_ptr.intr_req,eax }
}

// ---------------------------------------------------------------------------
//	荞݂̗v
// ---------------------------------------------------------------------------

void Z80_x86::CancelInterrupt(uint intno)
{
	__asm { mov esi,this }
	__asm { mov ecx,intno }
	__asm { mov eax,not 1 }
	__asm { rol eax,cl }
	__asm { and [esi]z80_ptr.intr_req,eax }
}



// ---------------------------------------------------------------------------
//	j^[
// ---------------------------------------------------------------------------

#ifdef DEBUG_MONITOR
static int fcount = 0;
static FILE* fpmon = 0;
static bool monitor = false;
#endif

void Z80_x86::StartMonitor()
{
#ifdef DEBUG_MONITOR
	if (fcount == 0 && !fpmon)
	{
		fpmon = fopen("z80.log", "w");
		fcount++;
	}
	monitor = true;
#endif
}

void Z80_x86::StopMonitor()
{
#ifdef DEBUG_MONITOR
	monitor = false;
	if (fpmon)
	{
		fclose(fpmon);
		fpmon = 0;
		fcount --;
	}
#endif
}

#ifdef DEBUG_MONITOR

#define Read16(a) (Read(a)+Read(a+1)*256)

void Z80_x86::Monitor()
{
	char f1[6], f2[6], buf[20], p1[5], p2[5];
	static int id = 0;
	uint8 f;
	if (fpmon)
	{
		f = reg.r.w.af >> 8;
		f1[0] = (f & 0x80) ? 'S' : '-'; f1[1] = (f & 0x40) ? 'Z' : '-';
		f1[2] = (f & 0x10) ? 'H' : '-';	f1[3] = (f & 0x04) ? 'P' : '-';
		f1[4] = (f & 0x02) ? 'N' : '-';	f1[5] = (f & 0x01) ? 'C' : '-';
		
		f = (uint8) (reg.r_af >> 8);
		f2[0] = (f & 0x80) ? 'S' : '-';	f2[1] = (f & 0x40) ? 'Z' : '-';
		f2[2] = (f & 0x10) ? 'H' : '-';	f2[3] = (f & 0x04) ? 'P' : '-';
		f2[4] = (f & 0x02) ? 'N' : '-';	f2[5] = (f & 0x01) ? 'C' : '-';

		Disassemble(buf);
	
		p1[0] = (intr_req & 0x0001 ? 'U' : '-');
		p1[1] = (intr_req & 0x0004 ? 'V' : '-');
		p1[2] = (intr_req & 0x0010 ? 'T' : '-');
		p1[3] = (intr_req & 0x0040 ? '4' : '-');
		p1[4] = (intr_req & 0x0100 ? 'S' : '-');
		p2[0] = (intr_mask & 0x0001 ? 'U' : '-');
		p2[1] = (intr_mask & 0x0004 ? 'V' : '-');
		p2[2] = (intr_mask & 0x0010 ? 'T' : '-');
		p2[3] = (intr_mask & 0x0040 ? '4' : '-');
		p2[4] = (intr_mask & 0x0100 ? 'S' : '-');


		fprintf(fpmon,
				"PC:%.4x %-20.20s  "
				"A:%.2x %.6s H:%.4x D:%.4x B:%.4x "
				"X:%.4x Y:%.4x R:%.2x SP:%.4x(%.4x %.4x %.4x) P:%.5s M:%.5s"
				"\n",
				reg.pc, buf, 
				reg.r.w.af & 0xff, f1, reg.r.w.hl & 0xffff, reg.r.w.de & 0xffff, reg.r.w.bc & 0xffff,
				reg.r.w.ix & 0xffff, reg.r.w.iy & 0xffff,  (reg.rreg & 0x7f) + (reg.rreg7 & 0x80), 
				reg.r.w.sp & 0xffff,
				Read(reg.r.w.sp  )+Read(reg.r.w.sp+1)*256,
				Read(reg.r.w.sp+2)+Read(reg.r.w.sp+3)*256,
				Read(reg.r.w.sp+4)+Read(reg.r.w.sp+5)*256,
				p1, p2
				);
	}
}

typedef struct
{
	const char* text;
	int flag;
} MneTable;

static const MneTable mnetable[0x100] =
{
{"NOP",			0},	{"LD   BC,%s",	2}, {"LD   (BC),A",	0}, {"INC  BC",		0},
{"INC  B",		0}, {"DEC  B",		0}, {"LD   B,%s",   1}, {"RLCA",        0},
{"EX   AF,AF'", 0},	{"ADD  HL,BC",	0}, {"LD   A,(BC)",	0}, {"DEC  BC",		0},
{"INC  C",		0}, {"DEC  C",		0}, {"LD   C,%s",   1}, {"RRCA",        0},
{"DJNZ %s",		3},	{"LD   DE,%s",	2}, {"LD   (DE),A",	0}, {"INC  DE",		0},
{"INC  D",		0}, {"DEC  D",		0},	{"LD   D,%s",   1}, {"RLA",         0},
{"JR   %s",     3},	{"ADD  HL,DE",	0},	{"LD   A,(DE)",	0}, {"DEC  DE",		0},
{"INC  E",		0}, {"DEC  E",		0},	{"LD   E,%s",   1}, {"RRA",			0},
{"JR   NZ,%s",	3},	{"LD   HL,%s",	2},	{"LD   (%s),HL",2}, {"INC  HL",		0},
{"INC  H",		0}, {"DEC  H",		0},	{"LD   H,%s",   1}, {"DAA",         0},
{"JR   Z,%s",   3},	{"ADD  HL,HL",	0},	{"LD   HL,(%s)",2}, {"DEC  HL",		0},
{"INC  L",		0}, {"DEC  L",		0},	{"LD   L,%s",   1}, {"CPL",			0},
{"JR   NC,%s",	3},	{"LD   SP,%s",	2},	{"LD   (%s),A", 2}, {"INC  SP",		0},
{"INC  (HL)",	0}, {"DEC  (HL)",	0},	{"LD   (HL),%s",1}, {"SCF",         0},
{"JR   C,%s",   3},	{"ADD  HL,SP",	0}, {"LD   A,(%s)",	2}, {"DEC  SP",		0},
{"INC  A",		0}, {"DEC  A",		0}, {"LD   A,%s",   1}, {"CCF",			0},
{"LD   B,B",	0},	{"LD   B,C",	0},	{"LD   B,D",	0},	{"LD   B,E",	0},
{"LD   B,H",	0},	{"LD   B,L",	0},	{"LD   B,(HL)",	0},	{"LD   B,A",	0},
{"LD   C,B",	0},	{"LD   C,C",	0},	{"LD   C,D",	0},	{"LD   C,E",	0},
{"LD   C,H",	0},	{"LD   C,L",	0},	{"LD   C,(HL)",	0},	{"LD   C,A",	0},
{"LD   D,B",	0},	{"LD   D,C",	0},	{"LD   D,D",	0},	{"LD   D,E",	0},
{"LD   D,H",	0},	{"LD   D,L",	0},	{"LD   D,(HL)",	0},	{"LD   D,A",	0},
{"LD   E,B",	0},	{"LD   E,C",	0},	{"LD   E,D",	0},	{"LD   E,E",	0},
{"LD   E,H",	0},	{"LD   E,L",	0},	{"LD   E,(HL)",	0},	{"LD   E,A",	0},
{"LD   H,B",	0},	{"LD   H,C",	0},	{"LD   H,D",	0},	{"LD   H,E",	0},
{"LD   H,H",	0},	{"LD   H,L",	0},	{"LD   H,(HL)",	0},	{"LD   H,A",	0},
{"LD   L,B",	0},	{"LD   L,C",	0},	{"LD   L,D",	0},	{"LD   L,E",	0},
{"LD   L,H",	0},	{"LD   L,L",	0},	{"LD   L,(HL)",	0},	{"LD   L,A",	0},
{"LD   (HL),B",	0},	{"LD   (HL),C",	0},	{"LD   (HL),D",	0},	{"LD   (HL),E",	0},
{"LD   (HL),H",	0},	{"LD   (HL),L",	0},	{"HALT",	    0},	{"LD   (HL),A",	0},
{"LD   A,B",	0},	{"LD   A,C",	0},	{"LD   A,D",	0},	{"LD   A,E",	0},
{"LD   A,H",	0},	{"LD   A,L",	0},	{"LD   A,(HL)",	0},	{"LD   A,A",	0},
{"ADD  A,B",    0},	{"ADD  A,C",    0},	{"ADD  A,D",    0},	{"ADD  A,E",    0},
{"ADD  A,H",    0},	{"ADD  A,L",    0},	{"ADD  A,(HL)", 0},	{"ADD  A,A",    0},
{"ADC  A,B",    0},	{"ADC  A,C",    0},	{"ADC  A,D",    0},	{"ADC  A,E",    0},
{"ADC  A,H",    0},	{"ADC  A,L",    0},	{"ADC  A,(HL)", 0},	{"ADC  A,A",    0},
{"SUB  B",      0},	{"SUB  C",      0},	{"SUB  D",      0},	{"SUB  E",      0},
{"SUB  H",      0},	{"SUB  L",      0},	{"SUB  (HL)",   0},	{"SUB  A",      0},
{"SBC  A,B",    0},	{"SBC  A,C",    0},	{"SBC  A,D",    0},	{"SBC  A,E",    0},
{"SBC  A,H",    0},	{"SBC  A,L",    0},	{"SBC  A,(HL)", 0},	{"SBC  A,A",    0},
{"AND  B",      0},	{"AND  C",      0},	{"AND  D",      0},	{"AND  E",      0},
{"AND  H",      0},	{"AND  L",      0},	{"AND  (HL)",   0},	{"AND  A",      0},
{"XOR  B",      0},	{"XOR  C",      0},	{"XOR  D",      0},	{"XOR  E",      0},
{"XOR  H",      0},	{"XOR  L",      0},	{"XOR  (HL)",   0},	{"XOR  A",      0},
{"OR   B",      0},	{"OR   C",      0},	{"OR   D",      0},	{"OR   E",      0},
{"OR   H",      0},	{"OR   L",      0},	{"OR   (HL)",   0},	{"OR   A",      0},
{"CP   B",      0},	{"CP   C",      0},	{"CP   D",      0},	{"CP   E",      0},
{"CP   H",      0},	{"CP   L",      0},	{"CP   (HL)",   0},	{"CP   A",      0},
{"RET  NZ",     0},	{"POP  BC",     0},	{"JP   NZ,%s",  2}, {"JP   %s",     2},
{"CALL NZ,%s",  2}, {"PUSH BC",     0},	{"ADD  A,%s",   1},	{"RST  0",      0},
{"RET  Z",      0},	{"RET",         0},	{"JP   Z,%s",   2}, {"DB   0CBH,%s",1},
{"CALL Z,%s",   2}, {"CALL %s",     2},	{"ADC  A,%s",   1},	{"RST  8",      0},
{"RET  NC",     0},	{"POP  DE",     0},	{"JP   NC,%s",  2}, {"OUT  (%s),A", 1},
{"CALL NC,%s",  2}, {"PUSH DE",     0},	{"SUB  %s",     1},	{"RST  10H",    0},
{"RET  C",      0},	{"EXX",         0},	{"JP   C,%s",   2}, {"IN   A,(%s)", 1},
{"CALL C,%s",   2}, {NULL,          5},	{"SBC  A,%s",   1},	{"RST  18H",    0},
{"RET  PO",     0},	{"POP  HL",     0},	{"JP   PO,%s",  2}, {"EX   (SP),HL",0},
{"CALL PO,%s",  2}, {"PUSH HL",     0},	{"AND  %s",     1},	{"RST  20H",    0},
{"RET  PE",     0},	{"JP   (HL)",   0},	{"JP   PE,%s",  2}, {"EX   DE,HL",  0},
{"CALL PE,%s",  2}, {"DB   0EDH,%s",1},	{"XOR  %s",     1},	{"RST  28H",    0},
{"RET  P",      0},	{"POP  AF",     0},	{"JP   P,%s",   2}, {"DI",          0},
{"CALL P,%s",   2}, {"PUSH AF",     0},	{"OR   %s",     1},	{"RST  20H",    0},
{"RET  M",      0},	{"LD   SP,HL",  0},	{"JP   M,%s",   2}, {"EI",          0},
{"CALL M,%s",   2}, {NULL,          5},	{"CP   %s",     1},	{"RST  28H",    0},
};	

static const MneTable mnetablei[0x100] =
{
{"NOP",			0},	{"LD   BC,%s",	2}, {"LD   (BC),A",	0}, {"INC  BC",		0},	// 0
{"INC  B",		0}, {"DEC  B",		0}, {"LD   B,%s",   1}, {"RLCA",        0},
{"EX   AF,AF'", 0},	{"ADD  I%c,BC",	8}, {"LD   A,(BC)",	0}, {"DEC  BC",		0},
{"INC  C",		0}, {"DEC  C",		0}, {"LD   C,%s",   1}, {"RRCA",        0},
{"DJNZ %s",		3},	{"LD   DE,%s",	2}, {"LD   (DE),A",	0}, {"INC  DE",		0},	// 1
{"INC  D",		0}, {"DEC  D",		0},	{"LD   D,%s",   1}, {"RLA",         0},
{"JR   %s",     3},	{"ADD  I%c,DE",	8},	{"LD   A,(DE)",	0}, {"DEC  DE",		0},
{"INC  E",		0}, {"DEC  E",		0},	{"LD   E,%s",   1}, {"RRA",			0},
{"JR   NZ,%s",	3},	{"LD   I%c,%s",	10},{"LD   (%s),I%c",14},{"INC  I%c",	8},	// 2	!
{"INC  %cH",	8}, {"DEC  %cH",	8},	{"LD   %cH,%s", 9}, {"DAA",         0},
{"JR   Z,%s",   3},	{"ADD  I%c,I%c",13},{"LD   I%c,(%s)",10},{"DEC  I%c",	0},
{"INC  %cL",	8}, {"DEC  %cL",	8},	{"LD   %cL,%s", 9}, {"CPL",			0},
{"JR   NC,%s",	3},	{"LD   SP,%s",	2},	{"LD   (%s),A", 2}, {"INC  SP",		0},	// 3
{"INC  (%s)",  11}, {"DEC  (%s)",  11}, {"LD   (%s),%s",12},{"SCF",         0},
{"JR   C,%s",   3},	{"ADD  I%c,SP",	8}, {"LD   A,(%s)",	2}, {"DEC  SP",		0},
{"INC  A",		0}, {"DEC  A",		0}, {"LD   A,%s",   1}, {"CCF",			0},
{"LD   B,B",	0},	{"LD   B,C",	0},	{"LD   B,D",	0},	{"LD   B,E",	0},	// 4
{"LD   B,%cH",	8},	{"LD   B,%cL",	8},	{"LD   B,(%s)",	11},{"LD   B,A",	0},
{"LD   C,B",	0},	{"LD   C,C",	0},	{"LD   C,D",	0},	{"LD   C,E",	0},
{"LD   C,%cH",	8},	{"LD   C,%cL",	8},	{"LD   C,(%s)",	11},{"LD   C,A",	0},
{"LD   D,B",	0},	{"LD   D,C",	0},	{"LD   D,D",	0},	{"LD   D,E",	0},
{"LD   D,%cH",	8},	{"LD   D,%cL",	8},	{"LD   D,(%s)",	11},{"LD   D,A",	0},
{"LD   E,B",	0},	{"LD   E,C",	0},	{"LD   E,D",	0},	{"LD   E,E",	0},
{"LD   E,%cH",	8},	{"LD   E,%cL",	8},	{"LD   E,(%s)",	11},{"LD   E,A",	0},
{"LD   %cH,B",	8},	{"LD   %cH,C",	8},	{"LD   %cH,D",	8},	{"LD   %cH,E",	8},
{"LD   %cH,%cH",13},{"LD   %cH,%cL",13},{"LD   H,(%s)",	11},{"LD   %cH,A",	8},
{"LD   %cL,B",	8},	{"LD   %cL,C",	8},	{"LD   %cL,D",	8},	{"LD   %cL,E",	8},
{"LD   %cL,%cH",13},{"LD   %cL,%cL",13},{"LD   L,(%s)",	11},{"LD   %cL,A",	8},
{"LD   (%s),B",	11},{"LD   (%s),C",	11},{"LD   (%s),D",	11},{"LD   (%s),E",	11},
{"LD   (%s),H", 11},{"LD   (%s),L",	11},{"HALT",	    0},	{"LD   (%s),A",	11},
{"LD   A,B",	0},	{"LD   A,C",	0},	{"LD   A,D",	0},	{"LD   A,E",	0},
{"LD   A,%cH",	8},	{"LD   A,%cL",	8},	{"LD   A,(%s)",	11},{"LD   A,A",	0},
{"ADD  A,B",    0},	{"ADD  A,C",    0},	{"ADD  A,D",    0},	{"ADD  A,E",    0},
{"ADD  A,%cH",  8},	{"ADD  A,%cL",  8},	{"ADD  A,(%s)", 11},{"ADD  A,A",    0},
{"ADC  A,B",    0},	{"ADC  A,C",    0},	{"ADC  A,D",    0},	{"ADC  A,E",    0},
{"ADC  A,%cH",  8},	{"ADC  A,%cL",  8},	{"ADC  A,(%s)", 11},{"ADC  A,A",    0},
{"SUB  B",      0},	{"SUB  C",      0},	{"SUB  D",      0},	{"SUB  E",      0},
{"SUB  %cH",    8},	{"SUB  %cL",    8},	{"SUB  (%s)",   11},{"SUB  A",      0},
{"SBC  A,B",    0},	{"SBC  A,C",    0},	{"SBC  A,D",    0},	{"SBC  A,E",    0},
{"SBC  A,%cH",  8},	{"SBC  A,%cL",  8},	{"SBC  A,(%s)", 11},{"SBC  A,A",    0},
{"AND  B",      0},	{"AND  C",      0},	{"AND  D",      0},	{"AND  E",      0},
{"AND  %cH",    8},	{"AND  %cL",    8},	{"AND  (%s)",   11},{"AND  A",      0},
{"XOR  B",      0},	{"XOR  C",      0},	{"XOR  D",      0},	{"XOR  E",      0},
{"XOR  %cH",    8},	{"XOR  %cL",    8},	{"XOR  (%s)",   11},{"XOR  A",      0},
{"OR   B",      0},	{"OR   C",      0},	{"OR   D",      0},	{"OR   E",      0},
{"OR   %cH",    8},	{"OR   %cL",    8},	{"OR   (%s)",   11},{"OR   A",      0},
{"CP   B",      0},	{"CP   C",      0},	{"CP   D",      0},	{"CP   E",      0},
{"CP   %cH",    8},	{"CP   %cL",    8},	{"CP   (%s)",   11},{"CP   A",      0},
{"RET  NZ",     0},	{"POP  BC",     0},	{"JP   NZ,%s",  2}, {"JP   %s",     2},
{"CALL NZ,%s",  2}, {"PUSH BC",     0},	{"ADD  A,%s",   1},	{"RST  0",      0},
{"RET  Z",      0},	{"RET",         0},	{"JP   Z,%s",   2}, {"DB   0CBH,%s",1},
{"CALL Z,%s",   2}, {"CALL %s",     2},	{"ADC  A,%s",   1},	{"RST  8",      0},
{"RET  NC",     0},	{"POP  DE",     0},	{"JP   NC,%s",  2}, {"OUT  (%s),A", 1},
{"CALL NC,%s",  2}, {"PUSH DE",     0},	{"SUB  %s",     1},	{"RST  10H",    0},
{"RET  C",      0},	{"EXX",         0},	{"JP   C,%s",   2}, {"IN   A,(%s)", 1},
{"CALL C,%s",   2}, {"DB   0DDH",   0},	{"SBC  A,%s",   1},	{"RST  18H",    0},
{"RET  PO",     0},	{"POP  I%c",    8},	{"JP   PO,%s",  2}, {"EX   (SP),I%c",8},
{"CALL PO,%s",  2}, {"PUSH I%c",    8},	{"AND  %s",     1},	{"RST  20H",    0},
{"RET  PE",     0},	{"JP   (I%c)",  8},	{"JP   PE,%s",  2}, {"EX   DE,HL",  0},
{"CALL PE,%s",  2}, {"DB   0EDH,%s",1},	{"XOR  %s",     1},	{"RST  28H",    0},
{"RET  P",      0},	{"POP  AF",     0},	{"JP   P,%s",   2}, {"DI",          0},
{"CALL P,%s",   2}, {"PUSH AF",     0},	{"OR   %s",     1},	{"RST  20H",    0},
{"RET  M",      0},	{"LD   SP,I%c", 0},	{"JP   M,%s",   2}, {"EI",          0},
{"CALL M,%s",   2}, {"DB   0FDH",   0},	{"CP   %s",     1},	{"RST  28H",    0},
};	


//	 flag = 0		no arg				8:  XY  noarg
//	 flag = 1		arg is one byte		9:  XY	one byte
//	 flag = 2		arg is two bytes	10: XY  two bytes
//	 flag = 3		relative jump		11: XY  +d
//   flag = 4		dump 4 bytes		12: XY  +d one byte
//										13: XY  XY
//										14: two bytes	XY

void Z80_x86::Disassemble(char* buf)
{
	uint8 inst = Read(reg.pc);
	char temp[10];
	uint arg = 0;
	int8 index;
	char i;
	int flag = mnetable[inst].flag;
	switch (flag)
	{
	case 0:
		strcpy(buf, mnetable[inst].text);
		return;
	case 1:
		arg = Read(reg.pc+1);
		break;
	case 2:
		arg = Read16(reg.pc+1);
		break;
	case 3:
		arg = reg.pc + 2 + (int8) Read(reg.pc+1);
		break;
	case 4:
		sprintf(buf, "(%.2x %.2x %.2x %.2x)", 
			Read(reg.pc  ), Read(reg.pc+1),
			Read(reg.pc+2), Read(reg.pc+3) );
		return;
	case 5:
		i = inst == 0xdd ? 'X': 'Y';
		inst = Read(reg.pc + 1);
		flag = mnetablei[inst].flag;
		switch (flag)
		{
		case 0:
			strcpy(buf, mnetablei[inst].text);
			return;
		case 1: case 9:
			arg = Read(reg.pc+2);
			break;
		case 2: case 10: case 14:
			arg = Read16(reg.pc+2);
			break;
		case 3:
			arg = reg.pc + 3 + (int8) Read(reg.pc+2);
			break;
		case 4:
			sprintf(buf, "(%.2x %.2x %.2x %.2x)", 
				Read(reg.pc  ), Read(reg.pc+1),
				Read(reg.pc+2), Read(reg.pc+3) );
			return;
		case 8:
			sprintf(buf, mnetablei[inst].text, i);
			return;
		case 11:
			index = Read(reg.pc+2);
			sprintf(temp, "I%c%+d", i, index);
			sprintf(buf, mnetablei[inst].text, temp);
			return;
		case 12:
			{
				char temp2[12];
				index = Read(reg.pc+2);
				sprintf(temp, "I%c%+d", i, index);
				arg = Read(reg.pc+2);
				if (arg < 10)
				{
					sprintf(temp2, "%d", arg);
					sprintf(buf, mnetablei[inst].text, temp, temp2);
				}
				else
				{
					sprintf(temp2, "0%XH", arg);
					if (isdigit(temp2[1]))
						sprintf(buf, mnetablei[inst].text, temp, temp2+1);
					else
						sprintf(buf, mnetablei[inst].text, temp, temp2);
				}
			}
			return;
		}
		break;
	default:
		buf[0] = 0;
		return;
	}

	if (arg < 10)
	{
		sprintf(temp, "%d", arg);
		if (flag & 8)
			sprintf(buf, mnetablei[inst].text, i, temp);
		else
			sprintf(buf, mnetable[inst].text, temp);
	}
	else
	{
		sprintf(temp, "0%XH", arg);
		if (flag == 14)
		{
			if (isdigit(temp[1]))
				sprintf(buf, mnetablei[inst].text, temp+1, i);
			else
				sprintf(buf, mnetablei[inst].text, temp, i);
		}
		else
		if (flag & 8)
		{
			if (isdigit(temp[1]))
				sprintf(buf, mnetablei[inst].text, i, temp+1);
			else
				sprintf(buf, mnetablei[inst].text, i, temp);
		}
		else
		{
			if (isdigit(temp[1]))
				sprintf(buf, mnetable[inst].text, temp+1);
			else
				sprintf(buf, mnetable[inst].text, temp);
		}
	}
}

#endif	// DEBUG_MONITOR

