// ---------------------------------------------------------------------------
//	Z80 emulator for x86/VC5.
//	Copyright (C) cisc 1997, 1998.
// ---------------------------------------------------------------------------
//	$Id: Z80_x86.h,v 1.2 1999/01/11 15:32:19 cisc Exp $

#ifndef Z80_x86_h
#define Z80_x86_h

#include "Z80.h"

class Screen;

// ---------------------------------------------------------------------------

class Z80_x86
{
public:
	void Reset(int);							// Reset
	void NMI() {}								// NMI ()
	void RequestInterrupt(uint);				// INT v
	void CancelInterrupt(uint);				// INT vO
	void Step(uint clocks);
	void StepDual(uint clocks, Z80_x86* sec);
	void StepDual2(uint clocks, Z80_x86* sec);
	void StepDual3(uint clocks, Z80_x86* sec);
	void StepDualP(uint clocks, Z80_x86* sec, int main, int sub);

	void StartMonitor();
	void StopMonitor();
	void Monitor();
	uint32 GetClockCount() { return clockcount; }

	virtual uint8 Read(uint a) = 0;
	virtual void Write(uint a, uint d) = 0;
	virtual uint8 InPort(uint p) = 0;
	virtual void OutPort(uint p, uint d) = 0;

	virtual void AcceptInterrupt(uint intno) = 0;

protected:
	Z80Reg reg;
	bool gvramselected;					// for 88 emulation
	volatile bool wait;									

private:
	void Disassemble(char* buf);
	
	uint8 flagn;
	uint32 intr_mask;
	uint32 intr_req;
	uint count;
	uint32 clockcounter;
	uint32 clockcount;
	uint32 banklimit;
	uint   bankwait;

protected:
//	Screen* screen;						// for 88
	uint8* readaccess[256];				// for 88
	uint8* writeaccess[256];			// for 88
	uint memwait[256];
	uint memwait2[256];
	uint gvramwait;
	uint gvramwait2;

	void SetIMask(uint32 im) { intr_mask = im; }

	friend class Z80Test;
};

// ---------------------------------------------------------------------------

#endif // Z80_x86_h
