//	$Id: Z80_x86i.h,v 1.2 1999/01/11 15:32:19 cisc Exp $
// ---------------------------------------------------------------------------
//	OC^[tF[X
// ---------------------------------------------------------------------------
//	pӂKv}N
//
//	}N			j󂵂Ă悢WX^	@\
//	READ8(reg)			edx						*bp -> reg
//	READ16(reg)			edx	ebp					*bp -> reg16
//	WRITE8(reg)			edx	ebp					reg -> *ebp
//	WRITE16(reg)		edx	ebp					reg16 -> *ebp
//	FETCH(reg)			edx	ebp					*di -> reg, di++
//	FETCH16(reg)		edx	ebp					*di -> reg16, di+=2
//	FETCHUV				edx ebp					*di -> UV(ecx), di+=2
//
//	INP(reg, port)		edx						reg = InPort(port)
//	OUTP(port, reg)		edx						OutPort(port, reg)


#ifdef DEBUG_F

static void __declspec(naked) Reader()
{
	__asm { and ebp,0ffffh }
	__asm { push eax }
	__asm { push ebx }
	__asm { push edi }
	__asm { push ecx }
	__asm { mov ecx,esi }
	__asm { mov eax,[esi] }
	__asm { push ebp }
	__asm { call [eax] }
	__asm { mov dl,al }
	__asm { pop ecx }
	__asm { pop edi }
	__asm { pop ebx }
	__asm { pop eax }
	__asm { ret }
}

//	T = *PC++
 
static void __declspec(naked) ReaderFetch()
{
	__asm {	mov ebp,edi }
	__asm { and edi,0ffffh } 
	__asm {	push edx } 
	__asm {	push eax } 
	__asm {	push ebx } 
	__asm {	mov eax,[esi] } 
	__asm {	mov ecx,esi } 
	__asm {	push edi } 
	__asm {	inc ebp } 
	__asm {	call [eax] } 
	__asm {	pop ebx } 
	__asm {	movzx ecx,al } 
	__asm {	pop eax } 
	__asm {	mov edi,ebp } 
	__asm {	pop edx } 
	__asm {	add eax,1000000h } 
	__asm {	ret }
}

// *PQ <- T

static void __declspec(naked) Writer()
{
	__asm {	and ebp,0ffffh } 
	__asm {	push eax } 
	__asm {	push ecx } 
	__asm {	push ebx } 
	__asm {	mov ecx,esi } 
	__asm {	mov eax,[esi] } 
	__asm {	push edx } 
	__asm {	push ebp } 
	__asm {	call [eax+4] } 
	__asm {	pop ebx } 
	__asm {	pop ecx } 
	__asm {	pop eax } 
	__asm {	ret }
}

// ST = *PQ

static void __declspec(naked) Reader16()
{
	__asm { push ebx } 
	__asm {	push ecx } 
	__asm {	and ebp,0ffffh } 
	__asm {	push eax } 
	__asm {	mov eax,[esi] } 
	__asm {	mov ecx,esi } 
	__asm {	push ebp } 
	__asm {	inc ebp } 
	__asm {	call [eax] } 
	__asm {	push eax }
	__asm { push ebp } 
	__asm {	mov eax,[esi] } 
	__asm {	mov ecx,esi } 
	__asm {	call [eax] } 
	__asm {	pop edx } 
	__asm {	mov dh,al } 
	__asm {	pop eax } 
	__asm {	pop ecx } 
	__asm {	pop ebx } 
	__asm {	ret } 
}

// *PQ <- ST

static void __declspec(naked) Writer16()
{
	__asm {	and ebp,0ffffh } 
	__asm {	push eax } 
	__asm {	push ecx } 
	__asm {	push ebx } 
	__asm {	mov ecx,edx } 
	__asm {	shr edx,8 }
	__asm {	mov eax,[esi] } 
	__asm {	push edx } 
	__asm {	push ecx } 
	__asm {	mov ecx,esi } 
	__asm {	push ebp } 
	__asm {	inc ebp } 
	__asm {	call [eax+4] } 
	__asm {	mov eax,[esi] } 
	__asm {	mov ecx,esi } 
	__asm {	push ebp } 
	__asm {	call [eax+4] } 
	__asm {	pop ebx } 
	__asm {	pop ecx } 
	__asm {	pop eax } 
	__asm {	ret } 
}

#else

//  T = *PQ

static void __declspec(naked) Reader()
{
	__asm {	and ebp,0ffffh } 
	__asm {	test [esi]z80_ptr.gvramselected,-1 } 
	__asm {	jnz indirect } 
	direct:
	__asm {	push ebp } 
	__asm {	mov edx,ebp } 
	__asm {	shr ebp,8 } 
	__asm { sub ebx,[esi]z80_ptr.memwait[ebp*4] }
	__asm {	and edx,0ffh } 
	__asm {	mov ebp,[esi]z80_ptr.readaccess[ebp*4] }
	__asm {	mov dl,[ebp+edx] } 
	__asm {	pop ebp } 
	__asm {	ret } 
	indirect:
	__asm {	cmp ebp,0c000h } 
	__asm {	jc  direct } 
	__asm {	push eax } 
	__asm { mov eax,[esi]z80_ptr.gvramwait }
	__asm {	push edi } 
	__asm { sub ebx,eax }
	__asm {	push ecx } 
	__asm {	mov ecx,esi } 
	__asm {	push ebx } 
	__asm {	mov eax,[esi] } 
	__asm {	push ebp } 
	__asm {	call [eax] } 
	__asm {	pop ebx } 
	__asm {	mov dl,al } 
	__asm {	pop ecx } 
	__asm {	pop edi } 
	__asm {	pop eax } 
	__asm {	ret }
}

//	T = *PC++
 
static void __declspec(naked) ReaderFetch()
{
	__asm {	mov ebp,edi }
	__asm {	and edi,0ffffh } 
	__asm {	cmp [esi]z80_ptr.gvramselected,0 } 
	__asm {	jnz indirect } 
	direct:
	__asm {	mov ecx,edi } 
	__asm {	shr edi,8 } 
	__asm {	and ecx,0ffh } 
	__asm { sub ebx,[esi]z80_ptr.memwait[edi*4] }
	__asm {	mov edi,[esi]z80_ptr.readaccess[edi*4] } 
	__asm {	inc ebp } 
	__asm {	movzx ecx,byte ptr [edi+ecx] } 
	__asm {	add eax,1000000h } 
	__asm {	mov edi,ebp } 
	__asm {	ret } 
	indirect:
	__asm {	cmp edi,0c000h } 
	__asm {	jc  direct } 
	__asm {	push edx } 
	__asm { mov edx,[esi]z80_ptr.gvramwait }
	__asm {	push eax } 
	__asm { sub ebx,edx }
	__asm {	mov eax,[esi] } 
	__asm {	push ebx } 
	__asm {	mov ecx,esi } 
	__asm {	push edi } 
	__asm {	inc ebp } 
	__asm {	call [eax] } 
	__asm {	pop ebx } 
	__asm {	movzx ecx,al } 
	__asm {	pop eax } 
	__asm {	mov edi,ebp } 
	__asm {	pop edx } 
	__asm {	add eax,1000000h } 
	__asm {	ret } 
}

// *PQ <- T

static void __declspec(naked) Writer()
{
	__asm {	and ebp,0ffffh } 
	__asm {	cmp [esi]z80_ptr.gvramselected,0 } 
	__asm {	jz direct } 
	__asm {	cmp ebp,0c000h } 
	__asm {	jc  direct } 
	__asm {	push eax } 
	__asm { mov eax,[esi]z80_ptr.gvramwait }
	__asm {	push ecx } 
	__asm { sub ebx,eax }
	__asm {	mov ecx,esi } 
	__asm {	push ebx } 
	__asm {	mov eax,[esi] } 
	__asm {	push edx } 
	__asm {	push ebp } 
	__asm {	call [eax+4] } 
	__asm {	pop ebx } 
	__asm {	pop ecx } 
	__asm {	pop eax } 
	__asm {	ret } 
	direct:
	__asm {	push eax } 
	__asm {	mov al,dl } 
	__asm {	mov edx,ebp } 
	__asm {	shr ebp,8 } 
	__asm {	and edx,0ffh } 
	__asm { sub ebx,[esi]z80_ptr.memwait[ebp*4] }
	__asm {	mov ebp,[esi]z80_ptr.writeaccess[ebp*4] } 
	__asm {	mov [ebp+edx],al } 
	__asm {	pop eax } 
	__asm {	ret } 
}

// ST = *PQ
//  FFFF  BFFF

static void __declspec(naked) Reader16()
{
	__asm {	push ecx } 
	__asm {	and ebp,0ffffh } 
	__asm {	cmp [esi]z80_ptr.gvramselected,0 } 
	__asm {	jz direct } 
	__asm {	cmp ebp,0bfffh } 
	__asm {	jc  direct }
	__asm {	push eax } 
	__asm { mov eax,[esi]z80_ptr.gvramwait2 }
	__asm { sub ebx,eax }
	__asm {	push ebx } 
	__asm {	mov eax,[esi] } 
	__asm {	mov ecx,esi } 
	__asm {	push ebp } 
	__asm {	inc ebp } 
	__asm {	call [eax] } 
	__asm {	push eax }
	__asm { push ebp } 
	__asm {	mov eax,[esi] } 
	__asm {	mov ecx,esi } 
	__asm {	call [eax] } 
	__asm {	pop edx } 
	__asm {	mov dh,al } 
	__asm {	pop ebx } 
	__asm {	pop eax } 
	__asm {	pop ecx } 
	__asm {	ret } 
	direct:
	__asm {	mov edx,ebp } 
	__asm {	and edx,0ffh } 
	__asm {	shr ebp,8 } 
	__asm { sub ebx,[esi]z80_ptr.memwait2[ebp*4] }
	__asm {	cmp edx,0ffh } 
	__asm {	mov ecx,[esi]z80_ptr.readaccess[ebp*4] } 
	__asm {	jnb directmb } 
	__asm {	movzx edx,word ptr [ecx+edx] } 
	__asm {	pop ecx } 
	__asm {	ret } 
	directmb:
	__asm {	inc ebp } 
	__asm {	mov dl,[ecx+edx] } 
	__asm {	and ebp,0ffh } 
	__asm {	mov ecx,[esi]z80_ptr.readaccess[ebp*4] } 
	__asm {	mov dh,[ecx] }
	__asm { pop ecx } 
	__asm {	ret }
}

// *PQ <- ST

static void __declspec(naked) Writer16()
{
	__asm {	and ebp,0ffffh } 
	__asm {	cmp [esi]z80_ptr.gvramselected,0 } 
	__asm {	jz direct } 
	__asm { cmp ebp,0bfffh } 
	__asm {	jc  direct } 
	__asm {	push ecx } 
	__asm { mov ecx,[esi]z80_ptr.gvramwait }
	__asm { sub ebx,ecx }
	__asm {	push eax } 
	__asm {	mov ecx,edx } 
	__asm {	shr edx,8 }
	__asm { push ebx } 
	__asm {	mov eax,[esi] } 
	__asm {	push edx } 
	__asm {	push ecx } 
	__asm {	mov ecx,esi } 
	__asm {	push ebp } 
	__asm {	inc ebp } 
	__asm {	call [eax+4] } 
	__asm {	mov eax,[esi] } 
	__asm {	mov ecx,esi } 
	__asm { push ebp } 
	__asm {	call [eax+4] } 
	__asm {	pop ebx } 
	__asm {	pop eax } 
	__asm {	pop ecx } 
	__asm {	ret } 
	direct:
	__asm { push ecx } 
	__asm {	mov ecx,ebp } 
	__asm {	and ecx,0ffh } 
	__asm {	shr ebp,8 } 
	__asm { sub ebx,[esi]z80_ptr.memwait2[ebp*4] }
	__asm {	cmp ecx,0ffh } 
	__asm {	jnb directmb } 
	__asm {	add ecx,[esi]z80_ptr.writeaccess[ebp*4] } 
	__asm {	mov [ecx],dx } 
	__asm {	pop ecx } 
	__asm {	ret } 
	directmb:
	__asm {	add ecx,[esi]z80_ptr.writeaccess[ebp*4] } 
	__asm {	inc ebp } 
	__asm {	mov [ecx],dl } 
	__asm {	and ebp,0ffh } 
	__asm {	mov ecx,[esi]z80_ptr.writeaccess[ebp*4] } 
	__asm {	mov [ecx],dh } 
	__asm {	pop ecx } 
	__asm {	ret }
}

#endif

#define READ8(reg)			__asm { call Reader } \
							__asm { mov reg,dl }

#define WRITE8(reg)			__asm { mov dl,reg } \
							__asm { call Writer }

#define FETCH(reg)			__asm { mov ebp,edi } \
							__asm { call Reader } \
							__asm { mov reg,dl } \
							__asm { inc edi }

#define FETCHSX(reg)		__asm { mov ebp,edi } \
							__asm { call Reader } \
							__asm { movsx reg,dl } \
							__asm { inc edi }

#define READPCSX(reg)		__asm { mov ebp,edi } \
							__asm { call Reader } \
							__asm { movsx reg,dl }



#ifdef WORDREG_IN_INT
	#define FETCH16(reg)		__asm { mov ebp,edi } \
								__asm { add edi,2 } \
								__asm { call Reader16 } \
								__asm { mov reg,edx }

	#define READ16(reg)			__asm { call Reader16 } \
								__asm { mov reg,edx }

	#define WRITE16(reg)		__asm { mov edx,reg } \
								__asm { call Writer16 }

	#define MPOP(reg)			__asm { mov ebp,SP } \
								__asm { lea edx,[ebp+2] } \
								__asm { mov SP, edx } \
								__asm { call Reader16 } \
								__asm { mov reg,edx }

#else
	#define FETCH16(reg)		__asm { mov ebp,edi } \
								__asm { add edi,2 } \
								__asm { call Reader16 } \
								__asm { mov reg,dx }

	#define READ16(reg)			__asm { call Reader16 } \
								__asm { mov reg,dx }

	#define WRITE16(reg)		__asm { mov dx,reg } \
								__asm { call Writer16 }

	#define MPOP(reg)			__asm { movzx ebp,SP } \
								__asm { lea edx,[ebp+2] } \
								__asm { mov SP,dx } \
								__asm { call Reader16 } \
								__asm { mov reg,dx }

#endif

static uint8  _stdcall Z80_In   (Z80_x86* z, uint port)
{
	return z->InPort(port);
}

static void   _stdcall Z80_Out  (Z80_x86* z, uint data, uint port)
{
	z->OutPort(port, data);
}

// (port) -> reg (!= A)  uses S, T
#ifdef WORDREG_IN_INT
#define	INP(reg, port)		__asm { xor edx,edx } \
							__asm { push eax } \
							__asm { mov edx,port } \
							__asm { push ebx } \
							__asm { push ecx } \
							__asm { and edx,0ffh } \
							__asm { push edx } \
							__asm { push esi } \
							__asm { call Z80_In } \
							__asm { pop ecx } \
							__asm { pop ebx } \
							__asm { mov reg,al } \
							__asm { pop eax }

#define OUTP(port, reg)		__asm { xor edx,edx } \
							__asm { push eax } \
							__asm { mov edx,CLKCNT } \
							__asm { push ebx } \
							__asm { sub edx,ebx } \
							__asm { push ecx } \
							__asm { mov ebx,port } \
							__asm { mov [esi]z80_ptr.clockcount,edx } \
							__asm { and ebx,0ffh } \
							__asm { push ebx } \
							__asm { movzx edx,reg } \
							__asm { push edx } \
							__asm { push esi } \
							__asm { call Z80_Out } \
							__asm { pop ecx } \
							__asm { pop ebx } \
							__asm { pop eax }
#else
#define	INP(reg, port)		__asm { xor edx,edx } \
							__asm { push eax } \
							__asm { mov dx,port } \
							__asm { push ebx } \
							__asm { push ecx } \
							__asm { and edx,0ffh } \
							__asm { push edx } \
							__asm { push esi } \
							__asm { call Z80_In } \
							__asm { pop ecx } \
							__asm { pop ebx } \
							__asm { mov reg,al } \
							__asm { pop eax }

#define OUTP(port, reg)		__asm { mov edx,CLKCNT } \
							__asm { push eax } \
							__asm { sub edx,ebx } \
							__asm { push ecx } \
							__asm { push ebx } \
							__asm { movzx ebx,port } \
							__asm { mov [esi]z80_ptr.clockcount,edx } \
							__asm { and ebx,0ffh } \
							__asm { movzx edx,reg } \
							__asm { push ebx } \
							__asm { push edx } \
							__asm { push esi } \
							__asm { call Z80_Out } \
							__asm { pop ebx } \
							__asm { pop ecx } \
							__asm { pop eax }
#endif


//#define READ16(rh,rl)			READ8(rl);  INC16(ePQ); READ8(rh);
//#define WRITE16(rh,rl)		WRITE8(rl); INC16(ePQ); WRITE8(rh);

//#define FETCH(reg)			MOV16(ePQ, ePC); READ8(reg); INC16(ePC);
//#define FETCH16(rh,rl)		MOV16(ePQ, ePC); READ16(rh,rl); ADD16N(ePC,2);

