// ---------------------------------------------------------------------------
//  PC88 emulator for windows
//	User Interface
//	Copyright (C) cisc 1997.
// ---------------------------------------------------------------------------
//	$Id: ui.h,v 1.2 1999/01/11 15:32:20 cisc Exp $

#ifndef m88_ui_h
#define m88_ui_h

#include "InstanceThunk.h"
#include "M88About.h"
#include "M88Config2.h"

// ---------------------------------------------------------------------------

class M88UI
{
public:
	M88UI(HINSTANCE hinst);
	~M88UI();
	
	bool InitWindow(int nwinmode);
	int  Main();

private:
	struct DiskInfo
	{
		HMENU hmenu;
		int ndisks;
		int currentdisk;
		int idchgdisk;
	};
	typedef BOOL (WINAPI* PENABLEIME)(HWND, BOOL);

private:
	bool InitM88();
	void CleanupM88();
	static LRESULT _stdcall WinProcGate(M88UI*, HWND, UINT, WPARAM, LPARAM);
	void Call();
	void LoadConfig(char* = 0);
	void SaveConfig(char* = 0);
	void ApplyConfig();
	void Reset88(PC88::BASICMODE);
	void GetDLLAddress();
	bool EnableIME(HWND hwnd, BOOL flag);

	bool OpenDiskImage(int drive, char* filename, char* title, bool readonly);
	bool CreateDiskMenu(int dr);
	void ChangeDiskImage(HWND hwnd, int drive, UINT item);
	bool SelectDisk(int drive, int id);

	void ChangeDisplayType(bool savepos = true);
	void ToggleDisplayMode();
	void ResizeWindow();
	
	InstanceThunk winproc;
	HWND hwnd;
	HINSTANCE hinst;
	HACCEL accel;
	UINT timerid;
	PENABLEIME penableime;

	DiskInfo diskinfo[2];

	Config config;
	bool background;
	bool fullscreen;
	bool report;
	bool haspalette;
	volatile bool active;
	uint displaychangedat;
	int resizewindow;

	WinScreen* screen;
	WinKeyIF keyif;
	Win88* pc;
	WinSound* sound;

	DWORD wstyle;
	POINT point;
	PC88::ROM rom;

	M88Config2 m88config;

private:
	void CaptureScreen();
	uint M88ChangeVolume(HWND, WPARAM, LPARAM);
	uint M88ApplyConfig(HWND, WPARAM, LPARAM);
	uint M88ChangeDisplay(HWND, WPARAM, LPARAM);
	uint M88DisplayChanged(HWND, WPARAM, LPARAM);
	uint WmDisplayChange(HWND, WPARAM, LPARAM);
	uint WmExitMenuLoop(HWND, WPARAM, LPARAM);
	uint WmEnterMenuLoop(HWND, WPARAM, LPARAM);
	uint M88SendKeyState(HWND, WPARAM, LPARAM);
	uint WmKeyDown(HWND, WPARAM, LPARAM);
	uint WmKeyUp(HWND, WPARAM, LPARAM);
	uint WmSysKeyDown(HWND, WPARAM, LPARAM);
	uint WmSysKeyUp(HWND, WPARAM, LPARAM);
	uint WmInitMenu(HWND, WPARAM, LPARAM);
	uint WmQueryNewPalette(HWND, WPARAM, LPARAM);
	uint WmPaletteChanged(HWND, WPARAM, LPARAM);
	uint WmActivate(HWND, WPARAM, LPARAM);
	uint WmTimer(HWND, WPARAM, LPARAM);
	uint WmClose(HWND, WPARAM, LPARAM);
	uint WmCreate(HWND, WPARAM, LPARAM);
	uint WmDestroy(HWND, WPARAM, LPARAM);
	uint WmPaint(HWND, WPARAM, LPARAM);
	uint WmCommand(HWND, WPARAM, LPARAM);
	LRESULT WinProc(HWND, UINT, WPARAM, LPARAM);
};

#endif
